------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with Ada.Strings.Unbounded.Text_IO; use Ada.Strings.Unbounded.Text_IO;

with Text_IO; use Text_IO;

with primitive_xml_strings; use primitive_xml_strings;

package body Address_Spaces is

   -- --------= Address_Space =--------

   procedure Initialize (obj : in out Address_Space) is
   begin
      Initialize (Generic_Object (obj));
      obj.Cpu_Name          := Empty_String;
      obj.Text_Memory_Size  := 0;
      obj.Stack_Memory_Size := 0;
      obj.Data_Memory_Size  := 0;
      obj.Heap_Memory_Size  := 0;
      obj.Object_Type       := Address_Space_Object_Type;
   end Initialize;

   function Copy (obj : in Address_Space) return Address_Space_Ptr is
      New_Address_Space : Address_Space_Ptr;
   begin
      New_Address_Space := new Address_Space'(obj);
      return Address_Space_Ptr (New_Address_Space);
   end Copy;

   function Copy (obj : in Address_Space_Ptr) return Address_Space_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Address_Space) is
   begin
      Put (Generic_Object (obj));
      Put ("Cpu_Name: ");
      Put (obj.Cpu_Name);
      Put ("; ");
      Put ("Text_Memory_Size: ");
      Standards_Io.Natural_Io.Put (obj.Text_Memory_Size);
      Put ("; ");
      Put ("Stack_Memory_Size: ");
      Standards_Io.Natural_Io.Put (obj.Stack_Memory_Size);
      Put ("; ");
      Put ("Data_Memory_Size: ");
      Standards_Io.Natural_Io.Put (obj.Data_Memory_Size);
      Put ("; ");
      Put ("Heap_Memory_Size: ");
      Standards_Io.Natural_Io.Put (obj.Heap_Memory_Size);
      Put ("; ");
      Put ("Scheduler: ");
      if obj.Scheduler /= null then
         Put (obj.Scheduler.all);
      else
         Put ("null");
      end if;
      Put ("; ");
   end Put;

   procedure Put (obj : in Address_Space_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Address_Space_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Address_Space) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Address_Space_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Address_Space;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Object (obj), level, result);
      result := result &
                ASCII.HT &
                "<Cpu_Name> " &
                XML_String (obj.Cpu_Name, level) &
                " </Cpu_Name>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Text_Memory_Size> " &
                XML_String (obj.Text_Memory_Size, level) &
                " </Text_Memory_Size>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Stack_Memory_Size> " &
                XML_String (obj.Stack_Memory_Size, level) &
                " </Stack_Memory_Size>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Data_Memory_Size> " &
                XML_String (obj.Data_Memory_Size, level) &
                " </Data_Memory_Size>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Heap_Memory_Size> " &
                XML_String (obj.Heap_Memory_Size, level) &
                " </Heap_Memory_Size>" &
                Unbounded_Lf;
      if obj.Scheduler /= null then
         result := result &
                   ASCII.HT &
                   "<Scheduler ref=""" &
                   Get_Name (obj.Scheduler) &
                   """ />" &
                   Unbounded_Lf;
      else
         result := result &
                   ASCII.HT &
                   "<Scheduler> </Scheduler>" &
                   Unbounded_Lf;
      end if;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Address_Space;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Address_Space id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Address_Space>" & Unbounded_Lf;
      return (result);
   end XML_String;

end Address_Spaces;
