------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with primitive_xml_strings; use primitive_xml_strings;

with Ada.Strings.Unbounded.Text_IO; use Ada.Strings.Unbounded.Text_IO;

with Text_IO; use Text_IO;

package body Buffers is

   function XML_String
     (e     : in Role_type;
      level : in Natural := 0)
      return  Unbounded_String
   is
   begin
      return To_Unbounded_String (Role_type'Image (e));
   end XML_String;

   -- --------= Buffer_Role =--------

   procedure Initialize (obj : out Buffer_Role) is
   begin
      obj.The_Role := No_Role;
      obj.Size     := 0;
      obj.Time     := 0;
   end Initialize;

   procedure Put (obj : in Buffer_Role) is
   begin
      Put ("The_Role: ");
      Put (obj.The_Role);
      Put ("; ");
      Put ("Size: ");
      Standards_Io.Natural_Io.Put (obj.Size);
      Put ("; ");
      Put ("Time: ");
      Standards_Io.Natural_Io.Put (obj.Time);
      Put ("; ");
   end Put;

   procedure Put (obj : in Buffer_Role_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Build_Attributes_XML_String
     (obj    : in Buffer_Role;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      result := result &
                ASCII.HT &
                "<The_Role> " &
                XML_String (obj.The_Role, level) &
                " </The_Role>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Size> " &
                XML_String (obj.Size, level) &
                " </Size>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Time> " &
                XML_String (obj.Time, level) &
                " </Time>" &
                Unbounded_Lf;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Buffer_Role;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Buffer_Role>" & Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Buffer_Role>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Buffer =--------

   procedure Initialize (obj : in out Buffer) is
   begin
      Initialize (Generic_Object (obj));
      obj.Cpu_Name           := Empty_String;
      obj.Address_Space_Name := Empty_String;
      obj.Size               := 0;
      Initialize (obj.Roles);
      obj.X           := 0;
      obj.Y           := 0;
      obj.Object_Type := Buffer_Object_Type;
   end Initialize;

   function Copy (obj : in Buffer) return Buffer_Ptr is
      New_Buffer : Buffer_Ptr;
   begin
      New_Buffer := new Buffer'(obj);
      return Buffer_Ptr (New_Buffer);
   end Copy;

   function Copy (obj : in Buffer_Ptr) return Buffer_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Buffer) is
   begin
      Put (Generic_Object (obj));
      Put ("Cpu_Name: ");
      Put (obj.Cpu_Name);
      Put ("; ");
      Put ("Address_Space_Name: ");
      Put (obj.Address_Space_Name);
      Put ("; ");
      Put ("Queueing_System_Type: ");
      Put (obj.Queueing_System_Type);
      Put ("; ");
      Put ("Size: ");
      Standards_Io.Natural_Io.Put (obj.Size);
      Put ("; ");
      Put ("Roles: ");
      Put (obj.Roles);
      Put ("; ");
      Put ("X: ");
      Standards_Io.Natural_Io.Put (obj.X);
      Put ("; ");
      Put ("Y: ");
      Standards_Io.Natural_Io.Put (obj.Y);
      Put ("; ");
   end Put;

   procedure Put (obj : in Buffer_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Buffer_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Buffer) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Buffer_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Buffer;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Object (obj), level, result);
      result := result &
                ASCII.HT &
                "<Cpu_Name> " &
                XML_String (obj.Cpu_Name, level) &
                " </Cpu_Name>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Address_Space_Name> " &
                XML_String (obj.Address_Space_Name, level) &
                " </Address_Space_Name>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Queueing_System_Type> " &
                XML_String (obj.Queueing_System_Type, level) &
                " </Queueing_System_Type>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Size> " &
                XML_String (obj.Size, level) &
                " </Size>" &
                Unbounded_Lf;
      --	result := result & ASCII.HT & "<Roles> " & XML_String(obj.Roles,
      --level) & " </Roles>" & Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<X> " &
                XML_String (obj.X, level) &
                " </X>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Y> " &
                XML_String (obj.Y, level) &
                " </Y>" &
                Unbounded_Lf;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Buffer;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Buffer id=""" & Get_Name (obj) & """ >" & Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Buffer>" & Unbounded_Lf;
      return (result);
   end XML_String;

end Buffers;
