------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with Convert_Strings;

with Convert_Unbounded_Strings;

with Text_IO; use Text_IO;

with Standards_Io; use Standards_Io;

use Standards_Io.Natural_Io;

with Indexed_Tables;

with Framework_Config; use Framework_Config;

with Ada.Strings.Unbounded.Text_IO; use Ada.Strings.Unbounded.Text_IO;

with Queueing_System; use Queueing_System;

use Queueing_System.qs_io;

with Objects; use Objects;

with Unchecked_Deallocation;

package Buffers is

   type Role_type is (No_Role, Producer, Consumer);

   procedure To_Role_type is new Convert_Strings (Role_type, No_Role);
   procedure To_Role_type is new Convert_Unbounded_Strings (
      Role_type,
      No_Role);
   function XML_String
     (e     : in Role_type;
      level : in Natural := 0)
      return  Unbounded_String;
   package Role_type_io is new Text_IO.Enumeration_IO (Role_type);
   use Role_type_io;

   -- --------= Buffer_Role =--------

   type Buffer_Role is record
      The_Role : Role_type;
      Size     : Natural;
      Time     : Natural;
   end record;

   type Buffer_Role_Ptr is access all Buffer_Role;

   procedure Initialize (obj : out Buffer_Role);
   procedure Put (obj : in Buffer_Role);
   procedure Put (obj : in Buffer_Role_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Buffer_Role;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Buffer_Role;
      level : in Natural := 0)
      return  Unbounded_String;

   package Buffer_Roles is new Indexed_Tables (
      Buffer_Role,
      Unbounded_String,
      Framework_Config.Max_Tasks,
      0,
      Put,
      Initialize,
      Put);
   use Buffer_Roles;

   subtype Buffer_Roles_Table is Buffer_Roles.Indexed_Table;

   subtype Buffer_Roles_Range is Buffer_Roles.Indexed_Table_Range;

   -- --------= Buffer =--------

   type Buffer;
   type Buffer_Ptr is access all Buffer'Class;
   type Buffer is new Generic_Object with record
      Cpu_Name             : Unbounded_String;
      Address_Space_Name   : Unbounded_String;
      Queueing_System_Type : Queueing_Systems_Type;
      Size                 : Natural;
      Roles                : Buffer_Roles_Table;
      X                    : Natural;
      Y                    : Natural;
   end record;

   procedure Initialize (obj : in out Buffer);
   procedure Put (obj : in Buffer);
   procedure Put (obj : in Buffer_Ptr);
   procedure Put_Name (obj : in Buffer_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Buffer;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Buffer;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Buffer) return Unbounded_String;
   function Get_Name (obj : in Buffer_Ptr) return Unbounded_String;
   function Copy (obj : in Buffer_Ptr) return Buffer_Ptr;
   function Copy (obj : in Buffer) return Buffer_Ptr;
   procedure Free is new Unchecked_Deallocation (Buffer'Class, Buffer_Ptr);

end Buffers;
