------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Text_IO; use Text_IO;

package body Event_Analyzers is

   procedure Put (My_Event_Analyzer : in Event_Analyzer_Ptr) is
   begin
      Put_Line
        ("Event handler : " &
         To_String (My_Event_Analyzer.Behavior_File_Name));
      Put_Line
        ("Event handler : " & To_String (My_Event_Analyzer.String_Behavior));
   end Put;

   function Copy
     (My_Event_Analyzer : in Event_Analyzer_Ptr)
      return              Event_Analyzer_Ptr
   is
      New_Event : Event_Analyzer_Ptr;
   begin
      New_Event     := new Event_Analyzer;
      New_Event.all := My_Event_Analyzer.all;
      return New_Event;
   end Copy;

end Event_Analyzers;
