------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with Convert_Strings;

with Convert_Unbounded_Strings;

with Text_IO; use Text_IO;

with Objects; use Objects;

with Unchecked_Deallocation;

package Networks is

   type Networks_Type is (Bounded_Delay, jitter_delay, Parametric_Delay);

   procedure To_Networks_Type is new Convert_Strings (
      Networks_Type,
      Bounded_Delay);
   procedure To_Networks_Type is new Convert_Unbounded_Strings (
      Networks_Type,
      Bounded_Delay);
   function XML_String
     (e     : in Networks_Type;
      level : in Natural := 0)
      return  Unbounded_String;
   package Networks_Type_io is new Text_IO.Enumeration_IO (Networks_Type);
   use Networks_Type_io;

   -- --------= Network =--------

   type Network;
   type Network_Ptr is access all Network'Class;
   type Network is new Generic_Object with record
      Network_Type : Networks_Type;
   end record;

   procedure Initialize (obj : in out Network);
   procedure Put (obj : in Network);
   procedure Put (obj : in Network_Ptr);
   procedure Put_Name (obj : in Network_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Network;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Network;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Network) return Unbounded_String;
   function Get_Name (obj : in Network_Ptr) return Unbounded_String;
   function Copy (obj : in Network_Ptr) return Network_Ptr;
   function Copy (obj : in Network) return Network_Ptr;
   procedure Free is new Unchecked_Deallocation (Network'Class, Network_Ptr);

end Networks;
