------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with Convert_Strings;

with Convert_Unbounded_Strings;

with Text_IO; use Text_IO;

with Ada.Finalization;

with Unchecked_Deallocation;

package Objects is

   type Objects_Type is (
      Buffer_Object_Type,
      Processor_Object_Type,
      Task_Object_Type,
      Resource_Object_Type,
      Address_Space_Object_Type,
      Message_Object_Type,
      State_Object_Type,
      Transition_Object_Type,
      Statement_Object_Type,
      Synchronization_Object_Type,
      Section_Object_Type,
      Network_Object_Type);

   procedure To_Objects_Type is new Convert_Strings (
      Objects_Type,
      Buffer_Object_Type);
   procedure To_Objects_Type is new Convert_Unbounded_Strings (
      Objects_Type,
      Buffer_Object_Type);
   function XML_String
     (e     : in Objects_Type;
      level : in Natural := 0)
      return  Unbounded_String;
   package Objects_Type_io is new Text_IO.Enumeration_IO (Objects_Type);
   use Objects_Type_io;

   -- --------= Generic_Object =--------

   type Generic_Object;
   type Generic_Object_Ptr is access all Generic_Object'Class;
   type Generic_Object is new Ada.Finalization.Controlled with record
      Name        : Unbounded_String;
      Object_Type : Objects_Type;
   end record;

   procedure Initialize (obj : in out Generic_Object);
   procedure Put (obj : in Generic_Object);
   procedure Put (obj : in Generic_Object_Ptr);
   procedure Put_Name (obj : in Generic_Object_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Generic_Object;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Generic_Object;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Generic_Object) return Unbounded_String;
   function Get_Name (obj : in Generic_Object_Ptr) return Unbounded_String;
   function Copy (obj : in Generic_Object_Ptr) return Generic_Object_Ptr;
   function Copy (obj : in Generic_Object) return Generic_Object_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Generic_Object'Class,
      Generic_Object_Ptr);

end Objects;
