------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Standards_Io; use Standards_Io;

use Standards_Io.Boolean_Io;

use Standards_Io.Integer_Io;

with Ada.Numerics.Aux; use Ada.Numerics.Aux;

use Standards_Io.Double_Io;

with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Tables;

with Framework_Config; use Framework_Config;

with Convert_Strings;

with Convert_Unbounded_Strings;

with Text_IO; use Text_IO;

package Parameters is

   type Parameter_Type is (
      Boolean_Parameter,
      Integer_Parameter,
      Double_Parameter,
      String_Parameter);

   procedure To_Parameter_Type is new Convert_Strings (
      Parameter_Type,
      Boolean_Parameter);
   procedure To_Parameter_Type is new Convert_Unbounded_Strings (
      Parameter_Type,
      Boolean_Parameter);
   function XML_String
     (e     : in Parameter_Type;
      level : in Natural := 0)
      return  Unbounded_String;
   package Parameter_Type_io is new Text_IO.Enumeration_IO (Parameter_Type);
   use Parameter_Type_io;

   type Parameter (ptype : Parameter_Type) is record
      Name : Unbounded_String;
      case ptype is
         when Boolean_Parameter =>
            Boolean_value : Boolean;
         when Integer_Parameter =>
            Integer_value : Integer;
         when Double_Parameter =>
            double_value : Double;
         when String_Parameter =>
            string_value : Unbounded_String;
      end case;
   end record;

   type Parameter_ptr is access all Parameter;

   procedure Initialize (obj : out Parameter_ptr);

   procedure Put (obj : in Parameter_ptr);

   package User_Defined_Parameters_Table_Package is new Tables (
      Parameter_ptr,
      Max_User_Defined_Task_Parameters,
      Put);
   use User_Defined_Parameters_Table_Package;

   subtype User_Defined_Parameters_Range is
     User_Defined_Parameters_Table_Package.Table_Range;

   subtype User_Defined_Parameters_Table is
     User_Defined_Parameters_Table_Package.Table;

end Parameters;
