------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with primitive_xml_strings; use primitive_xml_strings;

with Text_IO; use Text_IO;

package body Automaton is

   function XML_String
     (e     : in Synchronizations_Type;
      level : in Natural := 0)
      return  Unbounded_String
   is
   begin
      return To_Unbounded_String (Synchronizations_Type'Image (e));
   end XML_String;

   function XML_String
     (e     : in Status_Type;
      level : in Natural := 0)
      return  Unbounded_String
   is
   begin
      return To_Unbounded_String (Status_Type'Image (e));
   end XML_String;

   -- --------= State =--------

   procedure Initialize (obj : in out State) is
   begin
      Initialize (Generic_Object (obj));
      obj.Is_Initial  := False;
      obj.Object_Type := State_Object_Type;
   end Initialize;

   function Copy (obj : in State) return State_Ptr is
      New_State : State_Ptr;
   begin
      New_State := new State'(obj);
      return State_Ptr (New_State);
   end Copy;

   function Copy (obj : in State_Ptr) return State_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in State) is
   begin
      Put (Generic_Object (obj));
      Put ("Is_Initial: ");
      Standards_Io.Boolean_Io.Put (obj.Is_Initial);
      Put ("; ");
   end Put;

   procedure Put (obj : in State_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in State_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in State) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in State_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in State;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Object (obj), level, result);
      result := result &
                ASCII.HT &
                "<Is_Initial> " &
                XML_String (obj.Is_Initial, level) &
                " </Is_Initial>" &
                Unbounded_Lf;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in State;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<State id=""" & Get_Name (obj) & """ >" & Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</State>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Synchronization =--------

   procedure Initialize (obj : in out Synchronization) is
   begin
      Initialize (Generic_Object (obj));
      obj.Synchronization_Type := Send;
      obj.Object_Type          := Synchronization_Object_Type;
   end Initialize;

   function Copy (obj : in Synchronization) return Synchronization_Ptr is
      New_Synchronization : Synchronization_Ptr;
   begin
      New_Synchronization := new Synchronization'(obj);
      return Synchronization_Ptr (New_Synchronization);
   end Copy;

   function Copy (obj : in Synchronization_Ptr) return Synchronization_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Synchronization) is
   begin
      Put (Generic_Object (obj));
      Put ("Synchronization_Type: ");
      Put (obj.Synchronization_Type);
      Put ("; ");
   end Put;

   procedure Put (obj : in Synchronization_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Synchronization_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Synchronization) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Synchronization_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Synchronization;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Object (obj), level, result);
      result := result &
                ASCII.HT &
                "<Synchronization_Type> " &
                XML_String (obj.Synchronization_Type, level) &
                " </Synchronization_Type>" &
                Unbounded_Lf;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Synchronization;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Synchronization id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Synchronization>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Transition =--------

   procedure Initialize (obj : in out Transition) is
   begin
      Initialize (Generic_Object (obj));
      obj.Object_Type := Transition_Object_Type;
   end Initialize;

   function Copy (obj : in Transition) return Transition_Ptr is
      New_Transition : Transition_Ptr;
   begin
      New_Transition := new Transition'(obj);
      return Transition_Ptr (New_Transition);
   end Copy;

   function Copy (obj : in Transition_Ptr) return Transition_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Transition) is
   begin
      Put (Generic_Object (obj));
      Put ("From_State: ");
      if obj.From_State /= null then
         Put (obj.From_State.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("To_State: ");
      if obj.To_State /= null then
         Put (obj.To_State.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("Guards: ");
      if obj.Guards /= null then
         Put (obj.Guards.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("Clocks: ");
      if obj.Clocks /= null then
         Put (obj.Clocks.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("Synchronization: ");
      if obj.Synchronization /= null then
         Put (obj.Synchronization.all);
      else
         Put ("null");
      end if;
      Put ("; ");
   end Put;

   procedure Put (obj : in Transition_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Transition_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Transition) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Transition_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Transition;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Object (obj), level, result);
      if obj.From_State /= null then
         result := result &
                   ASCII.HT &
                   "<From_State ref=""" &
                   Get_Name (obj.From_State) &
                   """ />" &
                   Unbounded_Lf;
      else
         result := result &
                   ASCII.HT &
                   "<From_State> </From_State>" &
                   Unbounded_Lf;
      end if;
      if obj.To_State /= null then
         result := result &
                   ASCII.HT &
                   "<To_State ref=""" &
                   Get_Name (obj.To_State) &
                   """ />" &
                   Unbounded_Lf;
      else
         result := result &
                   ASCII.HT &
                   "<To_State> </To_State>" &
                   Unbounded_Lf;
      end if;
      --	if obj.Guards /= null then
      --		result := result & ASCII.HT & "<Guards ref=""" &
      --Get_Name(obj.Guards) & """ />" & Unbounded_Lf;
      --	else
      --		result := result & ASCII.HT & "<Guards> </Guards>" & Unbounded_Lf;
      --	end if;
      if obj.Clocks /= null then
         result := result &
                   ASCII.HT &
                   "<Clocks ref=""" &
                   Get_Name (obj.Clocks) &
                   """ />" &
                   Unbounded_Lf;
      else
         result := result & ASCII.HT & "<Clocks> </Clocks>" & Unbounded_Lf;
      end if;
      if obj.Synchronization /= null then
         result := result &
                   ASCII.HT &
                   "<Synchronization ref=""" &
                   Get_Name (obj.Synchronization) &
                   """ />" &
                   Unbounded_Lf;
      else
         result := result &
                   ASCII.HT &
                   "<Synchronization> </Synchronization>" &
                   Unbounded_Lf;
      end if;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Transition;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Transition id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Transition>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Automaton_Status =--------

   procedure Initialize (obj : out Automaton_Status) is
   begin
      null;
   end Initialize;

   procedure Put (obj : in Automaton_Status) is
   begin
      Put ("Current_State: ");
      if obj.Current_State /= null then
         Put (obj.Current_State.all);
      else
         Put ("null");
      end if;
      Put ("; ");
   end Put;

   procedure Put (obj : in Automaton_Status_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Build_Attributes_XML_String
     (obj    : in Automaton_Status;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      if obj.Current_State /= null then
         result := result &
                   ASCII.HT &
                   "<Current_State ref=""" &
                   Get_Name (obj.Current_State) &
                   """ />" &
                   Unbounded_Lf;
      else
         result := result &
                   ASCII.HT &
                   "<Current_State> </Current_State>" &
                   Unbounded_Lf;
      end if;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Automaton_Status;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Automaton_Status>" & Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Automaton_Status>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Transition_Status =--------

   procedure Initialize (obj : out Transition_Status) is
   begin
      obj.Status      := Ready;
      obj.Wakeup_Time := 0;
   end Initialize;

   procedure Put (obj : in Transition_Status) is
   begin
      Put ("Code: ");
      if obj.Code /= null then
         Put (obj.Code.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("Status: ");
      Put (obj.Status);
      Put ("; ");
      Put ("Wakeup_Time: ");
      Standards_Io.Natural_Io.Put (obj.Wakeup_Time);
      Put ("; ");
   end Put;

   procedure Put (obj : in Transition_Status_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Build_Attributes_XML_String
     (obj    : in Transition_Status;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      if obj.Code /= null then
         result := result &
                   ASCII.HT &
                   "<Code ref=""" &
                   Get_Name (obj.Code) &
                   """ />" &
                   Unbounded_Lf;
      else
         result := result & ASCII.HT & "<Code> </Code>" & Unbounded_Lf;
      end if;
      result := result &
                ASCII.HT &
                "<Status> " &
                XML_String (obj.Status, level) &
                " </Status>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Wakeup_Time> " &
                XML_String (obj.Wakeup_Time, level) &
                " </Wakeup_Time>" &
                Unbounded_Lf;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Transition_Status;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Transition_Status>" & Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Transition_Status>" & Unbounded_Lf;
      return (result);
   end XML_String;

end Automaton;
