------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with Standards_Io; use Standards_Io;

use Standards_Io.Boolean_Io;

with Objects; use Objects;

with Unchecked_Deallocation;

with Lists;

with Ada.Strings.Unbounded.Text_IO; use Ada.Strings.Unbounded.Text_IO;

with Framework_Config; use Framework_Config;

with Convert_Strings;

with Convert_Unbounded_Strings;

with Text_IO; use Text_IO;

with Expressions; use Expressions;

with Statements; use Statements;

with Indexed_Tables;

use Standards_Io.Natural_Io;

package Automaton is

   type Synchronizations_Type is (Send, Receive);

   procedure To_Synchronizations_Type is new Convert_Strings (
      Synchronizations_Type,
      Send);
   procedure To_Synchronizations_Type is new Convert_Unbounded_Strings (
      Synchronizations_Type,
      Send);
   function XML_String
     (e     : in Synchronizations_Type;
      level : in Natural := 0)
      return  Unbounded_String;
   package Synchronizations_Type_io is new Text_IO.Enumeration_IO (
      Synchronizations_Type);
   use Synchronizations_Type_io;

   type Status_Type is (Ready, Pended, Rendezvous, Guarded, Unreachable);

   procedure To_Status_Type is new Convert_Strings (Status_Type, Ready);
   procedure To_Status_Type is new Convert_Unbounded_Strings (
      Status_Type,
      Ready);
   function XML_String
     (e     : in Status_Type;
      level : in Natural := 0)
      return  Unbounded_String;
   package Status_Type_io is new Text_IO.Enumeration_IO (Status_Type);
   use Status_Type_io;

   -- --------= State =--------

   type State;
   type State_Ptr is access all State'Class;
   type State is new Generic_Object with record
      Is_Initial : Boolean;
   end record;

   procedure Initialize (obj : in out State);
   procedure Put (obj : in State);
   procedure Put (obj : in State_Ptr);
   procedure Put_Name (obj : in State_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in State;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in State;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in State) return Unbounded_String;
   function Get_Name (obj : in State_Ptr) return Unbounded_String;
   function Copy (obj : in State_Ptr) return State_Ptr;
   function Copy (obj : in State) return State_Ptr;
   procedure Free is new Unchecked_Deallocation (State'Class, State_Ptr);

   package State_Lists_Package is new Lists (State_Ptr, Put, Free);
   use State_Lists_Package;

   subtype State_Lists is State_Lists_Package.List;

   subtype State_Lists_Iterator is State_Lists_Package.Iterator;

   -- --------= Synchronization =--------

   type Synchronization;
   type Synchronization_Ptr is access all Synchronization'Class;
   type Synchronization is new Generic_Object with record
      Synchronization_Type : Synchronizations_Type;
   end record;

   procedure Initialize (obj : in out Synchronization);
   procedure Put (obj : in Synchronization);
   procedure Put (obj : in Synchronization_Ptr);
   procedure Put_Name (obj : in Synchronization_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Synchronization;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Synchronization;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Synchronization) return Unbounded_String;
   function Get_Name (obj : in Synchronization_Ptr) return Unbounded_String;
   function Copy (obj : in Synchronization_Ptr) return Synchronization_Ptr;
   function Copy (obj : in Synchronization) return Synchronization_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Synchronization'Class,
      Synchronization_Ptr);

   -- --------= Transition =--------

   type Transition;
   type Transition_Ptr is access all Transition'Class;
   type Transition is new Generic_Object with record
      From_State      : State_Ptr;
      To_State        : State_Ptr;
      Guards          : Generic_Expression_Ptr;
      Clocks          : Generic_Statement_Ptr;
      Synchronization : Synchronization_Ptr;
   end record;

   procedure Initialize (obj : in out Transition);
   procedure Put (obj : in Transition);
   procedure Put (obj : in Transition_Ptr);
   procedure Put_Name (obj : in Transition_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Transition;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Transition;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Transition) return Unbounded_String;
   function Get_Name (obj : in Transition_Ptr) return Unbounded_String;
   function Copy (obj : in Transition_Ptr) return Transition_Ptr;
   function Copy (obj : in Transition) return Transition_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Transition'Class,
      Transition_Ptr);

   package Transition_Lists_Package is new Lists (Transition_Ptr, Put, Free);
   use Transition_Lists_Package;

   subtype Transition_Lists is Transition_Lists_Package.List;

   subtype Transition_Lists_Iterator is Transition_Lists_Package.Iterator;

   -- --------= Automaton_Status =--------

   type Automaton_Status is record
      Current_State : State_Ptr;
   end record;

   type Automaton_Status_Ptr is access all Automaton_Status;

   procedure Initialize (obj : out Automaton_Status);
   procedure Put (obj : in Automaton_Status);
   procedure Put (obj : in Automaton_Status_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Automaton_Status;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Automaton_Status;
      level : in Natural := 0)
      return  Unbounded_String;

   package Package_Automaton_Status is new Indexed_Tables (
      Automaton_Status,
      Unbounded_String,
      Framework_Config.Max_Sections,
      0,
      Put,
      Initialize,
      Put);
   use Package_Automaton_Status;

   subtype Automaton_Status_Table is Package_Automaton_Status.Indexed_Table;

   subtype Automaton_Status_Range is
     Package_Automaton_Status.Indexed_Table_Range;

   -- --------= Transition_Status =--------

   type Transition_Status is record
      Code        : Transition_Ptr;
      Status      : Status_Type;
      Wakeup_Time : Natural;
   end record;

   type Transition_Status_Ptr is access all Transition_Status;

   procedure Initialize (obj : out Transition_Status);
   procedure Put (obj : in Transition_Status);
   procedure Put (obj : in Transition_Status_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Transition_Status;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Transition_Status;
      level : in Natural := 0)
      return  Unbounded_String;

   package Package_Transition_Status is new Indexed_Tables (
      Transition_Status,
      Unbounded_String,
      Framework_Config.Max_Transitions,
      0,
      Put,
      Initialize,
      Put);
   use Package_Transition_Status;

   subtype Transition_Status_Table is Package_Transition_Status.Indexed_Table;

   subtype Transition_Status_Range is
     Package_Transition_Status.Indexed_Table_Range;

end Automaton;
