------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------

package body Statements.extended is

   procedure Recursive_Put (S : in Generic_Statement_Ptr) is

   begin

      Put (S.all);

      if (S.Statement_Type = While_Statement_Type) then
         if (While_Statement_Ptr (S).Included_Statement /= null) then
            Put ("Included statement : ");
            New_Line;
            Recursive_Put (While_Statement_Ptr (S).Included_Statement);
         end if;
      end if;
      if (S.Statement_Type = For_Statement_Type) then
         if (For_Statement_Ptr (S).Included_Statement /= null) then
            Put ("Included statement : ");
            New_Line;
            Recursive_Put (For_Statement_Ptr (S).Included_Statement);
         end if;
      end if;

      if (S.Statement_Type = If_Statement_Type) then
         if (If_Statement_Ptr (S).Then_Statement /= null) then
            Put ("Then statement : ");
            New_Line;
            New_Line;
            Recursive_Put (If_Statement_Ptr (S).Then_Statement);
         end if;
         if (If_Statement_Ptr (S).Else_Statement /= null) then
            Put ("Else statement : ");
            New_Line;
            New_Line;
            Recursive_Put (If_Statement_Ptr (S).Else_Statement);
         end if;

      else
         if (S.Next_Statement /= null) then
            Put ("Next statement  : ");
            New_Line;
            New_Line;
            Recursive_Put (S.Next_Statement);
         end if;

      end if;

   end Recursive_Put;
end Statements.extended;
