------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with Ada.Strings.Unbounded.Text_IO; use Ada.Strings.Unbounded.Text_IO;

with Text_IO; use Text_IO;

with primitive_xml_strings; use primitive_xml_strings;

package body Statements is

   function XML_String
     (e     : in Statements_Type;
      level : in Natural := 0)
      return  Unbounded_String
   is
   begin
      return To_Unbounded_String (Statements_Type'Image (e));
   end XML_String;

   function XML_String
     (e     : in Table_Types;
      level : in Natural := 0)
      return  Unbounded_String
   is
   begin
      return To_Unbounded_String (Table_Types'Image (e));
   end XML_String;

   -- --------= Generic_Statement =--------

   procedure Initialize (obj : in out Generic_Statement) is
   begin
      Initialize (Generic_Object (obj));
      obj.Statement_Type := Put_Statement_Type;
      obj.Line_Number    := 0;
      obj.File_Name      := Empty_String;
      obj.Object_Type    := Statement_Object_Type;
   end Initialize;

   function Copy (obj : in Generic_Statement) return Generic_Statement_Ptr is
      New_Generic_Statement : Generic_Statement_Ptr;
   begin
      New_Generic_Statement := new Generic_Statement'(obj);
      return Generic_Statement_Ptr (New_Generic_Statement);
   end Copy;

   function Copy
     (obj  : in Generic_Statement_Ptr)
      return Generic_Statement_Ptr
   is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Generic_Statement) is
   begin
      Put (Generic_Object (obj));
      Put ("Statement_Type: ");
      Put (obj.Statement_Type);
      Put ("; ");
      Put ("Line_Number: ");
      Standards_Io.Natural_Io.Put (obj.Line_Number);
      Put ("; ");
      Put ("File_Name: ");
      Put (obj.File_Name);
      Put ("; ");
      Put ("Next_Statement: ");
      if obj.Next_Statement /= null then
         Put (obj.Next_Statement.all);
      else
         Put ("null");
      end if;
      Put ("; ");
   end Put;

   procedure Put (obj : in Generic_Statement_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Generic_Statement_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Generic_Statement) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name
     (obj  : in Generic_Statement_Ptr)
      return Unbounded_String
   is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Generic_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Object (obj), level, result);
      result := result &
                ASCII.HT &
                "<Statement_Type> " &
                XML_String (obj.Statement_Type, level) &
                " </Statement_Type>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Line_Number> " &
                XML_String (obj.Line_Number, level) &
                " </Line_Number>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<File_Name> " &
                XML_String (obj.File_Name, level) &
                " </File_Name>" &
                Unbounded_Lf;
      if obj.Next_Statement /= null then
         result := result &
                   ASCII.HT &
                   "<Next_Statement ref=""" &
                   Get_Name (obj.Next_Statement) &
                   """ />" &
                   Unbounded_Lf;
      else
         result := result &
                   ASCII.HT &
                   "<Next_Statement> </Next_Statement>" &
                   Unbounded_Lf;
      end if;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Generic_Statement;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Generic_Statement id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Generic_Statement>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Nop_Statement =--------

   procedure Initialize (obj : in out Nop_Statement) is
   begin
      Initialize (Generic_Statement (obj));
      obj.Statement_Type := Nop_Statement_Type;
   end Initialize;

   function Copy (obj : in Nop_Statement) return Generic_Statement_Ptr is
      New_Nop_Statement : Nop_Statement_Ptr;
   begin
      New_Nop_Statement := new Nop_Statement'(obj);
      return Generic_Statement_Ptr (New_Nop_Statement);
   end Copy;

   function Copy (obj : in Nop_Statement_Ptr) return Generic_Statement_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Nop_Statement) is
   begin
      Put (Generic_Statement (obj));
   end Put;

   procedure Put (obj : in Nop_Statement_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Nop_Statement_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Nop_Statement) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Nop_Statement_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Nop_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Statement (obj), level, result);
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Nop_Statement;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Nop_Statement id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Nop_Statement>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Exit_Statement =--------

   procedure Initialize (obj : in out Exit_Statement) is
   begin
      Initialize (Generic_Statement (obj));
      obj.Statement_Type := Exit_Statement_Type;
   end Initialize;

   function Copy (obj : in Exit_Statement) return Generic_Statement_Ptr is
      New_Exit_Statement : Exit_Statement_Ptr;
   begin
      New_Exit_Statement := new Exit_Statement'(obj);
      return Generic_Statement_Ptr (New_Exit_Statement);
   end Copy;

   function Copy (obj : in Exit_Statement_Ptr) return Generic_Statement_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Exit_Statement) is
   begin
      Put (Generic_Statement (obj));
   end Put;

   procedure Put (obj : in Exit_Statement_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Exit_Statement_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Exit_Statement) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Exit_Statement_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Exit_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Statement (obj), level, result);
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Exit_Statement;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Exit_Statement id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Exit_Statement>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Put_Statement =--------

   procedure Initialize (obj : in out Put_Statement) is
   begin
      Initialize (Generic_Statement (obj));
      obj.Statement_Type := Put_Statement_Type;
   end Initialize;

   function Copy (obj : in Put_Statement) return Generic_Statement_Ptr is
      New_Put_Statement : Put_Statement_Ptr;
   begin
      New_Put_Statement := new Put_Statement'(obj);
      return Generic_Statement_Ptr (New_Put_Statement);
   end Copy;

   function Copy (obj : in Put_Statement_Ptr) return Generic_Statement_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Put_Statement) is
   begin
      Put (Generic_Statement (obj));
      Put ("Put_From: ");
      if obj.Put_From /= null then
         Put (obj.Put_From.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("Put_To: ");
      if obj.Put_To /= null then
         Put (obj.Put_To.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("Expression_To_Be_displayed: ");
      if obj.Expression_To_Be_displayed /= null then
         Put (obj.Expression_To_Be_displayed.all);
      else
         Put ("null");
      end if;
      Put ("; ");
   end Put;

   procedure Put (obj : in Put_Statement_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Put_Statement_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Put_Statement) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Put_Statement_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Put_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Statement (obj), level, result);
      --if obj.Put_From /= null then
      --	result := result & ASCII.HT & "<Put_From ref=""" &
      --Get_Name(obj.Put_From) & """ />" & Unbounded_Lf;
      --else
      --	result := result & ASCII.HT & "<Put_From> </Put_From>" & Unbounded_Lf;
      --end if;
      --if obj.Put_To /= null then
      --	result := result & ASCII.HT & "<Put_To ref=""" & Get_Name(obj.Put_To)
      --& """ />" & Unbounded_Lf;
      --else
      --	result := result & ASCII.HT & "<Put_To> </Put_To>" & Unbounded_Lf;
      --end if;
      --if obj.Expression_To_Be_displayed /= null then
      --	result := result & ASCII.HT & "<Expression_To_Be_displayed ref=""" &
      --Get_Name(obj.Expression_To_Be_displayed) & """ />" & Unbounded_Lf;
      --else
      --	result := result & ASCII.HT & "<Expression_To_Be_displayed>
      --</Expression_To_Be_displayed>" & Unbounded_Lf;
      --end if;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Put_Statement;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Put_Statement id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Put_Statement>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= If_Statement =--------

   procedure Initialize (obj : in out If_Statement) is
   begin
      Initialize (Generic_Statement (obj));
      obj.Statement_Type := If_Statement_Type;
   end Initialize;

   function Copy (obj : in If_Statement) return Generic_Statement_Ptr is
      New_If_Statement : If_Statement_Ptr;
   begin
      New_If_Statement := new If_Statement'(obj);
      return Generic_Statement_Ptr (New_If_Statement);
   end Copy;

   function Copy (obj : in If_Statement_Ptr) return Generic_Statement_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in If_Statement) is
   begin
      Put (Generic_Statement (obj));
      Put ("Bool_Expression: ");
      if obj.Bool_Expression /= null then
         Put (obj.Bool_Expression.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("Else_Statement: ");
      if obj.Else_Statement /= null then
         Put (obj.Else_Statement.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("Then_Statement: ");
      if obj.Then_Statement /= null then
         Put (obj.Then_Statement.all);
      else
         Put ("null");
      end if;
      Put ("; ");
   end Put;

   procedure Put (obj : in If_Statement_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in If_Statement_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in If_Statement) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in If_Statement_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in If_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Statement (obj), level, result);
      --if obj.Bool_Expression /= null then
      --	result := result & ASCII.HT & "<Bool_Expression ref=""" &
      --Get_Name(obj.Bool_Expression) & """ />" & Unbounded_Lf;
      --else
      --		result := result & ASCII.HT & "<Bool_Expression> </Bool_Expression>"
      --& Unbounded_Lf;
      --	end if;
      --	if obj.Else_Statement /= null then
      --		result := result & ASCII.HT & "<Else_Statement ref=""" &
      --Get_Name(obj.Else_Statement) & """ />" & Unbounded_Lf;
      --	else
      --		result := result & ASCII.HT & "<Else_Statement> </Else_Statement>" &
      --Unbounded_Lf;
      --	end if;
      if obj.Then_Statement /= null then
         result := result &
                   ASCII.HT &
                   "<Then_Statement ref=""" &
                   Get_Name (obj.Then_Statement) &
                   """ />" &
                   Unbounded_Lf;
      else
         result := result &
                   ASCII.HT &
                   "<Then_Statement> </Then_Statement>" &
                   Unbounded_Lf;
      end if;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in If_Statement;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<If_Statement id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</If_Statement>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Assign_Statement =--------

   procedure Initialize (obj : in out Assign_Statement) is
   begin
      Initialize (Generic_Statement (obj));
      obj.Statement_Type := Assign_Statement_Type;
   end Initialize;

   function Copy (obj : in Assign_Statement) return Generic_Statement_Ptr is
      New_Assign_Statement : Assign_Statement_Ptr;
   begin
      New_Assign_Statement := new Assign_Statement'(obj);
      return Generic_Statement_Ptr (New_Assign_Statement);
   end Copy;

   function Copy
     (obj  : in Assign_Statement_Ptr)
      return Generic_Statement_Ptr
   is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Assign_Statement) is
   begin
      Put (Generic_Statement (obj));
      Put ("Lvalue: ");
      if obj.Lvalue /= null then
         Put (obj.Lvalue.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("Rvalue: ");
      if obj.Rvalue /= null then
         Put (obj.Rvalue.all);
      else
         Put ("null");
      end if;
      Put ("; ");
   end Put;

   procedure Put (obj : in Assign_Statement_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Assign_Statement_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Assign_Statement) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name
     (obj  : in Assign_Statement_Ptr)
      return Unbounded_String
   is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Assign_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Statement (obj), level, result);
      --if obj.Lvalue /= null then
      --	result := result & ASCII.HT & "<Lvalue ref=""" & Get_Name(obj.Lvalue)
      --& """ />" & Unbounded_Lf;
      --else
      --	result := result & ASCII.HT & "<Lvalue> </Lvalue>" & Unbounded_Lf;
      --end if;
      --if obj.Rvalue /= null then
      --	result := result & ASCII.HT & "<Rvalue ref=""" & Get_Name(obj.Rvalue)
      --& """ />" & Unbounded_Lf;
      --else
      --	result := result & ASCII.HT & "<Rvalue> </Rvalue>" & Unbounded_Lf;
      --end if;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Assign_Statement;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Assign_Statement id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Assign_Statement>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Clock_Statement =--------

   procedure Initialize (obj : in out Clock_Statement) is
   begin
      Initialize (Assign_Statement (obj));
      obj.Statement_Type := Clock_Statement_Type;
   end Initialize;

   function Copy (obj : in Clock_Statement) return Generic_Statement_Ptr is
      New_Clock_Statement : Clock_Statement_Ptr;
   begin
      New_Clock_Statement := new Clock_Statement'(obj);
      return Generic_Statement_Ptr (New_Clock_Statement);
   end Copy;

   function Copy
     (obj  : in Clock_Statement_Ptr)
      return Generic_Statement_Ptr
   is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Clock_Statement) is
   begin
      Put (Assign_Statement (obj));
   end Put;

   procedure Put (obj : in Clock_Statement_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Clock_Statement_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Clock_Statement) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Clock_Statement_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Clock_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Assign_Statement (obj), level, result);
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Clock_Statement;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Clock_Statement id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Clock_Statement>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= For_Statement =--------

   procedure Initialize (obj : in out For_Statement) is
   begin
      Initialize (Generic_Statement (obj));
      obj.For_Type       := Task_Table_Type;
      obj.Statement_Type := For_Statement_Type;
   end Initialize;

   function Copy (obj : in For_Statement) return Generic_Statement_Ptr is
      New_For_Statement : For_Statement_Ptr;
   begin
      New_For_Statement := new For_Statement'(obj);
      return Generic_Statement_Ptr (New_For_Statement);
   end Copy;

   function Copy (obj : in For_Statement_Ptr) return Generic_Statement_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in For_Statement) is
   begin
      Put (Generic_Statement (obj));
      Put ("For_Type: ");
      Put (obj.For_Type);
      Put ("; ");
      Put ("Included_Statement: ");
      if obj.Included_Statement /= null then
         Put (obj.Included_Statement.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("For_Index: ");
      if obj.For_Index /= null then
         Put (obj.For_Index.all);
      else
         Put ("null");
      end if;
      Put ("; ");
   end Put;

   procedure Put (obj : in For_Statement_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in For_Statement_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in For_Statement) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in For_Statement_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in For_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Statement (obj), level, result);
      result := result &
                ASCII.HT &
                "<For_Type> " &
                XML_String (obj.For_Type, level) &
                " </For_Type>" &
                Unbounded_Lf;

   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in For_Statement;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<For_Statement id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</For_Statement>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Return_Statement =--------

   procedure Initialize (obj : in out Return_Statement) is
   begin
      Initialize (Generic_Statement (obj));
      obj.Statement_Type := Return_Statement_Type;
   end Initialize;

   function Copy (obj : in Return_Statement) return Generic_Statement_Ptr is
      New_Return_Statement : Return_Statement_Ptr;
   begin
      New_Return_Statement := new Return_Statement'(obj);
      return Generic_Statement_Ptr (New_Return_Statement);
   end Copy;

   function Copy
     (obj  : in Return_Statement_Ptr)
      return Generic_Statement_Ptr
   is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Return_Statement) is
   begin
      Put (Generic_Statement (obj));
      Put ("Return_Value: ");
      if obj.Return_Value /= null then
         Put (obj.Return_Value.all);
      else
         Put ("null");
      end if;
      Put ("; ");
   end Put;

   procedure Put (obj : in Return_Statement_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Return_Statement_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Return_Statement) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name
     (obj  : in Return_Statement_Ptr)
      return Unbounded_String
   is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Return_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Statement (obj), level, result);

   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Return_Statement;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Return_Statement id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Return_Statement>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= While_Statement =--------

   procedure Initialize (obj : in out While_Statement) is
   begin
      Initialize (Generic_Statement (obj));
      obj.Statement_Type := While_Statement_Type;
   end Initialize;

   function Copy (obj : in While_Statement) return Generic_Statement_Ptr is
      New_While_Statement : While_Statement_Ptr;
   begin
      New_While_Statement := new While_Statement'(obj);
      return Generic_Statement_Ptr (New_While_Statement);
   end Copy;

   function Copy
     (obj  : in While_Statement_Ptr)
      return Generic_Statement_Ptr
   is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in While_Statement) is
   begin
      Put (Generic_Statement (obj));
      Put ("Included_Statement: ");
      if obj.Included_Statement /= null then
         Put (obj.Included_Statement.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("Condition: ");
      if obj.Condition /= null then
         Put (obj.Condition.all);
      else
         Put ("null");
      end if;
      Put ("; ");
   end Put;

   procedure Put (obj : in While_Statement_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in While_Statement_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in While_Statement) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in While_Statement_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in While_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Statement (obj), level, result);
      if obj.Included_Statement /= null then
         result := result &
                   ASCII.HT &
                   "<Included_Statement ref=""" &
                   Get_Name (obj.Included_Statement) &
                   """ />" &
                   Unbounded_Lf;
      else
         result := result &
                   ASCII.HT &
                   "<Included_Statement> </Included_Statement>" &
                   Unbounded_Lf;
      end if;

   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in While_Statement;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<While_Statement id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</While_Statement>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Random_Initialize_Statement =--------

   procedure Initialize (obj : in out Random_Initialize_Statement) is
   begin
      Initialize (Generic_Statement (obj));
      obj.Lvalue         := Empty_String;
      obj.Law            := Uniform_Law_Type;
      obj.Statement_Type := Random_Initialize_Statement_Type;
   end Initialize;

   function Copy
     (obj  : in Random_Initialize_Statement)
      return Generic_Statement_Ptr
   is
      New_Random_Initialize_Statement : Random_Initialize_Statement_Ptr;
   begin
      New_Random_Initialize_Statement :=
        new Random_Initialize_Statement'(obj);
      return Generic_Statement_Ptr (New_Random_Initialize_Statement);
   end Copy;

   function Copy
     (obj  : in Random_Initialize_Statement_Ptr)
      return Generic_Statement_Ptr
   is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Random_Initialize_Statement) is
   begin
      Put (Generic_Statement (obj));
      Put ("Lvalue: ");
      Put (obj.Lvalue);
      Put ("; ");
      Put ("Law: ");
      Put (obj.Law);
      Put ("; ");
      Put ("Parameter1: ");
      if obj.Parameter1 /= null then
         Put (obj.Parameter1.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("Parameter2: ");
      if obj.Parameter2 /= null then
         Put (obj.Parameter2.all);
      else
         Put ("null");
      end if;
      Put ("; ");
   end Put;

   procedure Put (obj : in Random_Initialize_Statement_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Random_Initialize_Statement_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name
     (obj  : in Random_Initialize_Statement)
      return Unbounded_String
   is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name
     (obj  : in Random_Initialize_Statement_Ptr)
      return Unbounded_String
   is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Random_Initialize_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Statement (obj), level, result);
      result := result &
                ASCII.HT &
                "<Lvalue> " &
                XML_String (obj.Lvalue, level) &
                " </Lvalue>" &
                Unbounded_Lf;
      --result := result & ASCII.HT & "<Law> " & XML_String(obj.Law, level) &
      --" </Law>" & Unbounded_Lf;

   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Random_Initialize_Statement;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Random_Initialize_Statement id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Random_Initialize_Statement>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Set_Statement =--------

   procedure Initialize (obj : in out Set_Statement) is
   begin
      Initialize (Generic_Statement (obj));
      obj.Set_Id         := Empty_String;
      obj.Statement_Type := Set_Statement_Type;
   end Initialize;

   function Copy (obj : in Set_Statement) return Generic_Statement_Ptr is
      New_Set_Statement : Set_Statement_Ptr;
   begin
      New_Set_Statement := new Set_Statement'(obj);
      return Generic_Statement_Ptr (New_Set_Statement);
   end Copy;

   function Copy (obj : in Set_Statement_Ptr) return Generic_Statement_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Set_Statement) is
   begin
      Put (Generic_Statement (obj));
      Put ("Set_Id: ");
      Put (obj.Set_Id);
      Put ("; ");
      Put ("Set_Value: ");
      if obj.Set_Value /= null then
         Put (obj.Set_Value.all);
      else
         Put ("null");
      end if;
      Put ("; ");
   end Put;

   procedure Put (obj : in Set_Statement_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Set_Statement_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Set_Statement) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Set_Statement_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Set_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Statement (obj), level, result);
      result := result &
                ASCII.HT &
                "<Set_Id> " &
                XML_String (obj.Set_Id, level) &
                " </Set_Id>" &
                Unbounded_Lf;

   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Set_Statement;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Set_Statement id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Set_Statement>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Subprogram_Statement =--------

   procedure Initialize (obj : in out Subprogram_Statement) is
   begin
      Initialize (Generic_Statement (obj));
      obj.Is_A_Function   := False;
      obj.Subprogram_Name := Empty_String;
      obj.Statement_Type  := Subprogram_Statement_Type;
   end Initialize;

   function Copy
     (obj  : in Subprogram_Statement)
      return Generic_Statement_Ptr
   is
      New_Subprogram_Statement : Subprogram_Statement_Ptr;
   begin
      New_Subprogram_Statement := new Subprogram_Statement'(obj);
      return Generic_Statement_Ptr (New_Subprogram_Statement);
   end Copy;

   function Copy
     (obj  : in Subprogram_Statement_Ptr)
      return Generic_Statement_Ptr
   is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Subprogram_Statement) is
   begin
      Put (Generic_Statement (obj));
      Put ("Included_Statement: ");
      if obj.Included_Statement /= null then
         Put (obj.Included_Statement.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("Is_A_Function: ");
      Standards_Io.Boolean_Io.Put (obj.Is_A_Function);
      Put ("; ");
      Put ("Subprogram_Name: ");
      Put (obj.Subprogram_Name);
      Put ("; ");
   end Put;

   procedure Put (obj : in Subprogram_Statement_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Subprogram_Statement_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name
     (obj  : in Subprogram_Statement)
      return Unbounded_String
   is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name
     (obj  : in Subprogram_Statement_Ptr)
      return Unbounded_String
   is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Subprogram_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Statement (obj), level, result);

      result := result &
                ASCII.HT &
                "<Is_A_Function> " &
                XML_String (obj.Is_A_Function, level) &
                " </Is_A_Function>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Subprogram_Name> " &
                XML_String (obj.Subprogram_Name, level) &
                " </Subprogram_Name>" &
                Unbounded_Lf;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Subprogram_Statement;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Subprogram_Statement id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Subprogram_Statement>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Subprogram_Call_Statement =--------

   procedure Initialize (obj : in out Subprogram_Call_Statement) is
   begin
      Initialize (Generic_Statement (obj));
      obj.Is_A_Function  := False;
      obj.Statement_Type := Subprogram_Call_Statement_Type;
   end Initialize;

   function Copy
     (obj  : in Subprogram_Call_Statement)
      return Generic_Statement_Ptr
   is
      New_Subprogram_Call_Statement : Subprogram_Call_Statement_Ptr;
   begin
      New_Subprogram_Call_Statement := new Subprogram_Call_Statement'(obj);
      return Generic_Statement_Ptr (New_Subprogram_Call_Statement);
   end Copy;

   function Copy
     (obj  : in Subprogram_Call_Statement_Ptr)
      return Generic_Statement_Ptr
   is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Subprogram_Call_Statement) is
   begin
      Put (Generic_Statement (obj));
      Put ("Is_A_Function: ");
      Standards_Io.Boolean_Io.Put (obj.Is_A_Function);
      Put ("; ");
      Put ("Called_Subprogram: ");
      if obj.Called_Subprogram /= null then
         Put (obj.Called_Subprogram.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("Return_Value: ");
      if obj.Return_Value /= null then
         Put (obj.Return_Value.all);
      else
         Put ("null");
      end if;
      Put ("; ");
   end Put;

   procedure Put (obj : in Subprogram_Call_Statement_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Subprogram_Call_Statement_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name
     (obj  : in Subprogram_Call_Statement)
      return Unbounded_String
   is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name
     (obj  : in Subprogram_Call_Statement_Ptr)
      return Unbounded_String
   is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Subprogram_Call_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Statement (obj), level, result);

   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Subprogram_Call_Statement;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Subprogram_Call_Statement id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Subprogram_Call_Statement>" & Unbounded_Lf;
      return (result);
   end XML_String;

end Statements;
