------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with Convert_Strings;

with Convert_Unbounded_Strings;

with Text_IO; use Text_IO;

with Standards_Io; use Standards_Io;

use Standards_Io.Natural_Io;

with Objects; use Objects;

with Unchecked_Deallocation;

with Expressions; use Expressions;

with Laws; use Laws;

use Laws.Laws_Type_io;

use Standards_Io.Boolean_Io;

package Statements is

   type Statements_Type is (
      Put_Statement_Type,
      Nop_Statement_Type,
      Exit_Statement_Type,
      If_Statement_Type,
      Assign_Statement_Type,
      For_Statement_Type,
      Return_Statement_Type,
      While_Statement_Type,
      Set_Statement_Type,
      Clock_Statement_Type,
      Subprogram_Statement_Type,
      Subprogram_Call_Statement_Type,
      Random_Initialize_Statement_Type);

   procedure To_Statements_Type is new Convert_Strings (
      Statements_Type,
      Put_Statement_Type);
   procedure To_Statements_Type is new Convert_Unbounded_Strings (
      Statements_Type,
      Put_Statement_Type);
   function XML_String
     (e     : in Statements_Type;
      level : in Natural := 0)
      return  Unbounded_String;
   package Statements_Type_io is new Text_IO.Enumeration_IO (
      Statements_Type);
   use Statements_Type_io;

   type Table_Types is (
      Task_Table_Type,
      Message_Table_Type,
      Processor_Table_Type,
      Buffer_Table_Type,
      Time_Unit_Table_Type,
      Resource_Table_Type);

   procedure To_Table_Types is new Convert_Strings (
      Table_Types,
      Task_Table_Type);
   procedure To_Table_Types is new Convert_Unbounded_Strings (
      Table_Types,
      Task_Table_Type);
   function XML_String
     (e     : in Table_Types;
      level : in Natural := 0)
      return  Unbounded_String;
   package Table_Types_io is new Text_IO.Enumeration_IO (Table_Types);
   use Table_Types_io;

   -- --------= Generic_Statement =--------

   type Generic_Statement;
   type Generic_Statement_Ptr is access all Generic_Statement'Class;
   type Generic_Statement is new Generic_Object with record
      Statement_Type : Statements_Type;
      Line_Number    : Natural;
      File_Name      : Unbounded_String;
      Next_Statement : Generic_Statement_Ptr;
   end record;

   procedure Initialize (obj : in out Generic_Statement);
   procedure Put (obj : in Generic_Statement);
   procedure Put (obj : in Generic_Statement_Ptr);
   procedure Put_Name (obj : in Generic_Statement_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Generic_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Generic_Statement;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Generic_Statement) return Unbounded_String;
   function Get_Name
     (obj  : in Generic_Statement_Ptr)
      return Unbounded_String;
   function Copy
     (obj  : in Generic_Statement_Ptr)
      return Generic_Statement_Ptr;
   function Copy (obj : in Generic_Statement) return Generic_Statement_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Generic_Statement'Class,
      Generic_Statement_Ptr);

   -- --------= Nop_Statement =--------

   type Nop_Statement;
   type Nop_Statement_Ptr is access all Nop_Statement'Class;
   type Nop_Statement is new Generic_Statement with null record;

   procedure Initialize (obj : in out Nop_Statement);
   procedure Put (obj : in Nop_Statement);
   procedure Put (obj : in Nop_Statement_Ptr);
   procedure Put_Name (obj : in Nop_Statement_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Nop_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Nop_Statement;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Nop_Statement) return Unbounded_String;
   function Get_Name (obj : in Nop_Statement_Ptr) return Unbounded_String;
   function Copy (obj : in Nop_Statement_Ptr) return Generic_Statement_Ptr;
   function Copy (obj : in Nop_Statement) return Generic_Statement_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Nop_Statement'Class,
      Nop_Statement_Ptr);

   -- --------= Exit_Statement =--------

   type Exit_Statement;
   type Exit_Statement_Ptr is access all Exit_Statement'Class;
   type Exit_Statement is new Generic_Statement with null record;

   procedure Initialize (obj : in out Exit_Statement);
   procedure Put (obj : in Exit_Statement);
   procedure Put (obj : in Exit_Statement_Ptr);
   procedure Put_Name (obj : in Exit_Statement_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Exit_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Exit_Statement;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Exit_Statement) return Unbounded_String;
   function Get_Name (obj : in Exit_Statement_Ptr) return Unbounded_String;
   function Copy (obj : in Exit_Statement_Ptr) return Generic_Statement_Ptr;
   function Copy (obj : in Exit_Statement) return Generic_Statement_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Exit_Statement'Class,
      Exit_Statement_Ptr);

   -- --------= Put_Statement =--------

   type Put_Statement;
   type Put_Statement_Ptr is access all Put_Statement'Class;
   type Put_Statement is new Generic_Statement with record
      Put_From                   : Generic_Expression_Ptr;
      Put_To                     : Generic_Expression_Ptr;
      Expression_To_Be_displayed : Generic_Expression_Ptr;
   end record;

   procedure Initialize (obj : in out Put_Statement);
   procedure Put (obj : in Put_Statement);
   procedure Put (obj : in Put_Statement_Ptr);
   procedure Put_Name (obj : in Put_Statement_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Put_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Put_Statement;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Put_Statement) return Unbounded_String;
   function Get_Name (obj : in Put_Statement_Ptr) return Unbounded_String;
   function Copy (obj : in Put_Statement_Ptr) return Generic_Statement_Ptr;
   function Copy (obj : in Put_Statement) return Generic_Statement_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Put_Statement'Class,
      Put_Statement_Ptr);

   -- --------= If_Statement =--------

   type If_Statement;
   type If_Statement_Ptr is access all If_Statement'Class;
   type If_Statement is new Generic_Statement with record
      Bool_Expression : Generic_Expression_Ptr;
      Else_Statement  : Generic_Statement_Ptr;
      Then_Statement  : Generic_Statement_Ptr;
   end record;

   procedure Initialize (obj : in out If_Statement);
   procedure Put (obj : in If_Statement);
   procedure Put (obj : in If_Statement_Ptr);
   procedure Put_Name (obj : in If_Statement_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in If_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in If_Statement;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in If_Statement) return Unbounded_String;
   function Get_Name (obj : in If_Statement_Ptr) return Unbounded_String;
   function Copy (obj : in If_Statement_Ptr) return Generic_Statement_Ptr;
   function Copy (obj : in If_Statement) return Generic_Statement_Ptr;
   procedure Free is new Unchecked_Deallocation (
      If_Statement'Class,
      If_Statement_Ptr);

   -- --------= Assign_Statement =--------

   type Assign_Statement;
   type Assign_Statement_Ptr is access all Assign_Statement'Class;
   type Assign_Statement is new Generic_Statement with record
      Lvalue : Generic_Expression_Ptr;
      Rvalue : Generic_Expression_Ptr;
   end record;

   procedure Initialize (obj : in out Assign_Statement);
   procedure Put (obj : in Assign_Statement);
   procedure Put (obj : in Assign_Statement_Ptr);
   procedure Put_Name (obj : in Assign_Statement_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Assign_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Assign_Statement;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Assign_Statement) return Unbounded_String;
   function Get_Name
     (obj  : in Assign_Statement_Ptr)
      return Unbounded_String;
   function Copy
     (obj  : in Assign_Statement_Ptr)
      return Generic_Statement_Ptr;
   function Copy (obj : in Assign_Statement) return Generic_Statement_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Assign_Statement'Class,
      Assign_Statement_Ptr);

   -- --------= Clock_Statement =--------

   type Clock_Statement;
   type Clock_Statement_Ptr is access all Clock_Statement'Class;
   type Clock_Statement is new Assign_Statement with null record;

   procedure Initialize (obj : in out Clock_Statement);
   procedure Put (obj : in Clock_Statement);
   procedure Put (obj : in Clock_Statement_Ptr);
   procedure Put_Name (obj : in Clock_Statement_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Clock_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Clock_Statement;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Clock_Statement) return Unbounded_String;
   function Get_Name (obj : in Clock_Statement_Ptr) return Unbounded_String;
   function Copy
     (obj  : in Clock_Statement_Ptr)
      return Generic_Statement_Ptr;
   function Copy (obj : in Clock_Statement) return Generic_Statement_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Clock_Statement'Class,
      Clock_Statement_Ptr);

   -- --------= For_Statement =--------

   type For_Statement;
   type For_Statement_Ptr is access all For_Statement'Class;
   type For_Statement is new Generic_Statement with record
      For_Type           : Table_Types;
      Included_Statement : Generic_Statement_Ptr;
      For_Index          : Variable_Expression_Ptr;
   end record;

   procedure Initialize (obj : in out For_Statement);
   procedure Put (obj : in For_Statement);
   procedure Put (obj : in For_Statement_Ptr);
   procedure Put_Name (obj : in For_Statement_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in For_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in For_Statement;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in For_Statement) return Unbounded_String;
   function Get_Name (obj : in For_Statement_Ptr) return Unbounded_String;
   function Copy (obj : in For_Statement_Ptr) return Generic_Statement_Ptr;
   function Copy (obj : in For_Statement) return Generic_Statement_Ptr;
   procedure Free is new Unchecked_Deallocation (
      For_Statement'Class,
      For_Statement_Ptr);

   -- --------= Return_Statement =--------

   type Return_Statement;
   type Return_Statement_Ptr is access all Return_Statement'Class;
   type Return_Statement is new Generic_Statement with record
      Return_Value : Generic_Expression_Ptr;
   end record;

   procedure Initialize (obj : in out Return_Statement);
   procedure Put (obj : in Return_Statement);
   procedure Put (obj : in Return_Statement_Ptr);
   procedure Put_Name (obj : in Return_Statement_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Return_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Return_Statement;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Return_Statement) return Unbounded_String;
   function Get_Name
     (obj  : in Return_Statement_Ptr)
      return Unbounded_String;
   function Copy
     (obj  : in Return_Statement_Ptr)
      return Generic_Statement_Ptr;
   function Copy (obj : in Return_Statement) return Generic_Statement_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Return_Statement'Class,
      Return_Statement_Ptr);

   -- --------= While_Statement =--------

   type While_Statement;
   type While_Statement_Ptr is access all While_Statement'Class;
   type While_Statement is new Generic_Statement with record
      Included_Statement : Generic_Statement_Ptr;
      Condition          : Generic_Expression_Ptr;
   end record;

   procedure Initialize (obj : in out While_Statement);
   procedure Put (obj : in While_Statement);
   procedure Put (obj : in While_Statement_Ptr);
   procedure Put_Name (obj : in While_Statement_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in While_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in While_Statement;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in While_Statement) return Unbounded_String;
   function Get_Name (obj : in While_Statement_Ptr) return Unbounded_String;
   function Copy
     (obj  : in While_Statement_Ptr)
      return Generic_Statement_Ptr;
   function Copy (obj : in While_Statement) return Generic_Statement_Ptr;
   procedure Free is new Unchecked_Deallocation (
      While_Statement'Class,
      While_Statement_Ptr);

   -- --------= Random_Initialize_Statement =--------

   type Random_Initialize_Statement;
   type Random_Initialize_Statement_Ptr is access all 
     Random_Initialize_Statement'Class;
   type Random_Initialize_Statement is new Generic_Statement with record
      Lvalue     : Unbounded_String;
      Law        : Laws_Type;
      Parameter1 : Generic_Expression_Ptr;
      Parameter2 : Generic_Expression_Ptr;
   end record;

   procedure Initialize (obj : in out Random_Initialize_Statement);
   procedure Put (obj : in Random_Initialize_Statement);
   procedure Put (obj : in Random_Initialize_Statement_Ptr);
   procedure Put_Name (obj : in Random_Initialize_Statement_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Random_Initialize_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Random_Initialize_Statement;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name
     (obj  : in Random_Initialize_Statement)
      return Unbounded_String;
   function Get_Name
     (obj  : in Random_Initialize_Statement_Ptr)
      return Unbounded_String;
   function Copy
     (obj  : in Random_Initialize_Statement_Ptr)
      return Generic_Statement_Ptr;
   function Copy
     (obj  : in Random_Initialize_Statement)
      return Generic_Statement_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Random_Initialize_Statement'Class,
      Random_Initialize_Statement_Ptr);

   -- --------= Set_Statement =--------

   type Set_Statement;
   type Set_Statement_Ptr is access all Set_Statement'Class;
   type Set_Statement is new Generic_Statement with record
      Set_Id    : Unbounded_String;
      Set_Value : Generic_Expression_Ptr;
   end record;

   procedure Initialize (obj : in out Set_Statement);
   procedure Put (obj : in Set_Statement);
   procedure Put (obj : in Set_Statement_Ptr);
   procedure Put_Name (obj : in Set_Statement_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Set_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Set_Statement;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Set_Statement) return Unbounded_String;
   function Get_Name (obj : in Set_Statement_Ptr) return Unbounded_String;
   function Copy (obj : in Set_Statement_Ptr) return Generic_Statement_Ptr;
   function Copy (obj : in Set_Statement) return Generic_Statement_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Set_Statement'Class,
      Set_Statement_Ptr);

   -- --------= Subprogram_Statement =--------

   type Subprogram_Statement;
   type Subprogram_Statement_Ptr is access all Subprogram_Statement'Class;
   type Subprogram_Statement is new Generic_Statement with record
      Included_Statement : Generic_Statement_Ptr;
      Is_A_Function      : Boolean;
      Subprogram_Name    : Unbounded_String;
   end record;

   procedure Initialize (obj : in out Subprogram_Statement);
   procedure Put (obj : in Subprogram_Statement);
   procedure Put (obj : in Subprogram_Statement_Ptr);
   procedure Put_Name (obj : in Subprogram_Statement_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Subprogram_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Subprogram_Statement;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name
     (obj  : in Subprogram_Statement)
      return Unbounded_String;
   function Get_Name
     (obj  : in Subprogram_Statement_Ptr)
      return Unbounded_String;
   function Copy
     (obj  : in Subprogram_Statement_Ptr)
      return Generic_Statement_Ptr;
   function Copy
     (obj  : in Subprogram_Statement)
      return Generic_Statement_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Subprogram_Statement'Class,
      Subprogram_Statement_Ptr);

   -- --------= Subprogram_Call_Statement =--------

   type Subprogram_Call_Statement;
   type Subprogram_Call_Statement_Ptr is access all Subprogram_Call_Statement'
     Class;
   type Subprogram_Call_Statement is new Generic_Statement with record
      Is_A_Function     : Boolean;
      Called_Subprogram : Generic_Statement_Ptr;
      Return_Value      : Generic_Expression_Ptr;
   end record;

   procedure Initialize (obj : in out Subprogram_Call_Statement);
   procedure Put (obj : in Subprogram_Call_Statement);
   procedure Put (obj : in Subprogram_Call_Statement_Ptr);
   procedure Put_Name (obj : in Subprogram_Call_Statement_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Subprogram_Call_Statement;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Subprogram_Call_Statement;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name
     (obj  : in Subprogram_Call_Statement)
      return Unbounded_String;
   function Get_Name
     (obj  : in Subprogram_Call_Statement_Ptr)
      return Unbounded_String;
   function Copy
     (obj  : in Subprogram_Call_Statement_Ptr)
      return Generic_Statement_Ptr;
   function Copy
     (obj  : in Subprogram_Call_Statement)
      return Generic_Statement_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Subprogram_Call_Statement'Class,
      Subprogram_Call_Statement_Ptr);

end Statements;
