------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with Ada.Strings.Unbounded.Text_IO; use Ada.Strings.Unbounded.Text_IO;

with Text_IO; use Text_IO;

with primitive_xml_strings; use primitive_xml_strings;

package body Processors is

   -- --------= Processor =--------

   procedure Initialize (obj : in out Processor) is
   begin
      Initialize (Generic_Object (obj));
      obj.Network     := Empty_String;
      obj.Object_Type := Processor_Object_Type;
   end Initialize;

   function Copy (obj : in Processor) return Processor_Ptr is
      New_Processor : Processor_Ptr;
   begin
      New_Processor := new Processor'(obj);
      return Processor_Ptr (New_Processor);
   end Copy;

   function Copy (obj : in Processor_Ptr) return Processor_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Processor) is
   begin
      Put (Generic_Object (obj));
      Put ("Scheduler: ");
      if obj.Scheduler /= null then
         Put (obj.Scheduler.all);
      else
         Put ("null");
      end if;
      Put ("; ");
      Put ("Network: ");
      Put (obj.Network);
      Put ("; ");
   end Put;

   procedure Put (obj : in Processor_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Processor_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Processor) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Processor_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Processor;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Object (obj), level, result);
      if obj.Scheduler /= null then
         result := result &
                   ASCII.HT &
                   "<Scheduler ref=""" &
                   Get_Name (obj.Scheduler) &
                   """ />" &
                   Unbounded_Lf;
      else
         result := result &
                   ASCII.HT &
                   "<Scheduler> </Scheduler>" &
                   Unbounded_Lf;
      end if;
      result := result &
                ASCII.HT &
                "<Network> " &
                XML_String (obj.Network, level) &
                " </Network>" &
                Unbounded_Lf;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Processor;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Processor id=""" & Get_Name (obj) & """ >" & Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Processor>" & Unbounded_Lf;
      return (result);
   end XML_String;

end Processors;
