------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Scheduler;             use Scheduler;
use Scheduler.Double_Tasks_Parameters;
with Systems;               use Systems;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

package Random_Scheduling is

   -- constant
   Nb_Job_Per_Task_Max : Natural := 500;

   -- type definition
   type Response_Table_Set is
     array (1 .. Nb_Job_Per_Task_Max) of Response_Time_Table;

   -- display an array of respone time table
   procedure Put
     (Res_Time_Set    : in Response_Table_Set;
      Nb_Res_Time_Set : in Natural);

   -- generate random response time Nb_Rand_scheduling time for system sys
   procedure Random_Buff_Size_Plot
     (Nb_Rand_Scheduling : Natural;
      Nb_Base_Period     : Natural;
      Save_Response      : Boolean;
      Save_Buff_Response : Natural;
      Save_File_Name     : Unbounded_String;
      Sys                : System);

end Random_Scheduling;
