------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with primitive_xml_strings; use primitive_xml_strings;

with Ada.Strings.Unbounded.Text_IO; use Ada.Strings.Unbounded.Text_IO;

with Text_IO; use Text_IO;

package body Resources is

   function XML_String
     (e     : in Resources_Type;
      level : in Natural := 0)
      return  Unbounded_String
   is
   begin
      return To_Unbounded_String (Resources_Type'Image (e));
   end XML_String;

   -- --------= Affected_Task_Lists =--------

   procedure Initialize (obj : out Affected_Task_Lists) is
   begin
      obj.Task_Begin := 0;
      obj.Task_End   := 0;
   end Initialize;

   procedure Put (obj : in Affected_Task_Lists) is
   begin
      Put ("Task_Begin: ");
      Standards_Io.Natural_Io.Put (obj.Task_Begin);
      Put ("; ");
      Put ("Task_End: ");
      Standards_Io.Natural_Io.Put (obj.Task_End);
      Put ("; ");
   end Put;

   procedure Put (obj : in Affected_Task_Lists_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Build_Attributes_XML_String
     (obj    : in Affected_Task_Lists;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      result := result &
                ASCII.HT &
                "<Task_Begin> " &
                XML_String (obj.Task_Begin, level) &
                " </Task_Begin>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Task_End> " &
                XML_String (obj.Task_End, level) &
                " </Task_End>" &
                Unbounded_Lf;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Affected_Task_Lists;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Affected_Task_Lists>" & Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Affected_Task_Lists>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Generic_Resource =--------

   procedure Initialize (obj : in out Generic_Resource) is
   begin
      Initialize (Generic_Object (obj));
      obj.state    := 0;
      obj.protocol := No_Protocol;
      Initialize (obj.task_tab);
      obj.cpu_name           := Empty_String;
      obj.Address_Space_Name := Empty_String;
      obj.Object_Type        := Resource_Object_Type;
   end Initialize;

   function Copy (obj : in Generic_Resource) return Generic_Resource_Ptr is
      New_Generic_Resource : Generic_Resource_Ptr;
   begin
      New_Generic_Resource := new Generic_Resource'(obj);
      return Generic_Resource_Ptr (New_Generic_Resource);
   end Copy;

   function Copy
     (obj  : in Generic_Resource_Ptr)
      return Generic_Resource_Ptr
   is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Generic_Resource) is
   begin
      Put (Generic_Object (obj));
      Put ("state: ");
      Standards_Io.Integer_Io.Put (obj.state);
      Put ("; ");
      Put ("protocol: ");
      Put (obj.protocol);
      Put ("; ");
      Put ("task_tab: ");
      Put (obj.task_tab);
      Put ("; ");
      Put ("cpu_name: ");
      Put (obj.cpu_name);
      Put ("; ");
      Put ("Address_Space_Name: ");
      Put (obj.Address_Space_Name);
      Put ("; ");
   end Put;

   procedure Put (obj : in Generic_Resource_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Generic_Resource_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Generic_Resource) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name
     (obj  : in Generic_Resource_Ptr)
      return Unbounded_String
   is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Generic_Resource;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Object (obj), level, result);
      result := result &
                ASCII.HT &
                "<state> " &
                XML_String (obj.state, level) &
                " </state>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<protocol> " &
                XML_String (obj.protocol, level) &
                " </protocol>" &
                Unbounded_Lf;
      --	result := result & ASCII.HT & "<task_tab> " &
      --XML_String(obj.task_tab, level) & " </task_tab>" & Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<cpu_name> " &
                XML_String (obj.cpu_name, level) &
                " </cpu_name>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Address_Space_Name> " &
                XML_String (obj.Address_Space_Name, level) &
                " </Address_Space_Name>" &
                Unbounded_Lf;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Generic_Resource;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Generic_Resource id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Generic_Resource>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Np_Resource =--------

   procedure Initialize (obj : in out Np_Resource) is
   begin
      Initialize (Generic_Resource (obj));
   end Initialize;

   function Copy (obj : in Np_Resource) return Generic_Resource_Ptr is
      New_Np_Resource : Np_Resource_Ptr;
   begin
      New_Np_Resource := new Np_Resource'(obj);
      return Generic_Resource_Ptr (New_Np_Resource);
   end Copy;

   function Copy (obj : in Np_Resource_Ptr) return Generic_Resource_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Np_Resource) is
   begin
      Put (Generic_Resource (obj));
   end Put;

   procedure Put (obj : in Np_Resource_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Np_Resource_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Np_Resource) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Np_Resource_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Np_Resource;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Resource (obj), level, result);
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Np_Resource;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Np_Resource id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Np_Resource>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Pip_Resource =--------

   procedure Initialize (obj : in out Pip_Resource) is
   begin
      Initialize (Generic_Resource (obj));
      obj.protocol := Priority_Inheritance_Protocol;
   end Initialize;

   function Copy (obj : in Pip_Resource) return Generic_Resource_Ptr is
      New_Pip_Resource : Pip_Resource_Ptr;
   begin
      New_Pip_Resource := new Pip_Resource'(obj);
      return Generic_Resource_Ptr (New_Pip_Resource);
   end Copy;

   function Copy (obj : in Pip_Resource_Ptr) return Generic_Resource_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Pip_Resource) is
   begin
      Put (Generic_Resource (obj));
   end Put;

   procedure Put (obj : in Pip_Resource_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Pip_Resource_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Pip_Resource) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Pip_Resource_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Pip_Resource;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Resource (obj), level, result);
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Pip_Resource;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Pip_Resource id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Pip_Resource>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Pcp_Resource =--------

   procedure Initialize (obj : in out Pcp_Resource) is
   begin
      Initialize (Generic_Resource (obj));
      obj.protocol := Priority_Ceiling_Protocol;
   end Initialize;

   function Copy (obj : in Pcp_Resource) return Generic_Resource_Ptr is
      New_Pcp_Resource : Pcp_Resource_Ptr;
   begin
      New_Pcp_Resource := new Pcp_Resource'(obj);
      return Generic_Resource_Ptr (New_Pcp_Resource);
   end Copy;

   function Copy (obj : in Pcp_Resource_Ptr) return Generic_Resource_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Pcp_Resource) is
   begin
      Put (Generic_Resource (obj));
   end Put;

   procedure Put (obj : in Pcp_Resource_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Pcp_Resource_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Pcp_Resource) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Pcp_Resource_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Pcp_Resource;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Resource (obj), level, result);
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Pcp_Resource;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Pcp_Resource id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Pcp_Resource>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= IPcp_Resource =--------

   procedure Initialize (obj : in out IPcp_Resource) is
   begin
      Initialize (Generic_Resource (obj));
      obj.protocol := Immediate_Priority_Ceiling_Protocol;
   end Initialize;

   function Copy (obj : in IPcp_Resource) return Generic_Resource_Ptr is
      New_IPcp_Resource : IPcp_Resource_Ptr;
   begin
      New_IPcp_Resource := new IPcp_Resource'(obj);
      return Generic_Resource_Ptr (New_IPcp_Resource);
   end Copy;

   function Copy (obj : in IPcp_Resource_Ptr) return Generic_Resource_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in IPcp_Resource) is
   begin
      Put (Generic_Resource (obj));
   end Put;

   procedure Put (obj : in IPcp_Resource_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in IPcp_Resource_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in IPcp_Resource) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in IPcp_Resource_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in IPcp_Resource;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Resource (obj), level, result);
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in IPcp_Resource;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<IPcp_Resource id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</IPcp_Resource>" & Unbounded_Lf;
      return (result);
   end XML_String;

end Resources;
