------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with Standards_Io; use Standards_Io;

use Standards_Io.Natural_Io;

with Indexed_Tables;

with Ada.Strings.Unbounded.Text_IO; use Ada.Strings.Unbounded.Text_IO;

with Framework_Config; use Framework_Config;

use Standards_Io.Integer_Io;

with Convert_Strings;

with Convert_Unbounded_Strings;

with Text_IO; use Text_IO;

with Objects; use Objects;

with Unchecked_Deallocation;

package Resources is

   type Resources_Type is (
      No_Protocol,
      Priority_Ceiling_Protocol,
      Priority_Inheritance_Protocol,
      Immediate_Priority_Ceiling_Protocol);

   procedure To_Resources_Type is new Convert_Strings (
      Resources_Type,
      No_Protocol);
   procedure To_Resources_Type is new Convert_Unbounded_Strings (
      Resources_Type,
      No_Protocol);
   function XML_String
     (e     : in Resources_Type;
      level : in Natural := 0)
      return  Unbounded_String;
   package Resources_Type_io is new Text_IO.Enumeration_IO (Resources_Type);
   use Resources_Type_io;

   -- --------= Affected_Task_Lists =--------

   type Affected_Task_Lists is record
      Task_Begin : Natural;
      Task_End   : Natural;
   end record;

   type Affected_Task_Lists_Ptr is access all Affected_Task_Lists;

   procedure Initialize (obj : out Affected_Task_Lists);
   procedure Put (obj : in Affected_Task_Lists);
   procedure Put (obj : in Affected_Task_Lists_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Affected_Task_Lists;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Affected_Task_Lists;
      level : in Natural := 0)
      return  Unbounded_String;

   package Task_Lists is new Indexed_Tables (
      Affected_Task_Lists,
      Unbounded_String,
      Framework_Config.Max_Tasks_For_A_Resource,
      0,
      Put,
      Initialize,
      Put);
   use Task_Lists;

   subtype Task_Lists_Table is Task_Lists.Indexed_Table;

   subtype Task_Lists_Range is Task_Lists.Indexed_Table_Range;

   type Start_End_Table is array (Task_Lists_Range) of Affected_Task_Lists;

   -- --------= Generic_Resource =--------

   type Generic_Resource;
   type Generic_Resource_Ptr is access all Generic_Resource'Class;
   type Generic_Resource is new Generic_Object with record
      state              : Integer;
      protocol           : Resources_Type;
      task_tab           : Task_Lists_Table;
      cpu_name           : Unbounded_String;
      Address_Space_Name : Unbounded_String;
   end record;

   procedure Initialize (obj : in out Generic_Resource);
   procedure Put (obj : in Generic_Resource);
   procedure Put (obj : in Generic_Resource_Ptr);
   procedure Put_Name (obj : in Generic_Resource_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Generic_Resource;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Generic_Resource;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Generic_Resource) return Unbounded_String;
   function Get_Name
     (obj  : in Generic_Resource_Ptr)
      return Unbounded_String;
   function Copy
     (obj  : in Generic_Resource_Ptr)
      return Generic_Resource_Ptr;
   function Copy (obj : in Generic_Resource) return Generic_Resource_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Generic_Resource'Class,
      Generic_Resource_Ptr);

   -- --------= Np_Resource =--------

   type Np_Resource;
   type Np_Resource_Ptr is access all Np_Resource'Class;
   type Np_Resource is new Generic_Resource with null record;

   procedure Initialize (obj : in out Np_Resource);
   procedure Put (obj : in Np_Resource);
   procedure Put (obj : in Np_Resource_Ptr);
   procedure Put_Name (obj : in Np_Resource_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Np_Resource;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Np_Resource;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Np_Resource) return Unbounded_String;
   function Get_Name (obj : in Np_Resource_Ptr) return Unbounded_String;
   function Copy (obj : in Np_Resource_Ptr) return Generic_Resource_Ptr;
   function Copy (obj : in Np_Resource) return Generic_Resource_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Np_Resource'Class,
      Np_Resource_Ptr);

   -- --------= Pip_Resource =--------

   type Pip_Resource;
   type Pip_Resource_Ptr is access all Pip_Resource'Class;
   type Pip_Resource is new Generic_Resource with null record;

   procedure Initialize (obj : in out Pip_Resource);
   procedure Put (obj : in Pip_Resource);
   procedure Put (obj : in Pip_Resource_Ptr);
   procedure Put_Name (obj : in Pip_Resource_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Pip_Resource;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Pip_Resource;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Pip_Resource) return Unbounded_String;
   function Get_Name (obj : in Pip_Resource_Ptr) return Unbounded_String;
   function Copy (obj : in Pip_Resource_Ptr) return Generic_Resource_Ptr;
   function Copy (obj : in Pip_Resource) return Generic_Resource_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Pip_Resource'Class,
      Pip_Resource_Ptr);

   -- --------= Pcp_Resource =--------

   type Pcp_Resource;
   type Pcp_Resource_Ptr is access all Pcp_Resource'Class;
   type Pcp_Resource is new Generic_Resource with null record;

   procedure Initialize (obj : in out Pcp_Resource);
   procedure Put (obj : in Pcp_Resource);
   procedure Put (obj : in Pcp_Resource_Ptr);
   procedure Put_Name (obj : in Pcp_Resource_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Pcp_Resource;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Pcp_Resource;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Pcp_Resource) return Unbounded_String;
   function Get_Name (obj : in Pcp_Resource_Ptr) return Unbounded_String;
   function Copy (obj : in Pcp_Resource_Ptr) return Generic_Resource_Ptr;
   function Copy (obj : in Pcp_Resource) return Generic_Resource_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Pcp_Resource'Class,
      Pcp_Resource_Ptr);

   -- --------= IPcp_Resource =--------

   type IPcp_Resource;
   type IPcp_Resource_Ptr is access all IPcp_Resource'Class;
   type IPcp_Resource is new Generic_Resource with null record;

   procedure Initialize (obj : in out IPcp_Resource);
   procedure Put (obj : in IPcp_Resource);
   procedure Put (obj : in IPcp_Resource_Ptr);
   procedure Put_Name (obj : in IPcp_Resource_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in IPcp_Resource;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in IPcp_Resource;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in IPcp_Resource) return Unbounded_String;
   function Get_Name (obj : in IPcp_Resource_Ptr) return Unbounded_String;
   function Copy (obj : in IPcp_Resource_Ptr) return Generic_Resource_Ptr;
   function Copy (obj : in IPcp_Resource) return Generic_Resource_Ptr;
   procedure Free is new Unchecked_Deallocation (
      IPcp_Resource'Class,
      IPcp_Resource_Ptr);

end Resources;
