------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with Ada.Strings.Unbounded.Text_IO; use Ada.Strings.Unbounded.Text_IO;

with Text_IO; use Text_IO;

with primitive_xml_strings; use primitive_xml_strings;

package body Sections is

   function XML_String
     (e     : in Sections_Type;
      level : in Natural := 0)
      return  Unbounded_String
   is
   begin
      return To_Unbounded_String (Sections_Type'Image (e));
   end XML_String;

   -- --------= Generic_Section =--------

   procedure Initialize (obj : in out Generic_Section) is
   begin
      Initialize (Generic_Object (obj));
      obj.Section_type := Automaton_Type;
      obj.File_Name    := Empty_String;
      obj.Object_Type  := Section_Object_Type;
   end Initialize;

   function Copy (obj : in Generic_Section) return Generic_Section_Ptr is
      New_Generic_Section : Generic_Section_Ptr;
   begin
      New_Generic_Section := new Generic_Section'(obj);
      return Generic_Section_Ptr (New_Generic_Section);
   end Copy;

   function Copy (obj : in Generic_Section_Ptr) return Generic_Section_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Generic_Section) is
   begin
      Put (Generic_Object (obj));
      Put ("Section_type: ");
      Put (obj.Section_type);
      Put ("; ");
      Put ("File_Name: ");
      Put (obj.File_Name);
      Put ("; ");
   end Put;

   procedure Put (obj : in Generic_Section_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Generic_Section_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Generic_Section) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Generic_Section_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Generic_Section;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Object (obj), level, result);
      result := result &
                ASCII.HT &
                "<Section_type> " &
                XML_String (obj.Section_type, level) &
                " </Section_type>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<File_Name> " &
                XML_String (obj.File_Name, level) &
                " </File_Name>" &
                Unbounded_Lf;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Generic_Section;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Generic_Section id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Generic_Section>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Computation_Section =--------

   procedure Initialize (obj : in out Computation_Section) is
   begin
      Initialize (Generic_Section (obj));
   end Initialize;

   function Copy (obj : in Computation_Section) return Generic_Section_Ptr is
      New_Computation_Section : Computation_Section_Ptr;
   begin
      New_Computation_Section := new Computation_Section'(obj);
      return Generic_Section_Ptr (New_Computation_Section);
   end Copy;

   function Copy
     (obj  : in Computation_Section_Ptr)
      return Generic_Section_Ptr
   is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Computation_Section) is
   begin
      Put (Generic_Section (obj));
      Put ("First_Statement: ");
      if obj.First_Statement /= null then
         Put (obj.First_Statement.all);
      else
         Put ("null");
      end if;
      Put ("; ");
   end Put;

   procedure Put (obj : in Computation_Section_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Computation_Section_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Computation_Section) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name
     (obj  : in Computation_Section_Ptr)
      return Unbounded_String
   is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Computation_Section;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Section (obj), level, result);
      if obj.First_Statement /= null then
         result := result &
                   ASCII.HT &
                   "<First_Statement ref=""" &
                   Get_Name (obj.First_Statement) &
                   """ />" &
                   Unbounded_Lf;
      else
         result := result &
                   ASCII.HT &
                   "<First_Statement> </First_Statement>" &
                   Unbounded_Lf;
      end if;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Computation_Section;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Computation_Section id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Computation_Section>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Synchronization_Section =--------

   procedure Initialize (obj : in out Synchronization_Section) is
   begin
      Initialize (Generic_Section (obj));
      Initialize (obj.State_List);
      Initialize (obj.Transition_List);
   end Initialize;

   function Copy
     (obj  : in Synchronization_Section)
      return Generic_Section_Ptr
   is
      New_Synchronization_Section : Synchronization_Section_Ptr;
   begin
      New_Synchronization_Section := new Synchronization_Section'(obj);
      return Generic_Section_Ptr (New_Synchronization_Section);
   end Copy;

   function Copy
     (obj  : in Synchronization_Section_Ptr)
      return Generic_Section_Ptr
   is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Synchronization_Section) is
   begin
      Put (Generic_Section (obj));
      Put ("State_List: ");
      Put (obj.State_List);
      Put ("; ");
      Put ("Transition_List: ");
      Put (obj.Transition_List);
      Put ("; ");
   end Put;

   procedure Put (obj : in Synchronization_Section_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Synchronization_Section_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name
     (obj  : in Synchronization_Section)
      return Unbounded_String
   is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name
     (obj  : in Synchronization_Section_Ptr)
      return Unbounded_String
   is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Synchronization_Section;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Section (obj), level, result);
      --	result := result & ASCII.HT & "<State_List> " &
      --XML_String(obj.State_List, level) & " </State_List>" & Unbounded_Lf;
      --	result := result & ASCII.HT & "<Transition_List> " &
      --XML_String(obj.Transition_List, level) & " </Transition_List>" &
      --Unbounded_Lf;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Synchronization_Section;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Synchronization_Section id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Synchronization_Section>" & Unbounded_Lf;
      return (result);
   end XML_String;

end Sections;
