------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with Convert_Strings;

with Convert_Unbounded_Strings;

with Text_IO; use Text_IO;

with Objects; use Objects;

with Unchecked_Deallocation;

with Statements; use Statements;

with Automaton; use Automaton;

use Automaton.State_Lists_Package;

use Automaton.Transition_Lists_Package;

package Sections is

   type Sections_Type is (
      Automaton_Type,
      Start_Type,
      Priority_Type,
      Election_Type,
      Activation_Type,
      Check_Resource_Type,
      Allocate_Resource_Type,
      Release_Resource_Type,
      Gather_Event_Analyzer_Type,
      Display_Event_Analyzer_Type);

   procedure To_Sections_Type is new Convert_Strings (
      Sections_Type,
      Automaton_Type);
   procedure To_Sections_Type is new Convert_Unbounded_Strings (
      Sections_Type,
      Automaton_Type);
   function XML_String
     (e     : in Sections_Type;
      level : in Natural := 0)
      return  Unbounded_String;
   package Sections_Type_io is new Text_IO.Enumeration_IO (Sections_Type);
   use Sections_Type_io;

   -- --------= Generic_Section =--------

   type Generic_Section;
   type Generic_Section_Ptr is access all Generic_Section'Class;
   type Generic_Section is new Generic_Object with record
      Section_type : Sections_Type;
      File_Name    : Unbounded_String;
   end record;

   procedure Initialize (obj : in out Generic_Section);
   procedure Put (obj : in Generic_Section);
   procedure Put (obj : in Generic_Section_Ptr);
   procedure Put_Name (obj : in Generic_Section_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Generic_Section;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Generic_Section;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Generic_Section) return Unbounded_String;
   function Get_Name (obj : in Generic_Section_Ptr) return Unbounded_String;
   function Copy (obj : in Generic_Section_Ptr) return Generic_Section_Ptr;
   function Copy (obj : in Generic_Section) return Generic_Section_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Generic_Section'Class,
      Generic_Section_Ptr);

   -- --------= Computation_Section =--------

   type Computation_Section;
   type Computation_Section_Ptr is access all Computation_Section'Class;
   type Computation_Section is new Generic_Section with record
      First_Statement : Generic_Statement_Ptr;
   end record;

   procedure Initialize (obj : in out Computation_Section);
   procedure Put (obj : in Computation_Section);
   procedure Put (obj : in Computation_Section_Ptr);
   procedure Put_Name (obj : in Computation_Section_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Computation_Section;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Computation_Section;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Computation_Section) return Unbounded_String;
   function Get_Name
     (obj  : in Computation_Section_Ptr)
      return Unbounded_String;
   function Copy
     (obj  : in Computation_Section_Ptr)
      return Generic_Section_Ptr;
   function Copy (obj : in Computation_Section) return Generic_Section_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Computation_Section'Class,
      Computation_Section_Ptr);

   -- --------= Synchronization_Section =--------

   type Synchronization_Section;
   type Synchronization_Section_Ptr is access all Synchronization_Section'
     Class;
   type Synchronization_Section is new Generic_Section with record
      State_List      : State_Lists;
      Transition_List : Transition_Lists;
   end record;

   procedure Initialize (obj : in out Synchronization_Section);
   procedure Put (obj : in Synchronization_Section);
   procedure Put (obj : in Synchronization_Section_Ptr);
   procedure Put_Name (obj : in Synchronization_Section_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Synchronization_Section;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Synchronization_Section;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name
     (obj  : in Synchronization_Section)
      return Unbounded_String;
   function Get_Name
     (obj  : in Synchronization_Section_Ptr)
      return Unbounded_String;
   function Copy
     (obj  : in Synchronization_Section_Ptr)
      return Generic_Section_Ptr;
   function Copy
     (obj  : in Synchronization_Section)
      return Generic_Section_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Synchronization_Section'Class,
      Synchronization_Section_Ptr);

end Sections;
