------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with Ada.Strings.Unbounded.Text_IO; use Ada.Strings.Unbounded.Text_IO;

with Text_IO; use Text_IO;

with primitive_xml_strings; use primitive_xml_strings;

package body Tasks is

   function XML_String
     (e     : in Tasks_Type;
      level : in Natural := 0)
      return  Unbounded_String
   is
   begin
      return To_Unbounded_String (Tasks_Type'Image (e));
   end XML_String;

   function XML_String
     (e     : in Policies;
      level : in Natural := 0)
      return  Unbounded_String
   is
   begin
      return To_Unbounded_String (Policies'Image (e));
   end XML_String;

   -- --------= Generic_Task =--------

   procedure Initialize (obj : in out Generic_Task) is
   begin
      Initialize (Generic_Object (obj));
      obj.Task_Type          := Periodic_Type;
      obj.Cpu_Name           := Empty_String;
      obj.Address_Space_Name := Empty_String;
      obj.Capacity           := 0;
      obj.Deadline           := 0;
      obj.Start_Time         := 0;
      obj.Blocking_Time      := 0;
      obj.Policy             := Sched_Fifo;
      obj.X                  := 0;
      obj.Y                  := 0;
      Initialize (obj.Offset);
      obj.Text_Memory_Size  := 0;
      obj.Stack_Memory_Size := 0;
      Initialize (obj.Param);
      obj.Criticality             := 0;
      obj.Context_Switch_Overhead := 0;
      obj.Object_Type             := Task_Object_Type;
   end Initialize;

   function Copy (obj : in Generic_Task) return Generic_Task_Ptr is
      New_Generic_Task : Generic_Task_Ptr;
   begin
      New_Generic_Task := new Generic_Task'(obj);
      return Generic_Task_Ptr (New_Generic_Task);
   end Copy;

   function Copy (obj : in Generic_Task_Ptr) return Generic_Task_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Generic_Task) is
   begin
      Put (Generic_Object (obj));
      Put ("Task_Type: ");
      Put (obj.Task_Type);
      Put ("; ");
      Put ("Cpu_Name: ");
      Put (obj.Cpu_Name);
      Put ("; ");
      Put ("Address_Space_Name: ");
      Put (obj.Address_Space_Name);
      Put ("; ");
      Put ("Capacity: ");
      Standards_Io.Natural_Io.Put (obj.Capacity);
      Put ("; ");
      Put ("Deadline: ");
      Standards_Io.Natural_Io.Put (obj.Deadline);
      Put ("; ");
      Put ("Start_Time: ");
      Standards_Io.Natural_Io.Put (obj.Start_Time);
      Put ("; ");
      Put ("Priority: ");
      Put (obj.Priority);
      Put ("; ");
      Put ("Blocking_Time: ");
      Standards_Io.Natural_Io.Put (obj.Blocking_Time);
      Put ("; ");
      Put ("Policy: ");
      Put (obj.Policy);
      Put ("; ");
      Put ("X: ");
      Standards_Io.Natural_Io.Put (obj.X);
      Put ("; ");
      Put ("Y: ");
      Standards_Io.Natural_Io.Put (obj.Y);
      Put ("; ");
      Put ("Offset: ");
      Put (obj.Offset);
      Put ("; ");
      Put ("Text_Memory_Size: ");
      Standards_Io.Natural_Io.Put (obj.Text_Memory_Size);
      Put ("; ");
      Put ("Stack_Memory_Size: ");
      Standards_Io.Natural_Io.Put (obj.Stack_Memory_Size);
      Put ("; ");
      Put ("Param: ");
      Put (obj.Param);
      Put ("; ");
      Put ("Criticality: ");
      Standards_Io.Natural_Io.Put (obj.Criticality);
      Put ("; ");
      Put ("Context_Switch_Overhead: ");
      Standards_Io.Natural_Io.Put (obj.Context_Switch_Overhead);
      Put ("; ");
   end Put;

   procedure Put (obj : in Generic_Task_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Generic_Task_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Generic_Task) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Generic_Task_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Generic_Task;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Object (obj), level, result);
      result := result &
                ASCII.HT &
                "<Task_Type> " &
                XML_String (obj.Task_Type, level) &
                " </Task_Type>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Cpu_Name> " &
                XML_String (obj.Cpu_Name, level) &
                " </Cpu_Name>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Address_Space_Name> " &
                XML_String (obj.Address_Space_Name, level) &
                " </Address_Space_Name>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Capacity> " &
                XML_String (obj.Capacity, level) &
                " </Capacity>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Deadline> " &
                XML_String (obj.Deadline, level) &
                " </Deadline>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Start_Time> " &
                XML_String (obj.Start_Time, level) &
                " </Start_Time>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Priority> " &
                XML_String (obj.Priority, level) &
                " </Priority>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Blocking_Time> " &
                XML_String (obj.Blocking_Time, level) &
                " </Blocking_Time>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Policy> " &
                XML_String (obj.Policy, level) &
                " </Policy>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<X> " &
                XML_String (obj.X, level) &
                " </X>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Y> " &
                XML_String (obj.Y, level) &
                " </Y>" &
                Unbounded_Lf;
      -- result := result & ASCII.HT & "<Offset> " & XML_String(obj.Offset,
      --level) & " </Offset>" & Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Text_Memory_Size> " &
                XML_String (obj.Text_Memory_Size, level) &
                " </Text_Memory_Size>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Stack_Memory_Size> " &
                XML_String (obj.Stack_Memory_Size, level) &
                " </Stack_Memory_Size>" &
                Unbounded_Lf;
      -- result := result & ASCII.HT & "<Param> " & XML_String(obj.Param,
      --level) & " </Param>" & Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Criticality> " &
                XML_String (obj.Criticality, level) &
                " </Criticality>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Context_Switch_Overhead> " &
                XML_String (obj.Context_Switch_Overhead, level) &
                " </Context_Switch_Overhead>" &
                Unbounded_Lf;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Generic_Task;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Generic_Task id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Generic_Task>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Periodic_Task =--------

   procedure Initialize (obj : in out Periodic_Task) is
   begin
      Initialize (Generic_Task (obj));
      obj.Period    := 0;
      obj.Jitter    := 0;
      obj.Task_Type := Periodic_Type;
   end Initialize;

   function Copy (obj : in Periodic_Task) return Generic_Task_Ptr is
      New_Periodic_Task : Periodic_Task_Ptr;
   begin
      New_Periodic_Task := new Periodic_Task'(obj);
      return Generic_Task_Ptr (New_Periodic_Task);
   end Copy;

   function Copy (obj : in Periodic_Task_Ptr) return Generic_Task_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Periodic_Task) is
   begin
      Put (Generic_Task (obj));
      Put ("Period: ");
      Standards_Io.Natural_Io.Put (obj.Period);
      Put ("; ");
      Put ("Jitter: ");
      Standards_Io.Natural_Io.Put (obj.Jitter);
      Put ("; ");
   end Put;

   procedure Put (obj : in Periodic_Task_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Periodic_Task_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Periodic_Task) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Periodic_Task_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Periodic_Task;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Task (obj), level, result);
      result := result &
                ASCII.HT &
                "<Period> " &
                XML_String (obj.Period, level) &
                " </Period>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Jitter> " &
                XML_String (obj.Jitter, level) &
                " </Jitter>" &
                Unbounded_Lf;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Periodic_Task;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Periodic_Task id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Periodic_Task>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Aperiodic_Task =--------

   procedure Initialize (obj : in out Aperiodic_Task) is
   begin
      Initialize (Generic_Task (obj));
      obj.Task_Type := Aperiodic_Type;
   end Initialize;

   function Copy (obj : in Aperiodic_Task) return Generic_Task_Ptr is
      New_Aperiodic_Task : Aperiodic_Task_Ptr;
   begin
      New_Aperiodic_Task := new Aperiodic_Task'(obj);
      return Generic_Task_Ptr (New_Aperiodic_Task);
   end Copy;

   function Copy (obj : in Aperiodic_Task_Ptr) return Generic_Task_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Aperiodic_Task) is
   begin
      Put (Generic_Task (obj));
   end Put;

   procedure Put (obj : in Aperiodic_Task_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Aperiodic_Task_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Aperiodic_Task) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Aperiodic_Task_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Aperiodic_Task;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Generic_Task (obj), level, result);
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Aperiodic_Task;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Aperiodic_Task id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Aperiodic_Task>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Poisson_Task =--------

   procedure Initialize (obj : in out Poisson_Task) is
   begin
      Initialize (Periodic_Task (obj));
      obj.Seed        := 0;
      obj.Predictable := False;
      obj.Task_Type   := Poisson_Type;
   end Initialize;

   function Copy (obj : in Poisson_Task) return Generic_Task_Ptr is
      New_Poisson_Task : Poisson_Task_Ptr;
   begin
      New_Poisson_Task := new Poisson_Task'(obj);
      return Generic_Task_Ptr (New_Poisson_Task);
   end Copy;

   function Copy (obj : in Poisson_Task_Ptr) return Generic_Task_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Poisson_Task) is
   begin
      Put (Periodic_Task (obj));
      Put ("Seed: ");
      Standards_Io.Integer_Io.Put (obj.Seed);
      Put ("; ");
      Put ("Predictable: ");
      Standards_Io.Boolean_Io.Put (obj.Predictable);
      Put ("; ");
   end Put;

   procedure Put (obj : in Poisson_Task_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Poisson_Task_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Poisson_Task) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Poisson_Task_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Poisson_Task;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Periodic_Task (obj), level, result);
      result := result &
                ASCII.HT &
                "<Seed> " &
                XML_String (obj.Seed, level) &
                " </Seed>" &
                Unbounded_Lf;
      result := result &
                ASCII.HT &
                "<Predictable> " &
                XML_String (obj.Predictable, level) &
                " </Predictable>" &
                Unbounded_Lf;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Poisson_Task;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Poisson_Task id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Poisson_Task>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Sporadic_Task =--------

   procedure Initialize (obj : in out Sporadic_Task) is
   begin
      Initialize (Poisson_Task (obj));
      obj.Task_Type := Sporadic_Type;
   end Initialize;

   function Copy (obj : in Sporadic_Task) return Generic_Task_Ptr is
      New_Sporadic_Task : Sporadic_Task_Ptr;
   begin
      New_Sporadic_Task := new Sporadic_Task'(obj);
      return Generic_Task_Ptr (New_Sporadic_Task);
   end Copy;

   function Copy (obj : in Sporadic_Task_Ptr) return Generic_Task_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Sporadic_Task) is
   begin
      Put (Poisson_Task (obj));
   end Put;

   procedure Put (obj : in Sporadic_Task_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Sporadic_Task_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Sporadic_Task) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Sporadic_Task_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Sporadic_Task;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Poisson_Task (obj), level, result);
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Sporadic_Task;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Sporadic_Task id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Sporadic_Task>" & Unbounded_Lf;
      return (result);
   end XML_String;

   -- --------= Parametric_Task =--------

   procedure Initialize (obj : in out Parametric_Task) is
   begin
      Initialize (Poisson_Task (obj));
      obj.Activation_Rule := Empty_String;
      obj.Task_Type       := Parametric_Type;
   end Initialize;

   function Copy (obj : in Parametric_Task) return Generic_Task_Ptr is
      New_Parametric_Task : Parametric_Task_Ptr;
   begin
      New_Parametric_Task := new Parametric_Task'(obj);
      return Generic_Task_Ptr (New_Parametric_Task);
   end Copy;

   function Copy (obj : in Parametric_Task_Ptr) return Generic_Task_Ptr is
   begin
      return Copy (obj.all);
   end Copy;

   procedure Put (obj : in Parametric_Task) is
   begin
      Put (Poisson_Task (obj));
      Put ("Activation_Rule: ");
      Put (obj.Activation_Rule);
      Put ("; ");
   end Put;

   procedure Put (obj : in Parametric_Task_Ptr) is
   begin
      Put (obj.all);
   end Put;

   procedure Put_Name (obj : in Parametric_Task_Ptr) is
   begin
      Put (To_String (obj.Name));
   end Put_Name;

   function Get_Name (obj : in Parametric_Task) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   function Get_Name (obj : in Parametric_Task_Ptr) return Unbounded_String is
   begin
      return obj.Name;
   end Get_Name;

   procedure Build_Attributes_XML_String
     (obj    : in Parametric_Task;
      level  : in Natural := 0;
      result : in out Unbounded_String)
   is
   begin
      Build_Attributes_XML_String (Poisson_Task (obj), level, result);
      result := result &
                ASCII.HT &
                "<Activation_Rule> " &
                XML_String (obj.Activation_Rule, level) &
                " </Activation_Rule>" &
                Unbounded_Lf;
   end Build_Attributes_XML_String;

   function XML_String
     (obj   : in Parametric_Task;
      level : in Natural := 0)
      return  Unbounded_String
   is
      result : Unbounded_String;
   begin
      result := "<Parametric_Task id=""" &
                Get_Name (obj) &
                """ >" &
                Unbounded_Lf;
      Build_Attributes_XML_String (obj, level, result);
      result := result & "</Parametric_Task>" & Unbounded_Lf;
      return (result);
   end XML_String;

end Tasks;
