------------------------------------------------------------------------------
-- This Ada package was automatically generated by
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Framework_Config; use Framework_Config;

use Framework_Config.Priority_Io;

with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Unbounded_Strings; use Unbounded_Strings;

with Convert_Strings;

with Convert_Unbounded_Strings;

with Text_IO; use Text_IO;

with Standards_Io; use Standards_Io;

use Standards_Io.Natural_Io;

with Offsets; use Offsets;

use Offsets.Offsets_Table_package;

with Parameters; use Parameters;

use Parameters.User_Defined_Parameters_Table_Package;

with Objects; use Objects;

with Unchecked_Deallocation;

use Standards_Io.Integer_Io;

use Standards_Io.Boolean_Io;

package Tasks is

   type Tasks_Type is (
      Periodic_Type,
      Aperiodic_Type,
      Sporadic_Type,
      Poisson_Type,
      Parametric_Type);

   procedure To_Tasks_Type is new Convert_Strings (
      Tasks_Type,
      Periodic_Type);
   procedure To_Tasks_Type is new Convert_Unbounded_Strings (
      Tasks_Type,
      Periodic_Type);
   function XML_String
     (e     : in Tasks_Type;
      level : in Natural := 0)
      return  Unbounded_String;
   package Tasks_Type_io is new Text_IO.Enumeration_IO (Tasks_Type);
   use Tasks_Type_io;

   type Policies is (Sched_Fifo, Sched_Rr, Sched_Others);

   procedure To_Policies is new Convert_Strings (Policies, Sched_Fifo);
   procedure To_Policies is new Convert_Unbounded_Strings (
      Policies,
      Sched_Fifo);
   function XML_String
     (e     : in Policies;
      level : in Natural := 0)
      return  Unbounded_String;
   package Policies_io is new Text_IO.Enumeration_IO (Policies);
   use Policies_io;

   -- --------= Generic_Task =--------

   type Generic_Task;
   type Generic_Task_Ptr is access all Generic_Task'Class;
   type Generic_Task is new Generic_Object with record
      Task_Type               : Tasks_Type;
      Cpu_Name                : Unbounded_String;
      Address_Space_Name      : Unbounded_String;
      Capacity                : Natural;
      Deadline                : Natural;
      Start_Time              : Natural;
      Priority                : Priority_Range;
      Blocking_Time           : Natural;
      Policy                  : Policies;
      X                       : Natural;
      Y                       : Natural;
      Offset                  : Offsets_Table;
      Text_Memory_Size        : Natural;
      Stack_Memory_Size       : Natural;
      Param                   : User_Defined_Parameters_Table;
      Criticality             : Natural;
      Context_Switch_Overhead : Natural;
   end record;

   procedure Initialize (obj : in out Generic_Task);
   procedure Put (obj : in Generic_Task);
   procedure Put (obj : in Generic_Task_Ptr);
   procedure Put_Name (obj : in Generic_Task_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Generic_Task;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Generic_Task;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Generic_Task) return Unbounded_String;
   function Get_Name (obj : in Generic_Task_Ptr) return Unbounded_String;
   function Copy (obj : in Generic_Task_Ptr) return Generic_Task_Ptr;
   function Copy (obj : in Generic_Task) return Generic_Task_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Generic_Task'Class,
      Generic_Task_Ptr);

   -- --------= Periodic_Task =--------

   type Periodic_Task;
   type Periodic_Task_Ptr is access all Periodic_Task'Class;
   type Periodic_Task is new Generic_Task with record
      Period : Natural;
      Jitter : Natural;
   end record;

   procedure Initialize (obj : in out Periodic_Task);
   procedure Put (obj : in Periodic_Task);
   procedure Put (obj : in Periodic_Task_Ptr);
   procedure Put_Name (obj : in Periodic_Task_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Periodic_Task;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Periodic_Task;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Periodic_Task) return Unbounded_String;
   function Get_Name (obj : in Periodic_Task_Ptr) return Unbounded_String;
   function Copy (obj : in Periodic_Task_Ptr) return Generic_Task_Ptr;
   function Copy (obj : in Periodic_Task) return Generic_Task_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Periodic_Task'Class,
      Periodic_Task_Ptr);

   -- --------= Aperiodic_Task =--------

   type Aperiodic_Task;
   type Aperiodic_Task_Ptr is access all Aperiodic_Task'Class;
   type Aperiodic_Task is new Generic_Task with null record;

   procedure Initialize (obj : in out Aperiodic_Task);
   procedure Put (obj : in Aperiodic_Task);
   procedure Put (obj : in Aperiodic_Task_Ptr);
   procedure Put_Name (obj : in Aperiodic_Task_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Aperiodic_Task;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Aperiodic_Task;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Aperiodic_Task) return Unbounded_String;
   function Get_Name (obj : in Aperiodic_Task_Ptr) return Unbounded_String;
   function Copy (obj : in Aperiodic_Task_Ptr) return Generic_Task_Ptr;
   function Copy (obj : in Aperiodic_Task) return Generic_Task_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Aperiodic_Task'Class,
      Aperiodic_Task_Ptr);

   -- --------= Poisson_Task =--------

   type Poisson_Task;
   type Poisson_Task_Ptr is access all Poisson_Task'Class;
   type Poisson_Task is new Periodic_Task with record
      Seed        : Integer;
      Predictable : Boolean;
   end record;

   procedure Initialize (obj : in out Poisson_Task);
   procedure Put (obj : in Poisson_Task);
   procedure Put (obj : in Poisson_Task_Ptr);
   procedure Put_Name (obj : in Poisson_Task_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Poisson_Task;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Poisson_Task;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Poisson_Task) return Unbounded_String;
   function Get_Name (obj : in Poisson_Task_Ptr) return Unbounded_String;
   function Copy (obj : in Poisson_Task_Ptr) return Generic_Task_Ptr;
   function Copy (obj : in Poisson_Task) return Generic_Task_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Poisson_Task'Class,
      Poisson_Task_Ptr);

   -- --------= Sporadic_Task =--------

   type Sporadic_Task;
   type Sporadic_Task_Ptr is access all Sporadic_Task'Class;
   type Sporadic_Task is new Poisson_Task with null record;

   procedure Initialize (obj : in out Sporadic_Task);
   procedure Put (obj : in Sporadic_Task);
   procedure Put (obj : in Sporadic_Task_Ptr);
   procedure Put_Name (obj : in Sporadic_Task_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Sporadic_Task;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Sporadic_Task;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Sporadic_Task) return Unbounded_String;
   function Get_Name (obj : in Sporadic_Task_Ptr) return Unbounded_String;
   function Copy (obj : in Sporadic_Task_Ptr) return Generic_Task_Ptr;
   function Copy (obj : in Sporadic_Task) return Generic_Task_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Sporadic_Task'Class,
      Sporadic_Task_Ptr);

   -- --------= Parametric_Task =--------

   type Parametric_Task;
   type Parametric_Task_Ptr is access all Parametric_Task'Class;
   type Parametric_Task is new Poisson_Task with record
      Activation_Rule : Unbounded_String;
   end record;

   procedure Initialize (obj : in out Parametric_Task);
   procedure Put (obj : in Parametric_Task);
   procedure Put (obj : in Parametric_Task_Ptr);
   procedure Put_Name (obj : in Parametric_Task_Ptr);
   procedure Build_Attributes_XML_String
     (obj    : in Parametric_Task;
      level  : in Natural := 0;
      result : in out Unbounded_String);
   function XML_String
     (obj   : in Parametric_Task;
      level : in Natural := 0)
      return  Unbounded_String;
   function Get_Name (obj : in Parametric_Task) return Unbounded_String;
   function Get_Name (obj : in Parametric_Task_Ptr) return Unbounded_String;
   function Copy (obj : in Parametric_Task_Ptr) return Generic_Task_Ptr;
   function Copy (obj : in Parametric_Task) return Generic_Task_Ptr;
   procedure Free is new Unchecked_Deallocation (
      Parametric_Task'Class,
      Parametric_Task_Ptr);

end Tasks;
