------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Gtk.Window;            use Gtk.Window;
with Gtk.Label;             use Gtk.Label;
with Gtk.Separator;         use Gtk.Separator;
with Gtk.Button;            use Gtk.Button;
with Gtk.Box;               use Gtk.Box;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Gtk.Combo;             use Gtk.Combo;
with Gtk.Enums;             use Gtk.Enums;

package Graph_Add_Pkg is

   type Add_Item_Record is new Gtk_Window_Record with record
      Label         : Gtk_Label;
      Combo         : Gtk_Combo;
      Items         : String_List.Glist;
      Hseparator    : Gtk_Hseparator;
      Vseparator    : Gtk_Vseparator;
      Hbox          : Gtk_Hbox;
      Vbox          : Gtk_Vbox;
      Ok_Button     : Gtk_Button;
      Cancel_Button : Gtk_Button;
      Parent        : Unbounded_String;
      Item_Type     : Unbounded_String;
   end record;
   type Add_Item_Access is access all Add_Item_Record'Class;

   procedure Gtk_New (Add_New_Item : out Add_Item_Access; Item : in String);
   procedure Initialize (Add_New_Item : access Add_Item_Record'Class);

   Add_New_Item : Add_Item_Access;

end Graph_Add_Pkg;
