------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Gtk.Window;      use Gtk.Window;
with Gtk.Widget;      use Gtk.Widget;
with Gtk.Table;       use Gtk.Table;
with Gtk.Box;         use Gtk.Box;
with Gtk.Label;       use Gtk.Label;
with Gtk.GEntry;      use Gtk.GEntry;
with Gtk.Separator;   use Gtk.Separator;
with Gtk.Button;      use Gtk.Button;
with Gtk.Option_Menu; use Gtk.Option_Menu;
with Systems;         use Systems;

package Duplicate_Pkg is

   type Duplicate_Record is new Gtk_Window_Record with private;
   type Duplicate_Access is access all Duplicate_Record'Class;

   procedure Gtk_New (Duplicate : out Duplicate_Access);

   procedure Initialize (Duplicate : access Duplicate_Record'Class);

   Duplicate : Duplicate_Access;

private

   type Duplicate_Record is new Gtk_Window_Record with record
      Table      : Gtk_Table;
      Hbox       : Gtk_Hbox;
      Hseparator : Gtk_Hseparator;
      Vseparator : Gtk_Vseparator;

      Object_Menu       : Gtk_Option_Menu;
      Clist_Object_Menu : Widget_SList.GSlist;

      Object_Label : Gtk_Label;
      Old_Label    : Gtk_Label;
      New_Label    : Gtk_Label;

      New_Entry : Gtk_Entry;
      Old_Entry : Gtk_Entry;

      Cancel_Button    : Gtk_Button;
      Ok_Button        : Gtk_Button;
      Duplicate_Button : Gtk_Button;

      Sys : System;
   end record;

end Duplicate_Pkg;
