------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Gtk.File_Selection;    use Gtk.File_Selection;
with Gtk.Button;            use Gtk.Button;
with Gtk.Notebook;          use Gtk.Notebook;

package read_sc_file_Pkg is

   type return_file_name is access procedure
  (File_Name : in Unbounded_String);

   type read_sc_file_Record is new Gtk_File_Selection_Record with private;
   type read_sc_file_Access is access all read_sc_file_Record'Class;

   procedure Gtk_New
     (read_sc_file : out read_sc_file_Access;
      proc         : in return_file_name);
   procedure Initialize
     (read_sc_file : access read_sc_file_Record'Class;
      proc         : in return_file_name);

   read_sc_file : read_sc_file_Access;

private

   type read_sc_file_Record is new Gtk_File_Selection_Record with record
      Ok_Button         : Gtk_Button;
      Cancel_Button     : Gtk_Button;
      procedure_to_call : return_file_name;
   end record;

end read_sc_file_Pkg;
