------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Gtk.GEntry;      use Gtk.GEntry;
with Gtk.Option_Menu; use Gtk.Option_Menu;
with Gtk.Widget;      use Gtk.Widget;
with Parameters;      use Parameters;
with Offsets;         use Offsets;

package Tasks_Widget_Pkg is

   type Parameter_Record is record
      Entry_Name           : Gtk_Entry;
      Entry_Value          : Gtk_Entry;
      Entry_Type           : Gtk_Entry;
      Parameter_Menu       : Gtk_Option_Menu;
      Clist_Parameter_Menu : Widget_SList.GSlist;
   end record;

   type Widget_Parameter_Table is
     array (User_Defined_Parameters_Range) of Parameter_Record;

   type Offset_Record is record
      Entry_Val : Gtk_Entry;
      Entry_Act : Gtk_Entry;
   end record;

   type Widget_Offset_Table is array (Offsets_Range) of Offset_Record;

end Tasks_Widget_Pkg;
