------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Scheduler; use Scheduler;

package Update_Address_Spaces_Set_Pkg.Callbacks.Integrity_Checks is

   Address_Space_Name       : Unbounded_String;
   Address_Space_Processor  : Unbounded_String;
   Address_Space_Data       : Integer;
   Address_Space_Text       : Integer;
   Address_Space_Heap       : Integer;
   Address_Space_Stack      : Integer;
   Address_Space_Preemptive : Preemptive_Type;
   Address_Space_Quantum    : Integer;
   Address_Space_File_Name  : Unbounded_String;
   Address_Space_Scheduler  : Scheduler_Type;
   Address_space_automaton  : Unbounded_String;

   procedure Check_Integrity_Constraints
     (Update_Address_Spaces_Set : in out Update_Address_Spaces_Set_Access;
      Error_Message             : in out Unbounded_String;
      Ok                        : in out Boolean);

end Update_Address_Spaces_Set_Pkg.Callbacks.Integrity_Checks;
