------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with Primitive_XML_Strings;
use Primitive_XML_Strings;

with text_io;
use text_io;



Package Body Automaton is 
 
function XML_String(e : in Synchronizations_Type; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Synchronizations_Type'image (e) );
end XML_String;
 
function XML_String(e : in Status_Type; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Status_Type'image (e) );
end XML_String;
 

-- --------= State =--------

procedure Initialize(obj : in out State) is 
begin
	initialize(Generic_Object(obj));
	obj.Is_Initial := false;
	obj.Object_Type := State_Object_Type;
end Initialize;

function Copy ( obj : in State ) return State_Ptr is
	New_State : State_Ptr;
begin
	New_State := new State'(obj);
	return State_Ptr(New_State);
end Copy;

function Copy ( obj : in State_Ptr ) return State_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in State) is 
begin
	put(Generic_Object(obj));
	put("Is_Initial: "); standards_io.boolean_io.put(obj.Is_Initial); put ( "; " );
end Put;
 
procedure Put(obj : in State_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in State_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in State) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in State_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in State; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Object(obj), level, result);
	result := result & ASCII.HT & "<Is_Initial> " & XML_String(obj.Is_Initial, level) & " </Is_Initial>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in State; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<State id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</State>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Synchronization =--------

procedure Initialize(obj : in out Synchronization) is 
begin
	initialize(Generic_Object(obj));
	obj.Synchronization_Type := Send;
	obj.Object_Type := Synchronization_Object_Type;
end Initialize;

function Copy ( obj : in Synchronization ) return Synchronization_Ptr is
	New_Synchronization : Synchronization_Ptr;
begin
	New_Synchronization := new Synchronization'(obj);
	return Synchronization_Ptr(New_Synchronization);
end Copy;

function Copy ( obj : in Synchronization_Ptr ) return Synchronization_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Synchronization) is 
begin
	put(Generic_Object(obj));
	put("Synchronization_Type: "); put(obj.Synchronization_Type); put ( "; " );
end Put;
 
procedure Put(obj : in Synchronization_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Synchronization_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Synchronization) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Synchronization_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Synchronization; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Object(obj), level, result);
	result := result & ASCII.HT & "<Synchronization_Type> " & XML_String(obj.Synchronization_Type, level) & " </Synchronization_Type>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Synchronization; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Synchronization id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Synchronization>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Transition =--------

procedure Initialize(obj : in out Transition) is 
begin
	initialize(Generic_Object(obj));
	obj.Object_Type := Transition_Object_Type;
end Initialize;

function Copy ( obj : in Transition ) return Transition_Ptr is
	New_Transition : Transition_Ptr;
begin
	New_Transition := new Transition'(obj);
	return Transition_Ptr(New_Transition);
end Copy;

function Copy ( obj : in Transition_Ptr ) return Transition_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Transition) is 
begin
	put(Generic_Object(obj));
	put("From_State: "); if obj.From_State /= null then put(obj.From_State.all); else put("null"); end if;put ( "; " );
	put("To_State: "); if obj.To_State /= null then put(obj.To_State.all); else put("null"); end if;put ( "; " );
	put("Guards: "); if obj.Guards /= null then put(obj.Guards.all); else put("null"); end if;put ( "; " );
	put("Clocks: "); if obj.Clocks /= null then put(obj.Clocks.all); else put("null"); end if;put ( "; " );
	put("Synchronization: "); if obj.Synchronization /= null then put(obj.Synchronization.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Transition_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Transition_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Transition) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Transition_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Transition; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Object(obj), level, result);
	if obj.From_State /= null then 
		result := result & ASCII.HT & "<From_State ref=""" & Get_Name(obj.From_State) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<From_State> </From_State>" & Unbounded_Lf;
	end if;
	if obj.To_State /= null then 
		result := result & ASCII.HT & "<To_State ref=""" & Get_Name(obj.To_State) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<To_State> </To_State>" & Unbounded_Lf;
	end if;
	if obj.Guards /= null then 
		result := result & ASCII.HT & "<Guards ref=""" & Get_Name(obj.Guards) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Guards> </Guards>" & Unbounded_Lf;
	end if;
	if obj.Clocks /= null then 
		result := result & ASCII.HT & "<Clocks ref=""" & Get_Name(obj.Clocks) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Clocks> </Clocks>" & Unbounded_Lf;
	end if;
	if obj.Synchronization /= null then 
		result := result & ASCII.HT & "<Synchronization ref=""" & Get_Name(obj.Synchronization) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Synchronization> </Synchronization>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Transition; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Transition id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Transition>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Automaton_Status =--------

procedure Initialize(obj : out Automaton_Status) is 
begin
	null;
end Initialize;

procedure Put(obj : in Automaton_Status) is 
begin
	put("Current_State: "); if obj.Current_State /= null then put(obj.Current_State.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Automaton_Status_Ptr) is
begin
	Put(Obj.All);
end Put;


procedure Build_Attributes_XML_String(obj : in Automaton_Status; level : in natural := 0; result : in out Unbounded_String) is 
begin
	if obj.Current_State /= null then 
		result := result & ASCII.HT & "<Current_State ref=""" & Get_Name(obj.Current_State) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Current_State> </Current_State>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Automaton_Status; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Automaton_Status>" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Automaton_Status>" & Unbounded_Lf;
	return (result);
end XML_String;



-- --------= Transition_Status =--------

procedure Initialize(obj : out Transition_Status) is 
begin
	obj.Status := Ready;
	obj.Wakeup_Time := 0;
end Initialize;

procedure Put(obj : in Transition_Status) is 
begin
	put("Code: "); if obj.Code /= null then put(obj.Code.all); else put("null"); end if;put ( "; " );
	put("Status: "); put(obj.Status); put ( "; " );
	put("Wakeup_Time: "); standards_io.natural_io.put(obj.Wakeup_Time); put ( "; " );
end Put;
 
procedure Put(obj : in Transition_Status_Ptr) is
begin
	Put(Obj.All);
end Put;


procedure Build_Attributes_XML_String(obj : in Transition_Status; level : in natural := 0; result : in out Unbounded_String) is 
begin
	if obj.Code /= null then 
		result := result & ASCII.HT & "<Code ref=""" & Get_Name(obj.Code) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Code> </Code>" & Unbounded_Lf;
	end if;
	result := result & ASCII.HT & "<Status> " & XML_String(obj.Status, level) & " </Status>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Wakeup_Time> " & XML_String(obj.Wakeup_Time, level) & " </Wakeup_Time>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Transition_Status; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Transition_Status>" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Transition_Status>" & Unbounded_Lf;
	return (result);
end XML_String;



End Automaton;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with Primitive_XML_Strings;
use Primitive_XML_Strings;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;

with text_io;
use text_io;



Package Body Expressions is 
 
function XML_String(e : in Operator_Type; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Operator_Type'image (e) );
end XML_String;
 
function XML_String(e : in Expressions_Type; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Expressions_Type'image (e) );
end XML_String;
 

-- --------= Generic_Expression =--------

procedure Initialize(obj : in out Generic_Expression) is 
begin
	obj.Expression_Type := Constant_Type;
end Initialize;

function Copy ( obj : in Generic_Expression ) return Generic_Expression_Ptr is
	New_Generic_Expression : Generic_Expression_Ptr;
begin
	New_Generic_Expression := new Generic_Expression'(obj);
	return Generic_Expression_Ptr(New_Generic_Expression);
end Copy;

function Copy ( obj : in Generic_Expression_Ptr ) return Generic_Expression_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Generic_Expression) is 
begin
	put("Expression_Type: "); put(obj.Expression_Type); put ( "; " );
end Put;
 
procedure Put(obj : in Generic_Expression_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Generic_Expression_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Generic_Expression) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Generic_Expression_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Generic_Expression; level : in natural := 0; result : in out Unbounded_String) is 
begin
	result := result & ASCII.HT & "<Expression_Type> " & XML_String(obj.Expression_Type, level) & " </Expression_Type>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Generic_Expression; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Generic_Expression id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Generic_Expression>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Constant_Expression =--------

procedure Initialize(obj : in out Constant_Expression) is 
begin
	initialize(Generic_Expression(obj));
	obj.Expression_Type := Constant_Type;
end Initialize;

function Copy ( obj : in Constant_Expression ) return Generic_Expression_Ptr is
	New_Constant_Expression : Constant_Expression_Ptr;
begin
	New_Constant_Expression := new Constant_Expression'(obj);
	return Generic_Expression_Ptr(New_Constant_Expression);
end Copy;

function Copy ( obj : in Constant_Expression_Ptr ) return Generic_Expression_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Constant_Expression) is 
begin
	put(Generic_Expression(obj));
	put("VALUE: "); if obj.VALUE /= null then put(obj.VALUE.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Constant_Expression_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Constant_Expression_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Constant_Expression) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Constant_Expression_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Constant_Expression; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Expression(obj), level, result);
	if obj.VALUE /= null then 
		result := result & ASCII.HT & "<VALUE ref=""" & Get_Name(obj.VALUE) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<VALUE> </VALUE>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Constant_Expression; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Constant_Expression id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Constant_Expression>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Variable_Expression =--------

procedure Initialize(obj : in out Variable_Expression) is 
begin
	initialize(Generic_Expression(obj));
	obj.Name := empty_string;
	obj.Variable_Type := Simulation_Boolean;
	obj.Expression_Type := Variable_Type;
end Initialize;

function Copy ( obj : in Variable_Expression ) return Generic_Expression_Ptr is
	New_Variable_Expression : Variable_Expression_Ptr;
begin
	New_Variable_Expression := new Variable_Expression'(obj);
	return Generic_Expression_Ptr(New_Variable_Expression);
end Copy;

function Copy ( obj : in Variable_Expression_Ptr ) return Generic_Expression_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Variable_Expression) is 
begin
	put(Generic_Expression(obj));
	put("Name: "); put(obj.Name); put ( "; " );
	put("Variable_Type: "); put(obj.Variable_Type); put ( "; " );
end Put;
 
procedure Put(obj : in Variable_Expression_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Variable_Expression_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Variable_Expression) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Variable_Expression_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Variable_Expression; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Expression(obj), level, result);
	result := result & ASCII.HT & "<Name> " & XML_String(obj.Name, level) & " </Name>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Variable_Type> " & XML_String(obj.Variable_Type, level) & " </Variable_Type>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Variable_Expression; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Variable_Expression id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Variable_Expression>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Array_Variable_Expression =--------

procedure Initialize(obj : in out Array_Variable_Expression) is 
begin
	initialize(Variable_Expression(obj));
	obj.Expression_Type := Array_Variable_Type;
end Initialize;

function Copy ( obj : in Array_Variable_Expression ) return Generic_Expression_Ptr is
	New_Array_Variable_Expression : Array_Variable_Expression_Ptr;
begin
	New_Array_Variable_Expression := new Array_Variable_Expression'(obj);
	return Generic_Expression_Ptr(New_Array_Variable_Expression);
end Copy;

function Copy ( obj : in Array_Variable_Expression_Ptr ) return Generic_Expression_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Array_Variable_Expression) is 
begin
	put(Variable_Expression(obj));
	put("Array_Index: "); if obj.Array_Index /= null then put(obj.Array_Index.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Array_Variable_Expression_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Array_Variable_Expression_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Array_Variable_Expression) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Array_Variable_Expression_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Array_Variable_Expression; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Variable_Expression(obj), level, result);
	if obj.Array_Index /= null then 
		result := result & ASCII.HT & "<Array_Index ref=""" & Get_Name(obj.Array_Index) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Array_Index> </Array_Index>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Array_Variable_Expression; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Array_Variable_Expression id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Array_Variable_Expression>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Binary_Expression =--------

procedure Initialize(obj : in out Binary_Expression) is 
begin
	initialize(Variable_Expression(obj));
	obj.Operator := Plus_Type;
	obj.Expression_Type := Binary_Type;
end Initialize;

function Copy ( obj : in Binary_Expression ) return Generic_Expression_Ptr is
	New_Binary_Expression : Binary_Expression_Ptr;
begin
	New_Binary_Expression := new Binary_Expression'(obj);
	return Generic_Expression_Ptr(New_Binary_Expression);
end Copy;

function Copy ( obj : in Binary_Expression_Ptr ) return Generic_Expression_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Binary_Expression) is 
begin
	put(Variable_Expression(obj));
	put("Rvalue: "); if obj.Rvalue /= null then put(obj.Rvalue.all); else put("null"); end if;put ( "; " );
	put("Lvalue: "); if obj.Lvalue /= null then put(obj.Lvalue.all); else put("null"); end if;put ( "; " );
	put("Operator: "); put(obj.Operator); put ( "; " );
end Put;
 
procedure Put(obj : in Binary_Expression_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Binary_Expression_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Binary_Expression) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Binary_Expression_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Binary_Expression; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Variable_Expression(obj), level, result);
	if obj.Rvalue /= null then 
		result := result & ASCII.HT & "<Rvalue ref=""" & Get_Name(obj.Rvalue) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Rvalue> </Rvalue>" & Unbounded_Lf;
	end if;
	if obj.Lvalue /= null then 
		result := result & ASCII.HT & "<Lvalue ref=""" & Get_Name(obj.Lvalue) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Lvalue> </Lvalue>" & Unbounded_Lf;
	end if;
	result := result & ASCII.HT & "<Operator> " & XML_String(obj.Operator, level) & " </Operator>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Binary_Expression; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Binary_Expression id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Binary_Expression>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Unary_Expression =--------

procedure Initialize(obj : in out Unary_Expression) is 
begin
	initialize(Variable_Expression(obj));
	obj.Operator := Plus_Type;
	obj.Expression_Type := Unary_Type;
end Initialize;

function Copy ( obj : in Unary_Expression ) return Generic_Expression_Ptr is
	New_Unary_Expression : Unary_Expression_Ptr;
begin
	New_Unary_Expression := new Unary_Expression'(obj);
	return Generic_Expression_Ptr(New_Unary_Expression);
end Copy;

function Copy ( obj : in Unary_Expression_Ptr ) return Generic_Expression_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Unary_Expression) is 
begin
	put(Variable_Expression(obj));
	put("Operator: "); put(obj.Operator); put ( "; " );
	put("VALUE: "); if obj.VALUE /= null then put(obj.VALUE.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Unary_Expression_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Unary_Expression_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Unary_Expression) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Unary_Expression_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Unary_Expression; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Variable_Expression(obj), level, result);
	result := result & ASCII.HT & "<Operator> " & XML_String(obj.Operator, level) & " </Operator>" & Unbounded_Lf;
	if obj.VALUE /= null then 
		result := result & ASCII.HT & "<VALUE ref=""" & Get_Name(obj.VALUE) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<VALUE> </VALUE>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Unary_Expression; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Unary_Expression id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Unary_Expression>" & Unbounded_Lf;
  return (result);
end XML_String;




End Expressions;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with Primitive_XML_Strings;
use Primitive_XML_Strings;

with text_io;
use text_io;



Package Body Offsets is 
 

-- --------= Offset_Type =--------

procedure Initialize(obj : out Offset_Type) is 
begin
	obj.Offset_Value := 0;
	obj.Activation := 0;
end Initialize;

procedure Put(obj : in Offset_Type) is 
begin
	put("Offset_Value: "); standards_io.integer_io.put(obj.Offset_Value); put ( "; " );
	put("Activation: "); standards_io.integer_io.put(obj.Activation); put ( "; " );
end Put;
 
procedure Put(obj : in Offset_Type_Ptr) is
begin
	Put(Obj.All);
end Put;


procedure Build_Attributes_XML_String(obj : in Offset_Type; level : in natural := 0; result : in out Unbounded_String) is 
begin
	result := result & ASCII.HT & "<Offset_Value> " & XML_String(obj.Offset_Value, level) & " </Offset_Value>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Activation> " & XML_String(obj.Activation, level) & " </Activation>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Offset_Type; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Offset_Type>" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Offset_Type>" & Unbounded_Lf;
	return (result);
end XML_String;



End Offsets;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with Primitive_XML_Strings;
use Primitive_XML_Strings;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;

with text_io;
use text_io;



Package Body Resources is 
 
function XML_String(e : in Resources_Type; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Resources_Type'image (e) );
end XML_String;
 

-- --------= Affected_Task_Lists =--------

procedure Initialize(obj : out Affected_Task_Lists) is 
begin
	obj.Task_Begin := 0;
	obj.Task_End := 0;
end Initialize;

procedure Put(obj : in Affected_Task_Lists) is 
begin
	put("Task_Begin: "); standards_io.natural_io.put(obj.Task_Begin); put ( "; " );
	put("Task_End: "); standards_io.natural_io.put(obj.Task_End); put ( "; " );
end Put;
 
procedure Put(obj : in Affected_Task_Lists_Ptr) is
begin
	Put(Obj.All);
end Put;


procedure Build_Attributes_XML_String(obj : in Affected_Task_Lists; level : in natural := 0; result : in out Unbounded_String) is 
begin
	result := result & ASCII.HT & "<Task_Begin> " & XML_String(obj.Task_Begin, level) & " </Task_Begin>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Task_End> " & XML_String(obj.Task_End, level) & " </Task_End>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Affected_Task_Lists; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Affected_Task_Lists>" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Affected_Task_Lists>" & Unbounded_Lf;
	return (result);
end XML_String;



-- --------= Generic_Resource =--------

procedure Initialize(obj : in out Generic_Resource) is 
begin
	initialize(Generic_Object(obj));
	obj.state := 0;
	obj.protocol := No_Protocol;
	initialize( obj.task_tab);
	obj.cpu_name := empty_string;
	obj.Address_Space_Name := empty_string;
	obj.Object_Type := Resource_Object_Type;
end Initialize;

function Copy ( obj : in Generic_Resource ) return Generic_Resource_Ptr is
	New_Generic_Resource : Generic_Resource_Ptr;
begin
	New_Generic_Resource := new Generic_Resource'(obj);
	return Generic_Resource_Ptr(New_Generic_Resource);
end Copy;

function Copy ( obj : in Generic_Resource_Ptr ) return Generic_Resource_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Generic_Resource) is 
begin
	put(Generic_Object(obj));
	put("state: "); standards_io.integer_io.put(obj.state); put ( "; " );
	put("protocol: "); put(obj.protocol); put ( "; " );
	put("task_tab: "); put(obj.task_tab); put ( "; " );
	put("cpu_name: "); put(obj.cpu_name); put ( "; " );
	put("Address_Space_Name: "); put(obj.Address_Space_Name); put ( "; " );
end Put;
 
procedure Put(obj : in Generic_Resource_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Generic_Resource_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Generic_Resource) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Generic_Resource_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Generic_Resource; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Object(obj), level, result);
	result := result & ASCII.HT & "<state> " & XML_String(obj.state, level) & " </state>" & Unbounded_Lf;
	result := result & ASCII.HT & "<protocol> " & XML_String(obj.protocol, level) & " </protocol>" & Unbounded_Lf;
	result := result & ASCII.HT & "<task_tab> " & XML_String(obj.task_tab, level) & " </task_tab>" & Unbounded_Lf;
	result := result & ASCII.HT & "<cpu_name> " & XML_String(obj.cpu_name, level) & " </cpu_name>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Address_Space_Name> " & XML_String(obj.Address_Space_Name, level) & " </Address_Space_Name>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Generic_Resource; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Generic_Resource id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Generic_Resource>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Np_Resource =--------

procedure Initialize(obj : in out Np_Resource) is 
begin
	initialize(Generic_Resource(obj));
end Initialize;

function Copy ( obj : in Np_Resource ) return Generic_Resource_Ptr is
	New_Np_Resource : Np_Resource_Ptr;
begin
	New_Np_Resource := new Np_Resource'(obj);
	return Generic_Resource_Ptr(New_Np_Resource);
end Copy;

function Copy ( obj : in Np_Resource_Ptr ) return Generic_Resource_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Np_Resource) is 
begin
	put(Generic_Resource(obj));
end Put;
 
procedure Put(obj : in Np_Resource_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Np_Resource_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Np_Resource) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Np_Resource_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Np_Resource; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Resource(obj), level, result);
end Build_Attributes_XML_String;

function XML_String(obj : in Np_Resource; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Np_Resource id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Np_Resource>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Pip_Resource =--------

procedure Initialize(obj : in out Pip_Resource) is 
begin
	initialize(Generic_Resource(obj));
	obj.protocol := Priority_Inheritance_Protocol;
end Initialize;

function Copy ( obj : in Pip_Resource ) return Generic_Resource_Ptr is
	New_Pip_Resource : Pip_Resource_Ptr;
begin
	New_Pip_Resource := new Pip_Resource'(obj);
	return Generic_Resource_Ptr(New_Pip_Resource);
end Copy;

function Copy ( obj : in Pip_Resource_Ptr ) return Generic_Resource_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Pip_Resource) is 
begin
	put(Generic_Resource(obj));
end Put;
 
procedure Put(obj : in Pip_Resource_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Pip_Resource_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Pip_Resource) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Pip_Resource_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Pip_Resource; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Resource(obj), level, result);
end Build_Attributes_XML_String;

function XML_String(obj : in Pip_Resource; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Pip_Resource id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Pip_Resource>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Pcp_Resource =--------

procedure Initialize(obj : in out Pcp_Resource) is 
begin
	initialize(Generic_Resource(obj));
	obj.protocol := Priority_Ceiling_Protocol;
end Initialize;

function Copy ( obj : in Pcp_Resource ) return Generic_Resource_Ptr is
	New_Pcp_Resource : Pcp_Resource_Ptr;
begin
	New_Pcp_Resource := new Pcp_Resource'(obj);
	return Generic_Resource_Ptr(New_Pcp_Resource);
end Copy;

function Copy ( obj : in Pcp_Resource_Ptr ) return Generic_Resource_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Pcp_Resource) is 
begin
	put(Generic_Resource(obj));
end Put;
 
procedure Put(obj : in Pcp_Resource_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Pcp_Resource_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Pcp_Resource) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Pcp_Resource_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Pcp_Resource; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Resource(obj), level, result);
end Build_Attributes_XML_String;

function XML_String(obj : in Pcp_Resource; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Pcp_Resource id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Pcp_Resource>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= IPcp_Resource =--------

procedure Initialize(obj : in out IPcp_Resource) is 
begin
	initialize(Generic_Resource(obj));
	obj.protocol := Immediate_Priority_Ceiling_Protocol;
end Initialize;

function Copy ( obj : in IPcp_Resource ) return Generic_Resource_Ptr is
	New_IPcp_Resource : IPcp_Resource_Ptr;
begin
	New_IPcp_Resource := new IPcp_Resource'(obj);
	return Generic_Resource_Ptr(New_IPcp_Resource);
end Copy;

function Copy ( obj : in IPcp_Resource_Ptr ) return Generic_Resource_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in IPcp_Resource) is 
begin
	put(Generic_Resource(obj));
end Put;
 
procedure Put(obj : in IPcp_Resource_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in IPcp_Resource_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in IPcp_Resource) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in IPcp_Resource_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in IPcp_Resource; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Resource(obj), level, result);
end Build_Attributes_XML_String;

function XML_String(obj : in IPcp_Resource; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<IPcp_Resource id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</IPcp_Resource>" & Unbounded_Lf;
  return (result);
end XML_String;




End Resources;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;

with text_io;
use text_io;

with Primitive_XML_Strings;
use Primitive_XML_Strings;



Package Body Objects is 
 
function XML_String(e : in Objects_Type; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Objects_Type'image (e) );
end XML_String;
 

-- --------= Generic_Object =--------

procedure Initialize(obj : in out Generic_Object) is 
begin
	obj.Name := empty_string;
	obj.Object_Type := Buffer_Object_Type;
end Initialize;

function Copy ( obj : in Generic_Object ) return Generic_Object_Ptr is
	New_Generic_Object : Generic_Object_Ptr;
begin
	New_Generic_Object := new Generic_Object'(obj);
	return Generic_Object_Ptr(New_Generic_Object);
end Copy;

function Copy ( obj : in Generic_Object_Ptr ) return Generic_Object_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Generic_Object) is 
begin
	put("Name: "); put(obj.Name); put ( "; " );
	put("Object_Type: "); put(obj.Object_Type); put ( "; " );
end Put;
 
procedure Put(obj : in Generic_Object_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Generic_Object_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Generic_Object) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Generic_Object_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Generic_Object; level : in natural := 0; result : in out Unbounded_String) is 
begin
	result := result & ASCII.HT & "<Name> " & XML_String(obj.Name, level) & " </Name>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Object_Type> " & XML_String(obj.Object_Type, level) & " </Object_Type>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Generic_Object; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Generic_Object id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Generic_Object>" & Unbounded_Lf;
  return (result);
end XML_String;




End Objects;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;

with text_io;
use text_io;

with unbounded_strings;
use unbounded_strings;



Package Body Parameters is 
 
function XML_String(e : in Parameter_Type; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Parameter_Type'image (e) );
end XML_String;
 
procedure Initialize (obj : out Parameter_Ptr) is
begin
	obj := NULL;
end Initialize;
 
procedure Put(obj : in Parameter_Ptr) is
begin
	if (obj /= NULL) then
		put("Name: "); put(obj.Name); put ( "; " );
		put("ptype: "); put(obj.ptype); put ( "; " );
		put ( " value: " );
		case obj.ptype is 
			when Boolean_Parameter => standards_io.boolean_io.put ( obj.Boolean_value ); put ( " " );
			when Integer_Parameter => standards_io.integer_io.put ( obj.Integer_value ); put ( " " );
			when Double_Parameter => standards_io.double_io.put ( obj.double_value ); put ( " " );
			when String_Parameter => put ( obj.string_value ); put ( " " );
		end case;
	end if;
	New_Line;
end Put;


End Parameters;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;

with text_io;
use text_io;

with Primitive_XML_Strings;
use Primitive_XML_Strings;



Package Body Processors is 
 

-- --------= Processor =--------

procedure Initialize(obj : in out Processor) is 
begin
	initialize(Generic_Object(obj));
	obj.Network := empty_string;
	obj.Object_Type := Processor_Object_Type;
end Initialize;

function Copy ( obj : in Processor ) return Processor_Ptr is
	New_Processor : Processor_Ptr;
begin
	New_Processor := new Processor'(obj);
	return Processor_Ptr(New_Processor);
end Copy;

function Copy ( obj : in Processor_Ptr ) return Processor_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Processor) is 
begin
	put(Generic_Object(obj));
	put("Scheduler: "); if obj.Scheduler /= null then put(obj.Scheduler.all); else put("null"); end if;put ( "; " );
	put("Network: "); put(obj.Network); put ( "; " );
end Put;
 
procedure Put(obj : in Processor_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Processor_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Processor) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Processor_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Processor; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Object(obj), level, result);
	if obj.Scheduler /= null then 
		result := result & ASCII.HT & "<Scheduler ref=""" & Get_Name(obj.Scheduler) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Scheduler> </Scheduler>" & Unbounded_Lf;
	end if;
	result := result & ASCII.HT & "<Network> " & XML_String(obj.Network, level) & " </Network>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Processor; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Processor id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Processor>" & Unbounded_Lf;
  return (result);
end XML_String;




End Processors;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;

with text_io;
use text_io;

with Primitive_XML_Strings;
use Primitive_XML_Strings;



Package Body Tasks is 
 
function XML_String(e : in Tasks_Type; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Tasks_Type'image (e) );
end XML_String;
 
function XML_String(e : in Policies; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Policies'image (e) );
end XML_String;
 

-- --------= Generic_Task =--------

procedure Initialize(obj : in out Generic_Task) is 
begin
	initialize(Generic_Object(obj));
	obj.Task_Type := Periodic_Type;
	obj.Cpu_Name := empty_string;
	obj.Address_Space_Name := empty_string;
	obj.Capacity := 0;
	obj.Deadline := 0;
	obj.Start_Time := 0;
	obj.Blocking_Time := 0;
	obj.Policy := Sched_Fifo;
	obj.X := 0;
	obj.Y := 0;
	initialize( obj.Offset);
	obj.Text_Memory_Size := 0;
	obj.Stack_Memory_Size := 0;
	initialize( obj.Param);
	obj.Criticality := 0;
	obj.Context_Switch_Overhead := 0;
	obj.Object_Type := Task_Object_Type;
end Initialize;

function Copy ( obj : in Generic_Task ) return Generic_Task_Ptr is
	New_Generic_Task : Generic_Task_Ptr;
begin
	New_Generic_Task := new Generic_Task'(obj);
	return Generic_Task_Ptr(New_Generic_Task);
end Copy;

function Copy ( obj : in Generic_Task_Ptr ) return Generic_Task_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Generic_Task) is 
begin
	put(Generic_Object(obj));
	put("Task_Type: "); put(obj.Task_Type); put ( "; " );
	put("Cpu_Name: "); put(obj.Cpu_Name); put ( "; " );
	put("Address_Space_Name: "); put(obj.Address_Space_Name); put ( "; " );
	put("Capacity: "); standards_io.natural_io.put(obj.Capacity); put ( "; " );
	put("Deadline: "); standards_io.natural_io.put(obj.Deadline); put ( "; " );
	put("Start_Time: "); standards_io.natural_io.put(obj.Start_Time); put ( "; " );
	put("Priority: "); put(obj.Priority); put ( "; " );
	put("Blocking_Time: "); standards_io.natural_io.put(obj.Blocking_Time); put ( "; " );
	put("Policy: "); put(obj.Policy); put ( "; " );
	put("X: "); standards_io.natural_io.put(obj.X); put ( "; " );
	put("Y: "); standards_io.natural_io.put(obj.Y); put ( "; " );
	put("Offset: "); put(obj.Offset); put ( "; " );
	put("Text_Memory_Size: "); standards_io.natural_io.put(obj.Text_Memory_Size); put ( "; " );
	put("Stack_Memory_Size: "); standards_io.natural_io.put(obj.Stack_Memory_Size); put ( "; " );
	put("Param: "); put(obj.Param); put ( "; " );
	put("Criticality: "); standards_io.natural_io.put(obj.Criticality); put ( "; " );
	put("Context_Switch_Overhead: "); standards_io.natural_io.put(obj.Context_Switch_Overhead); put ( "; " );
end Put;
 
procedure Put(obj : in Generic_Task_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Generic_Task_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Generic_Task) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Generic_Task_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Generic_Task; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Object(obj), level, result);
	result := result & ASCII.HT & "<Task_Type> " & XML_String(obj.Task_Type, level) & " </Task_Type>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Cpu_Name> " & XML_String(obj.Cpu_Name, level) & " </Cpu_Name>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Address_Space_Name> " & XML_String(obj.Address_Space_Name, level) & " </Address_Space_Name>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Capacity> " & XML_String(obj.Capacity, level) & " </Capacity>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Deadline> " & XML_String(obj.Deadline, level) & " </Deadline>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Start_Time> " & XML_String(obj.Start_Time, level) & " </Start_Time>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Priority> " & XML_String(obj.Priority, level) & " </Priority>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Blocking_Time> " & XML_String(obj.Blocking_Time, level) & " </Blocking_Time>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Policy> " & XML_String(obj.Policy, level) & " </Policy>" & Unbounded_Lf;
	result := result & ASCII.HT & "<X> " & XML_String(obj.X, level) & " </X>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Y> " & XML_String(obj.Y, level) & " </Y>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Offset> " & XML_String(obj.Offset, level) & " </Offset>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Text_Memory_Size> " & XML_String(obj.Text_Memory_Size, level) & " </Text_Memory_Size>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Stack_Memory_Size> " & XML_String(obj.Stack_Memory_Size, level) & " </Stack_Memory_Size>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Param> " & XML_String(obj.Param, level) & " </Param>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Criticality> " & XML_String(obj.Criticality, level) & " </Criticality>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Context_Switch_Overhead> " & XML_String(obj.Context_Switch_Overhead, level) & " </Context_Switch_Overhead>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Generic_Task; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Generic_Task id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Generic_Task>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Periodic_Task =--------

procedure Initialize(obj : in out Periodic_Task) is 
begin
	initialize(Generic_Task(obj));
	obj.Period := 0;
	obj.Jitter := 0;
	obj.Task_Type := Periodic_Type;
end Initialize;

function Copy ( obj : in Periodic_Task ) return Generic_Task_Ptr is
	New_Periodic_Task : Periodic_Task_Ptr;
begin
	New_Periodic_Task := new Periodic_Task'(obj);
	return Generic_Task_Ptr(New_Periodic_Task);
end Copy;

function Copy ( obj : in Periodic_Task_Ptr ) return Generic_Task_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Periodic_Task) is 
begin
	put(Generic_Task(obj));
	put("Period: "); standards_io.natural_io.put(obj.Period); put ( "; " );
	put("Jitter: "); standards_io.natural_io.put(obj.Jitter); put ( "; " );
end Put;
 
procedure Put(obj : in Periodic_Task_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Periodic_Task_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Periodic_Task) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Periodic_Task_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Periodic_Task; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Task(obj), level, result);
	result := result & ASCII.HT & "<Period> " & XML_String(obj.Period, level) & " </Period>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Jitter> " & XML_String(obj.Jitter, level) & " </Jitter>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Periodic_Task; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Periodic_Task id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Periodic_Task>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Aperiodic_Task =--------

procedure Initialize(obj : in out Aperiodic_Task) is 
begin
	initialize(Generic_Task(obj));
	obj.Task_Type := Aperiodic_Type;
end Initialize;

function Copy ( obj : in Aperiodic_Task ) return Generic_Task_Ptr is
	New_Aperiodic_Task : Aperiodic_Task_Ptr;
begin
	New_Aperiodic_Task := new Aperiodic_Task'(obj);
	return Generic_Task_Ptr(New_Aperiodic_Task);
end Copy;

function Copy ( obj : in Aperiodic_Task_Ptr ) return Generic_Task_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Aperiodic_Task) is 
begin
	put(Generic_Task(obj));
end Put;
 
procedure Put(obj : in Aperiodic_Task_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Aperiodic_Task_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Aperiodic_Task) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Aperiodic_Task_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Aperiodic_Task; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Task(obj), level, result);
end Build_Attributes_XML_String;

function XML_String(obj : in Aperiodic_Task; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Aperiodic_Task id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Aperiodic_Task>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Poisson_Task =--------

procedure Initialize(obj : in out Poisson_Task) is 
begin
	initialize(Periodic_Task(obj));
	obj.Seed := 0;
	obj.Predictable := false;
	obj.Task_Type := Poisson_Type;
end Initialize;

function Copy ( obj : in Poisson_Task ) return Generic_Task_Ptr is
	New_Poisson_Task : Poisson_Task_Ptr;
begin
	New_Poisson_Task := new Poisson_Task'(obj);
	return Generic_Task_Ptr(New_Poisson_Task);
end Copy;

function Copy ( obj : in Poisson_Task_Ptr ) return Generic_Task_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Poisson_Task) is 
begin
	put(Periodic_Task(obj));
	put("Seed: "); standards_io.integer_io.put(obj.Seed); put ( "; " );
	put("Predictable: "); standards_io.boolean_io.put(obj.Predictable); put ( "; " );
end Put;
 
procedure Put(obj : in Poisson_Task_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Poisson_Task_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Poisson_Task) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Poisson_Task_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Poisson_Task; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Periodic_Task(obj), level, result);
	result := result & ASCII.HT & "<Seed> " & XML_String(obj.Seed, level) & " </Seed>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Predictable> " & XML_String(obj.Predictable, level) & " </Predictable>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Poisson_Task; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Poisson_Task id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Poisson_Task>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Sporadic_Task =--------

procedure Initialize(obj : in out Sporadic_Task) is 
begin
	initialize(Poisson_Task(obj));
	obj.Task_Type := Sporadic_Type;
end Initialize;

function Copy ( obj : in Sporadic_Task ) return Generic_Task_Ptr is
	New_Sporadic_Task : Sporadic_Task_Ptr;
begin
	New_Sporadic_Task := new Sporadic_Task'(obj);
	return Generic_Task_Ptr(New_Sporadic_Task);
end Copy;

function Copy ( obj : in Sporadic_Task_Ptr ) return Generic_Task_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Sporadic_Task) is 
begin
	put(Poisson_Task(obj));
end Put;
 
procedure Put(obj : in Sporadic_Task_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Sporadic_Task_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Sporadic_Task) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Sporadic_Task_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Sporadic_Task; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Poisson_Task(obj), level, result);
end Build_Attributes_XML_String;

function XML_String(obj : in Sporadic_Task; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Sporadic_Task id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Sporadic_Task>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Parametric_Task =--------

procedure Initialize(obj : in out Parametric_Task) is 
begin
	initialize(Poisson_Task(obj));
	obj.Activation_Rule := empty_string;
	obj.Task_Type := Parametric_Type;
end Initialize;

function Copy ( obj : in Parametric_Task ) return Generic_Task_Ptr is
	New_Parametric_Task : Parametric_Task_Ptr;
begin
	New_Parametric_Task := new Parametric_Task'(obj);
	return Generic_Task_Ptr(New_Parametric_Task);
end Copy;

function Copy ( obj : in Parametric_Task_Ptr ) return Generic_Task_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Parametric_Task) is 
begin
	put(Poisson_Task(obj));
	put("Activation_Rule: "); put(obj.Activation_Rule); put ( "; " );
end Put;
 
procedure Put(obj : in Parametric_Task_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Parametric_Task_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Parametric_Task) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Parametric_Task_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Parametric_Task; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Poisson_Task(obj), level, result);
	result := result & ASCII.HT & "<Activation_Rule> " & XML_String(obj.Activation_Rule, level) & " </Activation_Rule>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Parametric_Task; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Parametric_Task id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Parametric_Task>" & Unbounded_Lf;
  return (result);
end XML_String;




End Tasks;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with text_io;
use text_io;



Package Body Laws is 
 
function XML_String(e : in Laws_Type; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Laws_Type'image (e) );
end XML_String;
 

End Laws;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;

with text_io;
use text_io;

with Primitive_XML_Strings;
use Primitive_XML_Strings;



Package Body Statements is 
 
function XML_String(e : in Statements_Type; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Statements_Type'image (e) );
end XML_String;
 
function XML_String(e : in Table_Types; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Table_Types'image (e) );
end XML_String;
 

-- --------= Generic_Statement =--------

procedure Initialize(obj : in out Generic_Statement) is 
begin
	initialize(Generic_Object(obj));
	obj.Statement_Type := Put_Statement_Type;
	obj.Line_Number := 0;
	obj.File_Name := empty_string;
	obj.Object_Type := Statement_Object_Type;
end Initialize;

function Copy ( obj : in Generic_Statement ) return Generic_Statement_Ptr is
	New_Generic_Statement : Generic_Statement_Ptr;
begin
	New_Generic_Statement := new Generic_Statement'(obj);
	return Generic_Statement_Ptr(New_Generic_Statement);
end Copy;

function Copy ( obj : in Generic_Statement_Ptr ) return Generic_Statement_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Generic_Statement) is 
begin
	put(Generic_Object(obj));
	put("Statement_Type: "); put(obj.Statement_Type); put ( "; " );
	put("Line_Number: "); standards_io.natural_io.put(obj.Line_Number); put ( "; " );
	put("File_Name: "); put(obj.File_Name); put ( "; " );
	put("Next_Statement: "); if obj.Next_Statement /= null then put(obj.Next_Statement.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Generic_Statement_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Generic_Statement_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Generic_Statement) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Generic_Statement_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Generic_Statement; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Object(obj), level, result);
	result := result & ASCII.HT & "<Statement_Type> " & XML_String(obj.Statement_Type, level) & " </Statement_Type>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Line_Number> " & XML_String(obj.Line_Number, level) & " </Line_Number>" & Unbounded_Lf;
	result := result & ASCII.HT & "<File_Name> " & XML_String(obj.File_Name, level) & " </File_Name>" & Unbounded_Lf;
	if obj.Next_Statement /= null then 
		result := result & ASCII.HT & "<Next_Statement ref=""" & Get_Name(obj.Next_Statement) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Next_Statement> </Next_Statement>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Generic_Statement; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Generic_Statement id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Generic_Statement>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Nop_Statement =--------

procedure Initialize(obj : in out Nop_Statement) is 
begin
	initialize(Generic_Statement(obj));
	obj.Statement_Type := Nop_Statement_Type;
end Initialize;

function Copy ( obj : in Nop_Statement ) return Generic_Statement_Ptr is
	New_Nop_Statement : Nop_Statement_Ptr;
begin
	New_Nop_Statement := new Nop_Statement'(obj);
	return Generic_Statement_Ptr(New_Nop_Statement);
end Copy;

function Copy ( obj : in Nop_Statement_Ptr ) return Generic_Statement_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Nop_Statement) is 
begin
	put(Generic_Statement(obj));
end Put;
 
procedure Put(obj : in Nop_Statement_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Nop_Statement_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Nop_Statement) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Nop_Statement_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Nop_Statement; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Statement(obj), level, result);
end Build_Attributes_XML_String;

function XML_String(obj : in Nop_Statement; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Nop_Statement id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Nop_Statement>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Exit_Statement =--------

procedure Initialize(obj : in out Exit_Statement) is 
begin
	initialize(Generic_Statement(obj));
	obj.Statement_Type := Exit_Statement_Type;
end Initialize;

function Copy ( obj : in Exit_Statement ) return Generic_Statement_Ptr is
	New_Exit_Statement : Exit_Statement_Ptr;
begin
	New_Exit_Statement := new Exit_Statement'(obj);
	return Generic_Statement_Ptr(New_Exit_Statement);
end Copy;

function Copy ( obj : in Exit_Statement_Ptr ) return Generic_Statement_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Exit_Statement) is 
begin
	put(Generic_Statement(obj));
end Put;
 
procedure Put(obj : in Exit_Statement_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Exit_Statement_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Exit_Statement) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Exit_Statement_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Exit_Statement; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Statement(obj), level, result);
end Build_Attributes_XML_String;

function XML_String(obj : in Exit_Statement; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Exit_Statement id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Exit_Statement>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Put_Statement =--------

procedure Initialize(obj : in out Put_Statement) is 
begin
	initialize(Generic_Statement(obj));
	obj.Statement_Type := Put_Statement_Type;
end Initialize;

function Copy ( obj : in Put_Statement ) return Generic_Statement_Ptr is
	New_Put_Statement : Put_Statement_Ptr;
begin
	New_Put_Statement := new Put_Statement'(obj);
	return Generic_Statement_Ptr(New_Put_Statement);
end Copy;

function Copy ( obj : in Put_Statement_Ptr ) return Generic_Statement_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Put_Statement) is 
begin
	put(Generic_Statement(obj));
	put("Put_From: "); if obj.Put_From /= null then put(obj.Put_From.all); else put("null"); end if;put ( "; " );
	put("Put_To: "); if obj.Put_To /= null then put(obj.Put_To.all); else put("null"); end if;put ( "; " );
	put("Expression_To_Be_displayed: "); if obj.Expression_To_Be_displayed /= null then put(obj.Expression_To_Be_displayed.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Put_Statement_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Put_Statement_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Put_Statement) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Put_Statement_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Put_Statement; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Statement(obj), level, result);
	if obj.Put_From /= null then 
		result := result & ASCII.HT & "<Put_From ref=""" & Get_Name(obj.Put_From) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Put_From> </Put_From>" & Unbounded_Lf;
	end if;
	if obj.Put_To /= null then 
		result := result & ASCII.HT & "<Put_To ref=""" & Get_Name(obj.Put_To) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Put_To> </Put_To>" & Unbounded_Lf;
	end if;
	if obj.Expression_To_Be_displayed /= null then 
		result := result & ASCII.HT & "<Expression_To_Be_displayed ref=""" & Get_Name(obj.Expression_To_Be_displayed) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Expression_To_Be_displayed> </Expression_To_Be_displayed>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Put_Statement; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Put_Statement id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Put_Statement>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= If_Statement =--------

procedure Initialize(obj : in out If_Statement) is 
begin
	initialize(Generic_Statement(obj));
	obj.Statement_Type := If_Statement_Type;
end Initialize;

function Copy ( obj : in If_Statement ) return Generic_Statement_Ptr is
	New_If_Statement : If_Statement_Ptr;
begin
	New_If_Statement := new If_Statement'(obj);
	return Generic_Statement_Ptr(New_If_Statement);
end Copy;

function Copy ( obj : in If_Statement_Ptr ) return Generic_Statement_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in If_Statement) is 
begin
	put(Generic_Statement(obj));
	put("Bool_Expression: "); if obj.Bool_Expression /= null then put(obj.Bool_Expression.all); else put("null"); end if;put ( "; " );
	put("Else_Statement: "); if obj.Else_Statement /= null then put(obj.Else_Statement.all); else put("null"); end if;put ( "; " );
	put("Then_Statement: "); if obj.Then_Statement /= null then put(obj.Then_Statement.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in If_Statement_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in If_Statement_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in If_Statement) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in If_Statement_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in If_Statement; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Statement(obj), level, result);
	if obj.Bool_Expression /= null then 
		result := result & ASCII.HT & "<Bool_Expression ref=""" & Get_Name(obj.Bool_Expression) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Bool_Expression> </Bool_Expression>" & Unbounded_Lf;
	end if;
	if obj.Else_Statement /= null then 
		result := result & ASCII.HT & "<Else_Statement ref=""" & Get_Name(obj.Else_Statement) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Else_Statement> </Else_Statement>" & Unbounded_Lf;
	end if;
	if obj.Then_Statement /= null then 
		result := result & ASCII.HT & "<Then_Statement ref=""" & Get_Name(obj.Then_Statement) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Then_Statement> </Then_Statement>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in If_Statement; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<If_Statement id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</If_Statement>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Assign_Statement =--------

procedure Initialize(obj : in out Assign_Statement) is 
begin
	initialize(Generic_Statement(obj));
	obj.Statement_Type := Assign_Statement_Type;
end Initialize;

function Copy ( obj : in Assign_Statement ) return Generic_Statement_Ptr is
	New_Assign_Statement : Assign_Statement_Ptr;
begin
	New_Assign_Statement := new Assign_Statement'(obj);
	return Generic_Statement_Ptr(New_Assign_Statement);
end Copy;

function Copy ( obj : in Assign_Statement_Ptr ) return Generic_Statement_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Assign_Statement) is 
begin
	put(Generic_Statement(obj));
	put("Lvalue: "); if obj.Lvalue /= null then put(obj.Lvalue.all); else put("null"); end if;put ( "; " );
	put("Rvalue: "); if obj.Rvalue /= null then put(obj.Rvalue.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Assign_Statement_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Assign_Statement_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Assign_Statement) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Assign_Statement_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Assign_Statement; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Statement(obj), level, result);
	if obj.Lvalue /= null then 
		result := result & ASCII.HT & "<Lvalue ref=""" & Get_Name(obj.Lvalue) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Lvalue> </Lvalue>" & Unbounded_Lf;
	end if;
	if obj.Rvalue /= null then 
		result := result & ASCII.HT & "<Rvalue ref=""" & Get_Name(obj.Rvalue) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Rvalue> </Rvalue>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Assign_Statement; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Assign_Statement id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Assign_Statement>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Clock_Statement =--------

procedure Initialize(obj : in out Clock_Statement) is 
begin
	initialize(Assign_Statement(obj));
	obj.Statement_Type := Clock_Statement_Type;
end Initialize;

function Copy ( obj : in Clock_Statement ) return Generic_Statement_Ptr is
	New_Clock_Statement : Clock_Statement_Ptr;
begin
	New_Clock_Statement := new Clock_Statement'(obj);
	return Generic_Statement_Ptr(New_Clock_Statement);
end Copy;

function Copy ( obj : in Clock_Statement_Ptr ) return Generic_Statement_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Clock_Statement) is 
begin
	put(Assign_Statement(obj));
end Put;
 
procedure Put(obj : in Clock_Statement_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Clock_Statement_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Clock_Statement) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Clock_Statement_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Clock_Statement; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Assign_Statement(obj), level, result);
end Build_Attributes_XML_String;

function XML_String(obj : in Clock_Statement; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Clock_Statement id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Clock_Statement>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= For_Statement =--------

procedure Initialize(obj : in out For_Statement) is 
begin
	initialize(Generic_Statement(obj));
	obj.For_Type := Task_Table_Type;
	obj.Statement_Type := For_Statement_Type;
end Initialize;

function Copy ( obj : in For_Statement ) return Generic_Statement_Ptr is
	New_For_Statement : For_Statement_Ptr;
begin
	New_For_Statement := new For_Statement'(obj);
	return Generic_Statement_Ptr(New_For_Statement);
end Copy;

function Copy ( obj : in For_Statement_Ptr ) return Generic_Statement_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in For_Statement) is 
begin
	put(Generic_Statement(obj));
	put("For_Type: "); put(obj.For_Type); put ( "; " );
	put("Included_Statement: "); if obj.Included_Statement /= null then put(obj.Included_Statement.all); else put("null"); end if;put ( "; " );
	put("For_Index: "); if obj.For_Index /= null then put(obj.For_Index.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in For_Statement_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in For_Statement_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in For_Statement) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in For_Statement_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in For_Statement; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Statement(obj), level, result);
	result := result & ASCII.HT & "<For_Type> " & XML_String(obj.For_Type, level) & " </For_Type>" & Unbounded_Lf;
	if obj.Included_Statement /= null then 
		result := result & ASCII.HT & "<Included_Statement ref=""" & Get_Name(obj.Included_Statement) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Included_Statement> </Included_Statement>" & Unbounded_Lf;
	end if;
	if obj.For_Index /= null then 
		result := result & ASCII.HT & "<For_Index ref=""" & Get_Name(obj.For_Index) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<For_Index> </For_Index>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in For_Statement; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<For_Statement id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</For_Statement>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Return_Statement =--------

procedure Initialize(obj : in out Return_Statement) is 
begin
	initialize(Generic_Statement(obj));
	obj.Statement_Type := Return_Statement_Type;
end Initialize;

function Copy ( obj : in Return_Statement ) return Generic_Statement_Ptr is
	New_Return_Statement : Return_Statement_Ptr;
begin
	New_Return_Statement := new Return_Statement'(obj);
	return Generic_Statement_Ptr(New_Return_Statement);
end Copy;

function Copy ( obj : in Return_Statement_Ptr ) return Generic_Statement_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Return_Statement) is 
begin
	put(Generic_Statement(obj));
	put("Return_Value: "); if obj.Return_Value /= null then put(obj.Return_Value.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Return_Statement_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Return_Statement_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Return_Statement) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Return_Statement_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Return_Statement; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Statement(obj), level, result);
	if obj.Return_Value /= null then 
		result := result & ASCII.HT & "<Return_Value ref=""" & Get_Name(obj.Return_Value) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Return_Value> </Return_Value>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Return_Statement; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Return_Statement id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Return_Statement>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= While_Statement =--------

procedure Initialize(obj : in out While_Statement) is 
begin
	initialize(Generic_Statement(obj));
	obj.Statement_Type := While_Statement_Type;
end Initialize;

function Copy ( obj : in While_Statement ) return Generic_Statement_Ptr is
	New_While_Statement : While_Statement_Ptr;
begin
	New_While_Statement := new While_Statement'(obj);
	return Generic_Statement_Ptr(New_While_Statement);
end Copy;

function Copy ( obj : in While_Statement_Ptr ) return Generic_Statement_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in While_Statement) is 
begin
	put(Generic_Statement(obj));
	put("Included_Statement: "); if obj.Included_Statement /= null then put(obj.Included_Statement.all); else put("null"); end if;put ( "; " );
	put("Condition: "); if obj.Condition /= null then put(obj.Condition.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in While_Statement_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in While_Statement_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in While_Statement) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in While_Statement_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in While_Statement; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Statement(obj), level, result);
	if obj.Included_Statement /= null then 
		result := result & ASCII.HT & "<Included_Statement ref=""" & Get_Name(obj.Included_Statement) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Included_Statement> </Included_Statement>" & Unbounded_Lf;
	end if;
	if obj.Condition /= null then 
		result := result & ASCII.HT & "<Condition ref=""" & Get_Name(obj.Condition) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Condition> </Condition>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in While_Statement; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<While_Statement id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</While_Statement>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Random_Initialize_Statement =--------

procedure Initialize(obj : in out Random_Initialize_Statement) is 
begin
	initialize(Generic_Statement(obj));
	obj.Lvalue := empty_string;
	obj.Law := Uniform_Law_Type;
	obj.Statement_Type := Random_Initialize_Statement_Type;
end Initialize;

function Copy ( obj : in Random_Initialize_Statement ) return Generic_Statement_Ptr is
	New_Random_Initialize_Statement : Random_Initialize_Statement_Ptr;
begin
	New_Random_Initialize_Statement := new Random_Initialize_Statement'(obj);
	return Generic_Statement_Ptr(New_Random_Initialize_Statement);
end Copy;

function Copy ( obj : in Random_Initialize_Statement_Ptr ) return Generic_Statement_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Random_Initialize_Statement) is 
begin
	put(Generic_Statement(obj));
	put("Lvalue: "); put(obj.Lvalue); put ( "; " );
	put("Law: "); put(obj.Law); put ( "; " );
	put("Parameter1: "); if obj.Parameter1 /= null then put(obj.Parameter1.all); else put("null"); end if;put ( "; " );
	put("Parameter2: "); if obj.Parameter2 /= null then put(obj.Parameter2.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Random_Initialize_Statement_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Random_Initialize_Statement_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Random_Initialize_Statement) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Random_Initialize_Statement_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Random_Initialize_Statement; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Statement(obj), level, result);
	result := result & ASCII.HT & "<Lvalue> " & XML_String(obj.Lvalue, level) & " </Lvalue>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Law> " & XML_String(obj.Law, level) & " </Law>" & Unbounded_Lf;
	if obj.Parameter1 /= null then 
		result := result & ASCII.HT & "<Parameter1 ref=""" & Get_Name(obj.Parameter1) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Parameter1> </Parameter1>" & Unbounded_Lf;
	end if;
	if obj.Parameter2 /= null then 
		result := result & ASCII.HT & "<Parameter2 ref=""" & Get_Name(obj.Parameter2) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Parameter2> </Parameter2>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Random_Initialize_Statement; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Random_Initialize_Statement id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Random_Initialize_Statement>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Set_Statement =--------

procedure Initialize(obj : in out Set_Statement) is 
begin
	initialize(Generic_Statement(obj));
	obj.Set_Id := empty_string;
	obj.Statement_Type := Set_Statement_Type;
end Initialize;

function Copy ( obj : in Set_Statement ) return Generic_Statement_Ptr is
	New_Set_Statement : Set_Statement_Ptr;
begin
	New_Set_Statement := new Set_Statement'(obj);
	return Generic_Statement_Ptr(New_Set_Statement);
end Copy;

function Copy ( obj : in Set_Statement_Ptr ) return Generic_Statement_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Set_Statement) is 
begin
	put(Generic_Statement(obj));
	put("Set_Id: "); put(obj.Set_Id); put ( "; " );
	put("Set_Value: "); if obj.Set_Value /= null then put(obj.Set_Value.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Set_Statement_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Set_Statement_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Set_Statement) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Set_Statement_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Set_Statement; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Statement(obj), level, result);
	result := result & ASCII.HT & "<Set_Id> " & XML_String(obj.Set_Id, level) & " </Set_Id>" & Unbounded_Lf;
	if obj.Set_Value /= null then 
		result := result & ASCII.HT & "<Set_Value ref=""" & Get_Name(obj.Set_Value) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Set_Value> </Set_Value>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Set_Statement; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Set_Statement id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Set_Statement>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Subprogram_Statement =--------

procedure Initialize(obj : in out Subprogram_Statement) is 
begin
	initialize(Generic_Statement(obj));
	obj.Is_A_Function := false;
	obj.Subprogram_Name := empty_string;
	obj.Statement_Type := Subprogram_Statement_Type;
end Initialize;

function Copy ( obj : in Subprogram_Statement ) return Generic_Statement_Ptr is
	New_Subprogram_Statement : Subprogram_Statement_Ptr;
begin
	New_Subprogram_Statement := new Subprogram_Statement'(obj);
	return Generic_Statement_Ptr(New_Subprogram_Statement);
end Copy;

function Copy ( obj : in Subprogram_Statement_Ptr ) return Generic_Statement_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Subprogram_Statement) is 
begin
	put(Generic_Statement(obj));
	put("Included_Statement: "); if obj.Included_Statement /= null then put(obj.Included_Statement.all); else put("null"); end if;put ( "; " );
	put("Is_A_Function: "); standards_io.boolean_io.put(obj.Is_A_Function); put ( "; " );
	put("Subprogram_Name: "); put(obj.Subprogram_Name); put ( "; " );
end Put;
 
procedure Put(obj : in Subprogram_Statement_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Subprogram_Statement_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Subprogram_Statement) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Subprogram_Statement_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Subprogram_Statement; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Statement(obj), level, result);
	if obj.Included_Statement /= null then 
		result := result & ASCII.HT & "<Included_Statement ref=""" & Get_Name(obj.Included_Statement) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Included_Statement> </Included_Statement>" & Unbounded_Lf;
	end if;
	result := result & ASCII.HT & "<Is_A_Function> " & XML_String(obj.Is_A_Function, level) & " </Is_A_Function>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Subprogram_Name> " & XML_String(obj.Subprogram_Name, level) & " </Subprogram_Name>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Subprogram_Statement; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Subprogram_Statement id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Subprogram_Statement>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Subprogram_Call_Statement =--------

procedure Initialize(obj : in out Subprogram_Call_Statement) is 
begin
	initialize(Generic_Statement(obj));
	obj.Is_A_Function := false;
	obj.Statement_Type := Subprogram_Call_Statement_Type;
end Initialize;

function Copy ( obj : in Subprogram_Call_Statement ) return Generic_Statement_Ptr is
	New_Subprogram_Call_Statement : Subprogram_Call_Statement_Ptr;
begin
	New_Subprogram_Call_Statement := new Subprogram_Call_Statement'(obj);
	return Generic_Statement_Ptr(New_Subprogram_Call_Statement);
end Copy;

function Copy ( obj : in Subprogram_Call_Statement_Ptr ) return Generic_Statement_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Subprogram_Call_Statement) is 
begin
	put(Generic_Statement(obj));
	put("Is_A_Function: "); standards_io.boolean_io.put(obj.Is_A_Function); put ( "; " );
	put("Called_Subprogram: "); if obj.Called_Subprogram /= null then put(obj.Called_Subprogram.all); else put("null"); end if;put ( "; " );
	put("Return_Value: "); if obj.Return_Value /= null then put(obj.Return_Value.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Subprogram_Call_Statement_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Subprogram_Call_Statement_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Subprogram_Call_Statement) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Subprogram_Call_Statement_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Subprogram_Call_Statement; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Statement(obj), level, result);
	result := result & ASCII.HT & "<Is_A_Function> " & XML_String(obj.Is_A_Function, level) & " </Is_A_Function>" & Unbounded_Lf;
	if obj.Called_Subprogram /= null then 
		result := result & ASCII.HT & "<Called_Subprogram ref=""" & Get_Name(obj.Called_Subprogram) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Called_Subprogram> </Called_Subprogram>" & Unbounded_Lf;
	end if;
	if obj.Return_Value /= null then 
		result := result & ASCII.HT & "<Return_Value ref=""" & Get_Name(obj.Return_Value) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Return_Value> </Return_Value>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Subprogram_Call_Statement; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Subprogram_Call_Statement id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Subprogram_Call_Statement>" & Unbounded_Lf;
  return (result);
end XML_String;




End Statements;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;

with text_io;
use text_io;

with Primitive_XML_Strings;
use Primitive_XML_Strings;



Package Body Sections is 
 
function XML_String(e : in Sections_Type; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Sections_Type'image (e) );
end XML_String;
 

-- --------= Generic_Section =--------

procedure Initialize(obj : in out Generic_Section) is 
begin
	initialize(Generic_Object(obj));
	obj.Section_type := Automaton_Type;
	obj.File_Name := empty_string;
	obj.Object_Type := Section_Object_Type;
end Initialize;

function Copy ( obj : in Generic_Section ) return Generic_Section_Ptr is
	New_Generic_Section : Generic_Section_Ptr;
begin
	New_Generic_Section := new Generic_Section'(obj);
	return Generic_Section_Ptr(New_Generic_Section);
end Copy;

function Copy ( obj : in Generic_Section_Ptr ) return Generic_Section_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Generic_Section) is 
begin
	put(Generic_Object(obj));
	put("Section_type: "); put(obj.Section_type); put ( "; " );
	put("File_Name: "); put(obj.File_Name); put ( "; " );
end Put;
 
procedure Put(obj : in Generic_Section_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Generic_Section_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Generic_Section) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Generic_Section_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Generic_Section; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Object(obj), level, result);
	result := result & ASCII.HT & "<Section_type> " & XML_String(obj.Section_type, level) & " </Section_type>" & Unbounded_Lf;
	result := result & ASCII.HT & "<File_Name> " & XML_String(obj.File_Name, level) & " </File_Name>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Generic_Section; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Generic_Section id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Generic_Section>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Computation_Section =--------

procedure Initialize(obj : in out Computation_Section) is 
begin
	initialize(Generic_Section(obj));
end Initialize;

function Copy ( obj : in Computation_Section ) return Generic_Section_Ptr is
	New_Computation_Section : Computation_Section_Ptr;
begin
	New_Computation_Section := new Computation_Section'(obj);
	return Generic_Section_Ptr(New_Computation_Section);
end Copy;

function Copy ( obj : in Computation_Section_Ptr ) return Generic_Section_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Computation_Section) is 
begin
	put(Generic_Section(obj));
	put("First_Statement: "); if obj.First_Statement /= null then put(obj.First_Statement.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Computation_Section_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Computation_Section_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Computation_Section) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Computation_Section_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Computation_Section; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Section(obj), level, result);
	if obj.First_Statement /= null then 
		result := result & ASCII.HT & "<First_Statement ref=""" & Get_Name(obj.First_Statement) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<First_Statement> </First_Statement>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Computation_Section; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Computation_Section id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Computation_Section>" & Unbounded_Lf;
  return (result);
end XML_String;




-- --------= Synchronization_Section =--------

procedure Initialize(obj : in out Synchronization_Section) is 
begin
	initialize(Generic_Section(obj));
	initialize( obj.State_List);
	initialize( obj.Transition_List);
end Initialize;

function Copy ( obj : in Synchronization_Section ) return Generic_Section_Ptr is
	New_Synchronization_Section : Synchronization_Section_Ptr;
begin
	New_Synchronization_Section := new Synchronization_Section'(obj);
	return Generic_Section_Ptr(New_Synchronization_Section);
end Copy;

function Copy ( obj : in Synchronization_Section_Ptr ) return Generic_Section_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Synchronization_Section) is 
begin
	put(Generic_Section(obj));
	put("State_List: "); put(obj.State_List); put ( "; " );
	put("Transition_List: "); put(obj.Transition_List); put ( "; " );
end Put;
 
procedure Put(obj : in Synchronization_Section_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Synchronization_Section_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Synchronization_Section) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Synchronization_Section_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Synchronization_Section; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Section(obj), level, result);
	result := result & ASCII.HT & "<State_List> " & XML_String(obj.State_List, level) & " </State_List>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Transition_List> " & XML_String(obj.Transition_List, level) & " </Transition_List>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Synchronization_Section; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Synchronization_Section id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Synchronization_Section>" & Unbounded_Lf;
  return (result);
end XML_String;




End Sections;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with text_io;
use text_io;



Package Body Simulations is 
 
function XML_String(e : in Simulation_Type; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Simulation_Type'image (e) );
end XML_String;
 

End Simulations;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with Primitive_XML_Strings;
use Primitive_XML_Strings;

with text_io;
use text_io;



Package Body Networks is 
 
function XML_String(e : in Networks_Type; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Networks_Type'image (e) );
end XML_String;
 

-- --------= Network =--------

procedure Initialize(obj : in out Network) is 
begin
	initialize(Generic_Object(obj));
	obj.Network_Type := Bounded_Delay;
	obj.Object_Type := Network_Object_Type;
end Initialize;

function Copy ( obj : in Network ) return Network_Ptr is
	New_Network : Network_Ptr;
begin
	New_Network := new Network'(obj);
	return Network_Ptr(New_Network);
end Copy;

function Copy ( obj : in Network_Ptr ) return Network_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Network) is 
begin
	put(Generic_Object(obj));
	put("Network_Type: "); put(obj.Network_Type); put ( "; " );
end Put;
 
procedure Put(obj : in Network_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Network_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Network) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Network_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Network; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Object(obj), level, result);
	result := result & ASCII.HT & "<Network_Type> " & XML_String(obj.Network_Type, level) & " </Network_Type>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Network; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Network id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Network>" & Unbounded_Lf;
  return (result);
end XML_String;




End Networks;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with Primitive_XML_Strings;
use Primitive_XML_Strings;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;

with text_io;
use text_io;



Package Body Buffers is 
 
function XML_String(e : in Role_type; level : in natural := 0) return Unbounded_String is
begin
	return to_unbounded_string(Role_type'image (e) );
end XML_String;
 

-- --------= Buffer_Role =--------

procedure Initialize(obj : out Buffer_Role) is 
begin
	obj.The_Role := No_Role;
	obj.Size := 0;
	obj.Time := 0;
end Initialize;

procedure Put(obj : in Buffer_Role) is 
begin
	put("The_Role: "); put(obj.The_Role); put ( "; " );
	put("Size: "); standards_io.natural_io.put(obj.Size); put ( "; " );
	put("Time: "); standards_io.natural_io.put(obj.Time); put ( "; " );
end Put;
 
procedure Put(obj : in Buffer_Role_Ptr) is
begin
	Put(Obj.All);
end Put;


procedure Build_Attributes_XML_String(obj : in Buffer_Role; level : in natural := 0; result : in out Unbounded_String) is 
begin
	result := result & ASCII.HT & "<The_Role> " & XML_String(obj.The_Role, level) & " </The_Role>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Size> " & XML_String(obj.Size, level) & " </Size>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Time> " & XML_String(obj.Time, level) & " </Time>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Buffer_Role; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Buffer_Role>" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Buffer_Role>" & Unbounded_Lf;
	return (result);
end XML_String;



-- --------= Buffer =--------

procedure Initialize(obj : in out Buffer) is 
begin
	initialize(Generic_Object(obj));
	obj.Cpu_Name := empty_string;
	obj.Address_Space_Name := empty_string;
	obj.Size := 0;
	initialize( obj.Roles);
	obj.X := 0;
	obj.Y := 0;
	obj.Object_Type := Buffer_Object_Type;
end Initialize;

function Copy ( obj : in Buffer ) return Buffer_Ptr is
	New_Buffer : Buffer_Ptr;
begin
	New_Buffer := new Buffer'(obj);
	return Buffer_Ptr(New_Buffer);
end Copy;

function Copy ( obj : in Buffer_Ptr ) return Buffer_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Buffer) is 
begin
	put(Generic_Object(obj));
	put("Cpu_Name: "); put(obj.Cpu_Name); put ( "; " );
	put("Address_Space_Name: "); put(obj.Address_Space_Name); put ( "; " );
	put("Queueing_System_Type: "); put(obj.Queueing_System_Type); put ( "; " );
	put("Size: "); standards_io.natural_io.put(obj.Size); put ( "; " );
	put("Roles: "); put(obj.Roles); put ( "; " );
	put("X: "); standards_io.natural_io.put(obj.X); put ( "; " );
	put("Y: "); standards_io.natural_io.put(obj.Y); put ( "; " );
end Put;
 
procedure Put(obj : in Buffer_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Buffer_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Buffer) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Buffer_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Buffer; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Object(obj), level, result);
	result := result & ASCII.HT & "<Cpu_Name> " & XML_String(obj.Cpu_Name, level) & " </Cpu_Name>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Address_Space_Name> " & XML_String(obj.Address_Space_Name, level) & " </Address_Space_Name>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Queueing_System_Type> " & XML_String(obj.Queueing_System_Type, level) & " </Queueing_System_Type>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Size> " & XML_String(obj.Size, level) & " </Size>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Roles> " & XML_String(obj.Roles, level) & " </Roles>" & Unbounded_Lf;
	result := result & ASCII.HT & "<X> " & XML_String(obj.X, level) & " </X>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Y> " & XML_String(obj.Y, level) & " </Y>" & Unbounded_Lf;
end Build_Attributes_XML_String;

function XML_String(obj : in Buffer; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Buffer id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Buffer>" & Unbounded_Lf;
  return (result);
end XML_String;




End Buffers;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;

with text_io;
use text_io;

with Primitive_XML_Strings;
use Primitive_XML_Strings;



Package Body Address_Spaces is 
 

-- --------= Address_Space =--------

procedure Initialize(obj : in out Address_Space) is 
begin
	initialize(Generic_Object(obj));
	obj.Cpu_Name := empty_string;
	obj.Text_Memory_Size := 0;
	obj.Stack_Memory_Size := 0;
	obj.Data_Memory_Size := 0;
	obj.Heap_Memory_Size := 0;
	obj.Object_Type := Address_Space_Object_Type;
end Initialize;

function Copy ( obj : in Address_Space ) return Address_Space_Ptr is
	New_Address_Space : Address_Space_Ptr;
begin
	New_Address_Space := new Address_Space'(obj);
	return Address_Space_Ptr(New_Address_Space);
end Copy;

function Copy ( obj : in Address_Space_Ptr ) return Address_Space_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Address_Space) is 
begin
	put(Generic_Object(obj));
	put("Cpu_Name: "); put(obj.Cpu_Name); put ( "; " );
	put("Text_Memory_Size: "); standards_io.natural_io.put(obj.Text_Memory_Size); put ( "; " );
	put("Stack_Memory_Size: "); standards_io.natural_io.put(obj.Stack_Memory_Size); put ( "; " );
	put("Data_Memory_Size: "); standards_io.natural_io.put(obj.Data_Memory_Size); put ( "; " );
	put("Heap_Memory_Size: "); standards_io.natural_io.put(obj.Heap_Memory_Size); put ( "; " );
	put("Scheduler: "); if obj.Scheduler /= null then put(obj.Scheduler.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Address_Space_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Address_Space_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Address_Space) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Address_Space_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;


procedure Build_Attributes_XML_String(obj : in Address_Space; level : in natural := 0; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Object(obj), level, result);
	result := result & ASCII.HT & "<Cpu_Name> " & XML_String(obj.Cpu_Name, level) & " </Cpu_Name>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Text_Memory_Size> " & XML_String(obj.Text_Memory_Size, level) & " </Text_Memory_Size>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Stack_Memory_Size> " & XML_String(obj.Stack_Memory_Size, level) & " </Stack_Memory_Size>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Data_Memory_Size> " & XML_String(obj.Data_Memory_Size, level) & " </Data_Memory_Size>" & Unbounded_Lf;
	result := result & ASCII.HT & "<Heap_Memory_Size> " & XML_String(obj.Heap_Memory_Size, level) & " </Heap_Memory_Size>" & Unbounded_Lf;
	if obj.Scheduler /= null then 
		result := result & ASCII.HT & "<Scheduler ref=""" & Get_Name(obj.Scheduler) & """ />" & Unbounded_Lf;
	else
		result := result & ASCII.HT & "<Scheduler> </Scheduler>" & Unbounded_Lf;
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Address_Space; level : in natural := 0) return Unbounded_String is
	result : Unbounded_String;
begin
	result := "<Address_Space id=""" & Get_Name(obj) & """ >" & Unbounded_Lf;
	Build_Attributes_XML_String(obj, level, result);
	result := result & "</Address_Space>" & Unbounded_Lf;
  return (result);
end XML_String;




End Address_Spaces;

