------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with standards_io;
use standards_io;

use standards_io.boolean_io;

with Objects;
use Objects;

with Unchecked_Deallocation;

with Lists;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;

with framework_config;
use framework_config;

with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with Expressions;
use Expressions;

with Statements;
use Statements;

with Indexed_Tables;

use standards_io.natural_io;



Package Automaton is 
 
type Synchronizations_Type is (
	Send,
	Receive);

procedure To_Synchronizations_Type is
new Convert_Strings(Synchronizations_Type, Send);
procedure To_Synchronizations_Type is
new Convert_Unbounded_Strings(Synchronizations_Type, Send);
function XML_String (e : in Synchronizations_Type; level : in natural := 0) return Unbounded_String;
package Synchronizations_Type_io is new text_io.enumeration_io(Synchronizations_Type);
use Synchronizations_Type_io;

type Status_Type is (
	Ready,
	Pended,
	Rendezvous,
	Guarded,
	Unreachable);

procedure To_Status_Type is
new Convert_Strings(Status_Type, Ready);
procedure To_Status_Type is
new Convert_Unbounded_Strings(Status_Type, Ready);
function XML_String (e : in Status_Type; level : in natural := 0) return Unbounded_String;
package Status_Type_io is new text_io.enumeration_io(Status_Type);
use Status_Type_io;


-- --------= State =--------

type State;
type State_Ptr is access all State'Class;
type State is new Generic_Object with 
record
 Is_Initial : Boolean;
end record;

procedure Initialize(obj : in out State);
procedure Put(obj : in State);
procedure Put(obj : in State_Ptr);
procedure Put_Name(obj : in State_Ptr);
procedure Build_Attributes_XML_String(obj : in State; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in State; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in State) return Unbounded_String;
function Get_Name (obj : in State_Ptr) return Unbounded_String;
function Copy(obj : in State_Ptr) return State_Ptr;
function Copy(obj : in State) return State_Ptr;
procedure Free  is new Unchecked_Deallocation
	(State'Class, State_Ptr);

package State_Lists_Package is new Lists(State_Ptr, Put, Free);
use State_Lists_Package;

subtype State_Lists is State_Lists_Package.List;

subtype State_Lists_Iterator is State_Lists_Package.Iterator;


-- --------= Synchronization =--------

type Synchronization;
type Synchronization_Ptr is access all Synchronization'Class;
type Synchronization is new Generic_Object with 
record
 Synchronization_Type : Synchronizations_Type;
end record;

procedure Initialize(obj : in out Synchronization);
procedure Put(obj : in Synchronization);
procedure Put(obj : in Synchronization_Ptr);
procedure Put_Name(obj : in Synchronization_Ptr);
procedure Build_Attributes_XML_String(obj : in Synchronization; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Synchronization; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Synchronization) return Unbounded_String;
function Get_Name (obj : in Synchronization_Ptr) return Unbounded_String;
function Copy(obj : in Synchronization_Ptr) return Synchronization_Ptr;
function Copy(obj : in Synchronization) return Synchronization_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Synchronization'Class, Synchronization_Ptr);


-- --------= Transition =--------

type Transition;
type Transition_Ptr is access all Transition'Class;
type Transition is new Generic_Object with 
record
 From_State : state_Ptr;
 To_State : state_Ptr;
 Guards : Generic_Expression_Ptr;
 Clocks : Generic_Statement_Ptr;
 Synchronization : synchronization_Ptr;
end record;

procedure Initialize(obj : in out Transition);
procedure Put(obj : in Transition);
procedure Put(obj : in Transition_Ptr);
procedure Put_Name(obj : in Transition_Ptr);
procedure Build_Attributes_XML_String(obj : in Transition; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Transition; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Transition) return Unbounded_String;
function Get_Name (obj : in Transition_Ptr) return Unbounded_String;
function Copy(obj : in Transition_Ptr) return Transition_Ptr;
function Copy(obj : in Transition) return Transition_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Transition'Class, Transition_Ptr);

package Transition_Lists_Package is new Lists(Transition_Ptr, Put, Free);
use Transition_Lists_Package;

subtype Transition_Lists is Transition_Lists_Package.List;

subtype Transition_Lists_Iterator is Transition_Lists_Package.Iterator;


-- --------= Automaton_Status =--------
 
type Automaton_Status is
record
 Current_State : state_Ptr;
end record;

type Automaton_Status_Ptr is access all Automaton_Status;

procedure Initialize(obj : out Automaton_Status);
procedure Put(obj : in Automaton_Status);
procedure Put(obj : in Automaton_Status_Ptr);
procedure Build_Attributes_XML_String(obj : in Automaton_Status; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Automaton_Status; level : in natural := 0) return Unbounded_String;

package Package_Automaton_Status is new Indexed_Tables(Automaton_Status, Unbounded_String, Framework_Config.Max_Sections, 0, Put, Initialize, Put);
use Package_Automaton_Status;

subtype Automaton_Status_Table is Package_Automaton_Status.Indexed_Table;

subtype Automaton_Status_Range is Package_Automaton_Status.Indexed_Table_Range;


-- --------= Transition_Status =--------
 
type Transition_Status is
record
 Code : transition_Ptr;
 Status : Status_Type;
 Wakeup_Time : Natural;
end record;

type Transition_Status_Ptr is access all Transition_Status;

procedure Initialize(obj : out Transition_Status);
procedure Put(obj : in Transition_Status);
procedure Put(obj : in Transition_Status_Ptr);
procedure Build_Attributes_XML_String(obj : in Transition_Status; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Transition_Status; level : in natural := 0) return Unbounded_String;

package Package_Transition_Status is new Indexed_Tables(Transition_Status, Unbounded_String, Framework_Config.Max_Transitions, 0, Put, Initialize, Put);
use Package_Transition_Status;

subtype Transition_Status_Table is Package_Transition_Status.Indexed_Table;

subtype Transition_Status_Range is Package_Transition_Status.Indexed_Table_Range;


End Automaton;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with Ada.Finalization;

with Unchecked_Deallocation;

with Simulations;
use Simulations;

use Simulations.Simulation_Type_io;



Package Expressions is 
 
type Operator_Type is (
	Plus_Type,
	Minus_Type,
	Divide_Type,
	Multiply_Type,
	Exponential_Type,
	Modulo_Type,
	Equal_Type,
	Not_Equal_Type,
	Equal_Less_Type,
	Equal_Greater_Type,
	Inferior_Type,
	Superior_Type,
	Logic_And_Type,
	Logic_Or_Type,
	Logic_Not_Type,
	Min_Operator_Type,
	Max_Operator_type,
	Min_To_Index_Type,
	Max_To_Index_Type,
	Lcm_Type,
	Abs_Type,
	Get_Resource_Index_Type,
	Get_Task_Index_Type,
	Get_Message_Index_Type,
	Get_Buffer_Index_Type,
	Concatenate_Type);

procedure To_Operator_Type is
new Convert_Strings(Operator_Type, Plus_Type);
procedure To_Operator_Type is
new Convert_Unbounded_Strings(Operator_Type, Plus_Type);
function XML_String (e : in Operator_Type; level : in natural := 0) return Unbounded_String;
package Operator_Type_io is new text_io.enumeration_io(Operator_Type);
use Operator_Type_io;

type Expressions_Type is (
	Constant_Type,
	Variable_Type,
	Array_Variable_Type,
	Binary_Type,
	Unary_Type);

procedure To_Expressions_Type is
new Convert_Strings(Expressions_Type, Constant_Type);
procedure To_Expressions_Type is
new Convert_Unbounded_Strings(Expressions_Type, Constant_Type);
function XML_String (e : in Expressions_Type; level : in natural := 0) return Unbounded_String;
package Expressions_Type_io is new text_io.enumeration_io(Expressions_Type);
use Expressions_Type_io;


-- --------= Generic_Expression =--------

type Generic_Expression;
type Generic_Expression_Ptr is access all Generic_Expression'Class;
type Generic_Expression is new Ada.Finalization.Controlled with 
record
 Expression_Type : Expressions_Type;
end record;

procedure Initialize(obj : in out Generic_Expression);
procedure Put(obj : in Generic_Expression);
procedure Put(obj : in Generic_Expression_Ptr);
procedure Put_Name(obj : in Generic_Expression_Ptr);
procedure Build_Attributes_XML_String(obj : in Generic_Expression; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Generic_Expression; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Generic_Expression) return Unbounded_String;
function Get_Name (obj : in Generic_Expression_Ptr) return Unbounded_String;
function Copy(obj : in Generic_Expression_Ptr) return Generic_Expression_Ptr;
function Copy(obj : in Generic_Expression) return Generic_Expression_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Generic_Expression'Class, Generic_Expression_Ptr);


-- --------= Constant_Expression =--------

type Constant_Expression;
type Constant_Expression_Ptr is access all Constant_Expression'Class;
type Constant_Expression is new Generic_Expression with 
record
 VALUE : Simulation_Ptr;
end record;

procedure Initialize(obj : in out Constant_Expression);
procedure Put(obj : in Constant_Expression);
procedure Put(obj : in Constant_Expression_Ptr);
procedure Put_Name(obj : in Constant_Expression_Ptr);
procedure Build_Attributes_XML_String(obj : in Constant_Expression; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Constant_Expression; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Constant_Expression) return Unbounded_String;
function Get_Name (obj : in Constant_Expression_Ptr) return Unbounded_String;
function Copy(obj : in Constant_Expression_Ptr) return Generic_Expression_Ptr;
function Copy(obj : in Constant_Expression) return Generic_Expression_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Constant_Expression'Class, Constant_Expression_Ptr);


-- --------= Variable_Expression =--------

type Variable_Expression;
type Variable_Expression_Ptr is access all Variable_Expression'Class;
type Variable_Expression is new Generic_Expression with 
record
 Name : unbounded_string;
 Variable_Type : Simulation_Type;
end record;

procedure Initialize(obj : in out Variable_Expression);
procedure Put(obj : in Variable_Expression);
procedure Put(obj : in Variable_Expression_Ptr);
procedure Put_Name(obj : in Variable_Expression_Ptr);
procedure Build_Attributes_XML_String(obj : in Variable_Expression; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Variable_Expression; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Variable_Expression) return Unbounded_String;
function Get_Name (obj : in Variable_Expression_Ptr) return Unbounded_String;
function Copy(obj : in Variable_Expression_Ptr) return Generic_Expression_Ptr;
function Copy(obj : in Variable_Expression) return Generic_Expression_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Variable_Expression'Class, Variable_Expression_Ptr);


-- --------= Array_Variable_Expression =--------

type Array_Variable_Expression;
type Array_Variable_Expression_Ptr is access all Array_Variable_Expression'Class;
type Array_Variable_Expression is new Variable_Expression with 
record
 Array_Index : Generic_Expression_Ptr;
end record;

procedure Initialize(obj : in out Array_Variable_Expression);
procedure Put(obj : in Array_Variable_Expression);
procedure Put(obj : in Array_Variable_Expression_Ptr);
procedure Put_Name(obj : in Array_Variable_Expression_Ptr);
procedure Build_Attributes_XML_String(obj : in Array_Variable_Expression; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Array_Variable_Expression; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Array_Variable_Expression) return Unbounded_String;
function Get_Name (obj : in Array_Variable_Expression_Ptr) return Unbounded_String;
function Copy(obj : in Array_Variable_Expression_Ptr) return Generic_Expression_Ptr;
function Copy(obj : in Array_Variable_Expression) return Generic_Expression_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Array_Variable_Expression'Class, Array_Variable_Expression_Ptr);


-- --------= Binary_Expression =--------

type Binary_Expression;
type Binary_Expression_Ptr is access all Binary_Expression'Class;
type Binary_Expression is new Variable_Expression with 
record
 Rvalue : Generic_Expression_Ptr;
 Lvalue : Generic_Expression_Ptr;
 Operator : Operator_Type;
end record;

procedure Initialize(obj : in out Binary_Expression);
procedure Put(obj : in Binary_Expression);
procedure Put(obj : in Binary_Expression_Ptr);
procedure Put_Name(obj : in Binary_Expression_Ptr);
procedure Build_Attributes_XML_String(obj : in Binary_Expression; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Binary_Expression; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Binary_Expression) return Unbounded_String;
function Get_Name (obj : in Binary_Expression_Ptr) return Unbounded_String;
function Copy(obj : in Binary_Expression_Ptr) return Generic_Expression_Ptr;
function Copy(obj : in Binary_Expression) return Generic_Expression_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Binary_Expression'Class, Binary_Expression_Ptr);


-- --------= Unary_Expression =--------

type Unary_Expression;
type Unary_Expression_Ptr is access all Unary_Expression'Class;
type Unary_Expression is new Variable_Expression with 
record
 Operator : Operator_Type;
 VALUE : Generic_Expression_Ptr;
end record;

procedure Initialize(obj : in out Unary_Expression);
procedure Put(obj : in Unary_Expression);
procedure Put(obj : in Unary_Expression_Ptr);
procedure Put_Name(obj : in Unary_Expression_Ptr);
procedure Build_Attributes_XML_String(obj : in Unary_Expression; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Unary_Expression; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Unary_Expression) return Unbounded_String;
function Get_Name (obj : in Unary_Expression_Ptr) return Unbounded_String;
function Copy(obj : in Unary_Expression_Ptr) return Generic_Expression_Ptr;
function Copy(obj : in Unary_Expression) return Generic_Expression_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Unary_Expression'Class, Unary_Expression_Ptr);


End Expressions;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with standards_io;
use standards_io;

use standards_io.integer_io;

with Tables;

with framework_config;
use framework_config;



Package Offsets is 
 

-- --------= Offset_Type =--------
 
type Offset_Type is
record
 Offset_Value : Integer;
 Activation : Integer;
end record;

type Offset_Type_Ptr is access all Offset_Type;

procedure Initialize(obj : out Offset_Type);
procedure Put(obj : in Offset_Type);
procedure Put(obj : in Offset_Type_Ptr);
procedure Build_Attributes_XML_String(obj : in Offset_Type; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Offset_Type; level : in natural := 0) return Unbounded_String;

package Offsets_Table_package is new Tables(Offset_Type, Max_Offsets, Put);
use Offsets_Table_package;

subtype Offsets_Range is Offsets_Table_package.Table_Range;

subtype Offsets_Table is Offsets_Table_package.Table;


End Offsets;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with standards_io;
use standards_io;

use standards_io.natural_io;

with Indexed_Tables;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;

with framework_config;
use framework_config;

use standards_io.integer_io;

with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with Objects;
use Objects;

with Unchecked_Deallocation;



Package Resources is 
 
type Resources_Type is (
	No_Protocol,
	Priority_Ceiling_Protocol,
	Priority_Inheritance_Protocol,
	Immediate_Priority_Ceiling_Protocol);

procedure To_Resources_Type is
new Convert_Strings(Resources_Type, No_Protocol);
procedure To_Resources_Type is
new Convert_Unbounded_Strings(Resources_Type, No_Protocol);
function XML_String (e : in Resources_Type; level : in natural := 0) return Unbounded_String;
package Resources_Type_io is new text_io.enumeration_io(Resources_Type);
use Resources_Type_io;


-- --------= Affected_Task_Lists =--------
 
type Affected_Task_Lists is
record
 Task_Begin : Natural;
 Task_End : Natural;
end record;

type Affected_Task_Lists_Ptr is access all Affected_Task_Lists;

procedure Initialize(obj : out Affected_Task_Lists);
procedure Put(obj : in Affected_Task_Lists);
procedure Put(obj : in Affected_Task_Lists_Ptr);
procedure Build_Attributes_XML_String(obj : in Affected_Task_Lists; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Affected_Task_Lists; level : in natural := 0) return Unbounded_String;

package Task_Lists is new Indexed_Tables(Affected_Task_Lists, Unbounded_String, Framework_Config.Max_Tasks_For_A_Resource, 0, Put, Initialize, Put);
use Task_Lists;

subtype Task_Lists_Table is Task_Lists.Indexed_Table;

subtype Task_Lists_Range is Task_Lists.Indexed_Table_Range;

type Start_End_Table is Array (Task_Lists_Range) of Affected_Task_Lists;


-- --------= Generic_Resource =--------

type Generic_Resource;
type Generic_Resource_Ptr is access all Generic_Resource'Class;
type Generic_Resource is new Generic_Object with 
record
 state : Integer;
 protocol : resources_type;
 task_tab : Task_Lists_Table;
 cpu_name : unbounded_string;
 Address_Space_Name : unbounded_string;
end record;

procedure Initialize(obj : in out Generic_Resource);
procedure Put(obj : in Generic_Resource);
procedure Put(obj : in Generic_Resource_Ptr);
procedure Put_Name(obj : in Generic_Resource_Ptr);
procedure Build_Attributes_XML_String(obj : in Generic_Resource; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Generic_Resource; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Generic_Resource) return Unbounded_String;
function Get_Name (obj : in Generic_Resource_Ptr) return Unbounded_String;
function Copy(obj : in Generic_Resource_Ptr) return Generic_Resource_Ptr;
function Copy(obj : in Generic_Resource) return Generic_Resource_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Generic_Resource'Class, Generic_Resource_Ptr);


-- --------= Np_Resource =--------

type Np_Resource;
type Np_Resource_Ptr is access all Np_Resource'Class;
type Np_Resource is new Generic_Resource with null record;

procedure Initialize(obj : in out Np_Resource);
procedure Put(obj : in Np_Resource);
procedure Put(obj : in Np_Resource_Ptr);
procedure Put_Name(obj : in Np_Resource_Ptr);
procedure Build_Attributes_XML_String(obj : in Np_Resource; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Np_Resource; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Np_Resource) return Unbounded_String;
function Get_Name (obj : in Np_Resource_Ptr) return Unbounded_String;
function Copy(obj : in Np_Resource_Ptr) return Generic_Resource_Ptr;
function Copy(obj : in Np_Resource) return Generic_Resource_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Np_Resource'Class, Np_Resource_Ptr);


-- --------= Pip_Resource =--------

type Pip_Resource;
type Pip_Resource_Ptr is access all Pip_Resource'Class;
type Pip_Resource is new Generic_Resource with null record;

procedure Initialize(obj : in out Pip_Resource);
procedure Put(obj : in Pip_Resource);
procedure Put(obj : in Pip_Resource_Ptr);
procedure Put_Name(obj : in Pip_Resource_Ptr);
procedure Build_Attributes_XML_String(obj : in Pip_Resource; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Pip_Resource; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Pip_Resource) return Unbounded_String;
function Get_Name (obj : in Pip_Resource_Ptr) return Unbounded_String;
function Copy(obj : in Pip_Resource_Ptr) return Generic_Resource_Ptr;
function Copy(obj : in Pip_Resource) return Generic_Resource_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Pip_Resource'Class, Pip_Resource_Ptr);


-- --------= Pcp_Resource =--------

type Pcp_Resource;
type Pcp_Resource_Ptr is access all Pcp_Resource'Class;
type Pcp_Resource is new Generic_Resource with null record;

procedure Initialize(obj : in out Pcp_Resource);
procedure Put(obj : in Pcp_Resource);
procedure Put(obj : in Pcp_Resource_Ptr);
procedure Put_Name(obj : in Pcp_Resource_Ptr);
procedure Build_Attributes_XML_String(obj : in Pcp_Resource; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Pcp_Resource; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Pcp_Resource) return Unbounded_String;
function Get_Name (obj : in Pcp_Resource_Ptr) return Unbounded_String;
function Copy(obj : in Pcp_Resource_Ptr) return Generic_Resource_Ptr;
function Copy(obj : in Pcp_Resource) return Generic_Resource_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Pcp_Resource'Class, Pcp_Resource_Ptr);


-- --------= IPcp_Resource =--------

type IPcp_Resource;
type IPcp_Resource_Ptr is access all IPcp_Resource'Class;
type IPcp_Resource is new Generic_Resource with null record;

procedure Initialize(obj : in out IPcp_Resource);
procedure Put(obj : in IPcp_Resource);
procedure Put(obj : in IPcp_Resource_Ptr);
procedure Put_Name(obj : in IPcp_Resource_Ptr);
procedure Build_Attributes_XML_String(obj : in IPcp_Resource; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in IPcp_Resource; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in IPcp_Resource) return Unbounded_String;
function Get_Name (obj : in IPcp_Resource_Ptr) return Unbounded_String;
function Copy(obj : in IPcp_Resource_Ptr) return Generic_Resource_Ptr;
function Copy(obj : in IPcp_Resource) return Generic_Resource_Ptr;
procedure Free  is new Unchecked_Deallocation
	(IPcp_Resource'Class, IPcp_Resource_Ptr);


End Resources;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with Ada.Finalization;

with Unchecked_Deallocation;



Package Objects is 
 
type Objects_Type is (
	Buffer_Object_Type,
	Processor_Object_Type,
	Task_Object_Type,
	Resource_Object_Type,
	Address_Space_Object_Type,
	Message_Object_Type,
	State_Object_Type,
	Transition_Object_Type,
	Statement_Object_Type,
	Synchronization_Object_Type,
	Section_Object_Type,
	Network_Object_Type);

procedure To_Objects_Type is
new Convert_Strings(Objects_Type, Buffer_Object_Type);
procedure To_Objects_Type is
new Convert_Unbounded_Strings(Objects_Type, Buffer_Object_Type);
function XML_String (e : in Objects_Type; level : in natural := 0) return Unbounded_String;
package Objects_Type_io is new text_io.enumeration_io(Objects_Type);
use Objects_Type_io;


-- --------= Generic_Object =--------

type Generic_Object;
type Generic_Object_Ptr is access all Generic_Object'Class;
type Generic_Object is new Ada.Finalization.Controlled with 
record
 Name : unbounded_string;
 Object_Type : Objects_Type;
end record;

procedure Initialize(obj : in out Generic_Object);
procedure Put(obj : in Generic_Object);
procedure Put(obj : in Generic_Object_Ptr);
procedure Put_Name(obj : in Generic_Object_Ptr);
procedure Build_Attributes_XML_String(obj : in Generic_Object; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Generic_Object; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Generic_Object) return Unbounded_String;
function Get_Name (obj : in Generic_Object_Ptr) return Unbounded_String;
function Copy(obj : in Generic_Object_Ptr) return Generic_Object_Ptr;
function Copy(obj : in Generic_Object) return Generic_Object_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Generic_Object'Class, Generic_Object_Ptr);


End Objects;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with standards_io;
use standards_io;

use standards_io.boolean_io;

use standards_io.integer_io;

with Ada.Numerics.Aux;
use Ada.Numerics.Aux;

use standards_io.double_io;

with ada.strings.unbounded;
use ada.strings.unbounded;

with Tables;

with framework_config;
use framework_config;

with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;



Package Parameters is 
 
type Parameter_Type is (
	Boolean_Parameter,
	Integer_Parameter,
	Double_Parameter,
	String_Parameter);

procedure To_Parameter_Type is
new Convert_Strings(Parameter_Type, Boolean_Parameter);
procedure To_Parameter_Type is
new Convert_Unbounded_Strings(Parameter_Type, Boolean_Parameter);
function XML_String (e : in Parameter_Type; level : in natural := 0) return Unbounded_String;
package Parameter_Type_io is new text_io.enumeration_io(Parameter_Type);
use Parameter_Type_io;

type Parameter (ptype : Parameter_Type ) is record
	Name : unbounded_string;
 	case ptype is 
		when Boolean_Parameter => 
			Boolean_value : Boolean;
 		when Integer_Parameter => 
			Integer_value : Integer;
 		when Double_Parameter => 
			double_value : Double;
 		when String_Parameter => 
			string_value : unbounded_string;
 	end case;
end record;
 
type Parameter_ptr is access all Parameter;

procedure Initialize(obj : out Parameter_ptr);

procedure Put(obj : in Parameter_Ptr);

package User_Defined_Parameters_Table_Package is new Tables(Parameter_Ptr, Max_User_Defined_Task_Parameters, Put);
use User_Defined_Parameters_Table_Package;

subtype User_Defined_Parameters_Range is User_Defined_Parameters_Table_Package.Table_Range;

subtype User_Defined_Parameters_Table is User_Defined_Parameters_Table_Package.Table;


End Parameters;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with scheduler;
use scheduler;

with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with Objects;
use Objects;

with Unchecked_Deallocation;



Package Processors is 
 

-- --------= Processor =--------

type Processor;
type Processor_Ptr is access all Processor'Class;
type Processor is new Generic_Object with 
record
 Scheduler : Generic_Scheduler_Ptr;
 Network : unbounded_string;
end record;

procedure Initialize(obj : in out Processor);
procedure Put(obj : in Processor);
procedure Put(obj : in Processor_Ptr);
procedure Put_Name(obj : in Processor_Ptr);
procedure Build_Attributes_XML_String(obj : in Processor; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Processor; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Processor) return Unbounded_String;
function Get_Name (obj : in Processor_Ptr) return Unbounded_String;
function Copy(obj : in Processor_Ptr) return Processor_Ptr;
function Copy(obj : in Processor) return Processor_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Processor'Class, Processor_Ptr);


End Processors;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Framework_Config;
use Framework_Config;

use Framework_Config.Priority_Io;

with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with standards_io;
use standards_io;

use standards_io.natural_io;

with Offsets;
use Offsets;

use Offsets.Offsets_Table_package;

with Parameters;
use Parameters;

use Parameters.User_Defined_Parameters_Table_Package;

with Objects;
use Objects;

with Unchecked_Deallocation;

use standards_io.integer_io;

use standards_io.boolean_io;



Package Tasks is 
 
type Tasks_Type is (
	Periodic_Type,
	Aperiodic_Type,
	Sporadic_Type,
	Poisson_Type,
	Parametric_Type);

procedure To_Tasks_Type is
new Convert_Strings(Tasks_Type, Periodic_Type);
procedure To_Tasks_Type is
new Convert_Unbounded_Strings(Tasks_Type, Periodic_Type);
function XML_String (e : in Tasks_Type; level : in natural := 0) return Unbounded_String;
package Tasks_Type_io is new text_io.enumeration_io(Tasks_Type);
use Tasks_Type_io;

type Policies is (
	Sched_Fifo,
	Sched_Rr,
	Sched_Others);

procedure To_Policies is
new Convert_Strings(Policies, Sched_Fifo);
procedure To_Policies is
new Convert_Unbounded_Strings(Policies, Sched_Fifo);
function XML_String (e : in Policies; level : in natural := 0) return Unbounded_String;
package Policies_io is new text_io.enumeration_io(Policies);
use Policies_io;


-- --------= Generic_Task =--------

type Generic_Task;
type Generic_Task_Ptr is access all Generic_Task'Class;
type Generic_Task is new Generic_Object with 
record
 Task_Type : Tasks_Type;
 Cpu_Name : unbounded_string;
 Address_Space_Name : unbounded_string;
 Capacity : Natural;
 Deadline : Natural;
 Start_Time : Natural;
 Priority : priority_range;
 Blocking_Time : Natural;
 Policy : Policies;
 X : Natural;
 Y : Natural;
 Offset : Offsets_Table;
 Text_Memory_Size : Natural;
 Stack_Memory_Size : Natural;
 Param : User_Defined_Parameters_Table;
 Criticality : Natural;
 Context_Switch_Overhead : Natural;
end record;

procedure Initialize(obj : in out Generic_Task);
procedure Put(obj : in Generic_Task);
procedure Put(obj : in Generic_Task_Ptr);
procedure Put_Name(obj : in Generic_Task_Ptr);
procedure Build_Attributes_XML_String(obj : in Generic_Task; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Generic_Task; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Generic_Task) return Unbounded_String;
function Get_Name (obj : in Generic_Task_Ptr) return Unbounded_String;
function Copy(obj : in Generic_Task_Ptr) return Generic_Task_Ptr;
function Copy(obj : in Generic_Task) return Generic_Task_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Generic_Task'Class, Generic_Task_Ptr);


-- --------= Periodic_Task =--------

type Periodic_Task;
type Periodic_Task_Ptr is access all Periodic_Task'Class;
type Periodic_Task is new Generic_Task with 
record
 Period : Natural;
 Jitter : Natural;
end record;

procedure Initialize(obj : in out Periodic_Task);
procedure Put(obj : in Periodic_Task);
procedure Put(obj : in Periodic_Task_Ptr);
procedure Put_Name(obj : in Periodic_Task_Ptr);
procedure Build_Attributes_XML_String(obj : in Periodic_Task; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Periodic_Task; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Periodic_Task) return Unbounded_String;
function Get_Name (obj : in Periodic_Task_Ptr) return Unbounded_String;
function Copy(obj : in Periodic_Task_Ptr) return Generic_Task_Ptr;
function Copy(obj : in Periodic_Task) return Generic_Task_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Periodic_Task'Class, Periodic_Task_Ptr);


-- --------= Aperiodic_Task =--------

type Aperiodic_Task;
type Aperiodic_Task_Ptr is access all Aperiodic_Task'Class;
type Aperiodic_Task is new Generic_Task with null record;

procedure Initialize(obj : in out Aperiodic_Task);
procedure Put(obj : in Aperiodic_Task);
procedure Put(obj : in Aperiodic_Task_Ptr);
procedure Put_Name(obj : in Aperiodic_Task_Ptr);
procedure Build_Attributes_XML_String(obj : in Aperiodic_Task; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Aperiodic_Task; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Aperiodic_Task) return Unbounded_String;
function Get_Name (obj : in Aperiodic_Task_Ptr) return Unbounded_String;
function Copy(obj : in Aperiodic_Task_Ptr) return Generic_Task_Ptr;
function Copy(obj : in Aperiodic_Task) return Generic_Task_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Aperiodic_Task'Class, Aperiodic_Task_Ptr);


-- --------= Poisson_Task =--------

type Poisson_Task;
type Poisson_Task_Ptr is access all Poisson_Task'Class;
type Poisson_Task is new Periodic_Task with 
record
 Seed : Integer;
 Predictable : Boolean;
end record;

procedure Initialize(obj : in out Poisson_Task);
procedure Put(obj : in Poisson_Task);
procedure Put(obj : in Poisson_Task_Ptr);
procedure Put_Name(obj : in Poisson_Task_Ptr);
procedure Build_Attributes_XML_String(obj : in Poisson_Task; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Poisson_Task; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Poisson_Task) return Unbounded_String;
function Get_Name (obj : in Poisson_Task_Ptr) return Unbounded_String;
function Copy(obj : in Poisson_Task_Ptr) return Generic_Task_Ptr;
function Copy(obj : in Poisson_Task) return Generic_Task_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Poisson_Task'Class, Poisson_Task_Ptr);


-- --------= Sporadic_Task =--------

type Sporadic_Task;
type Sporadic_Task_Ptr is access all Sporadic_Task'Class;
type Sporadic_Task is new Poisson_Task with null record;

procedure Initialize(obj : in out Sporadic_Task);
procedure Put(obj : in Sporadic_Task);
procedure Put(obj : in Sporadic_Task_Ptr);
procedure Put_Name(obj : in Sporadic_Task_Ptr);
procedure Build_Attributes_XML_String(obj : in Sporadic_Task; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Sporadic_Task; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Sporadic_Task) return Unbounded_String;
function Get_Name (obj : in Sporadic_Task_Ptr) return Unbounded_String;
function Copy(obj : in Sporadic_Task_Ptr) return Generic_Task_Ptr;
function Copy(obj : in Sporadic_Task) return Generic_Task_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Sporadic_Task'Class, Sporadic_Task_Ptr);


-- --------= Parametric_Task =--------

type Parametric_Task;
type Parametric_Task_Ptr is access all Parametric_Task'Class;
type Parametric_Task is new Poisson_Task with 
record
 Activation_Rule : unbounded_string;
end record;

procedure Initialize(obj : in out Parametric_Task);
procedure Put(obj : in Parametric_Task);
procedure Put(obj : in Parametric_Task_Ptr);
procedure Put_Name(obj : in Parametric_Task_Ptr);
procedure Build_Attributes_XML_String(obj : in Parametric_Task; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Parametric_Task; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Parametric_Task) return Unbounded_String;
function Get_Name (obj : in Parametric_Task_Ptr) return Unbounded_String;
function Copy(obj : in Parametric_Task_Ptr) return Generic_Task_Ptr;
function Copy(obj : in Parametric_Task) return Generic_Task_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Parametric_Task'Class, Parametric_Task_Ptr);


End Tasks;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with ada.strings.unbounded;
use ada.strings.unbounded;



Package Laws is 
 
type Laws_Type is (
	Uniform_Law_Type,
	Laplace_Gauss_Law_Type,
	Exponential_Law_Type);

procedure To_Laws_Type is
new Convert_Strings(Laws_Type, Uniform_Law_Type);
procedure To_Laws_Type is
new Convert_Unbounded_Strings(Laws_Type, Uniform_Law_Type);
function XML_String (e : in Laws_Type; level : in natural := 0) return Unbounded_String;
package Laws_Type_io is new text_io.enumeration_io(Laws_Type);
use Laws_Type_io;


End Laws;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with standards_io;
use standards_io;

use standards_io.natural_io;

with Objects;
use Objects;

with Unchecked_Deallocation;

with Expressions;
use Expressions;

with Laws;
use Laws;

use Laws.Laws_Type_io;

use standards_io.boolean_io;



Package Statements is 
 
type Statements_Type is (
	Put_Statement_Type,
	Nop_Statement_Type,
	Exit_Statement_Type,
	If_Statement_Type,
	Assign_Statement_Type,
	For_Statement_Type,
	Return_Statement_Type,
	While_Statement_Type,
	Set_Statement_Type,
	Clock_Statement_Type,
	Subprogram_Statement_Type,
	Subprogram_Call_Statement_Type,
	Random_Initialize_Statement_Type);

procedure To_Statements_Type is
new Convert_Strings(Statements_Type, Put_Statement_Type);
procedure To_Statements_Type is
new Convert_Unbounded_Strings(Statements_Type, Put_Statement_Type);
function XML_String (e : in Statements_Type; level : in natural := 0) return Unbounded_String;
package Statements_Type_io is new text_io.enumeration_io(Statements_Type);
use Statements_Type_io;

type Table_Types is (
	Task_Table_Type,
	Message_Table_Type,
	Processor_Table_Type,
	Buffer_Table_Type,
	Time_Unit_Table_Type,
	Resource_Table_Type);

procedure To_Table_Types is
new Convert_Strings(Table_Types, Task_Table_Type);
procedure To_Table_Types is
new Convert_Unbounded_Strings(Table_Types, Task_Table_Type);
function XML_String (e : in Table_Types; level : in natural := 0) return Unbounded_String;
package Table_Types_io is new text_io.enumeration_io(Table_Types);
use Table_Types_io;


-- --------= Generic_Statement =--------

type Generic_Statement;
type Generic_Statement_Ptr is access all Generic_Statement'Class;
type Generic_Statement is new Generic_Object with 
record
 Statement_Type : Statements_Type;
 Line_Number : Natural;
 File_Name : unbounded_string;
 Next_Statement : Generic_Statement_Ptr;
end record;

procedure Initialize(obj : in out Generic_Statement);
procedure Put(obj : in Generic_Statement);
procedure Put(obj : in Generic_Statement_Ptr);
procedure Put_Name(obj : in Generic_Statement_Ptr);
procedure Build_Attributes_XML_String(obj : in Generic_Statement; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Generic_Statement; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Generic_Statement) return Unbounded_String;
function Get_Name (obj : in Generic_Statement_Ptr) return Unbounded_String;
function Copy(obj : in Generic_Statement_Ptr) return Generic_Statement_Ptr;
function Copy(obj : in Generic_Statement) return Generic_Statement_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Generic_Statement'Class, Generic_Statement_Ptr);


-- --------= Nop_Statement =--------

type Nop_Statement;
type Nop_Statement_Ptr is access all Nop_Statement'Class;
type Nop_Statement is new Generic_Statement with null record;

procedure Initialize(obj : in out Nop_Statement);
procedure Put(obj : in Nop_Statement);
procedure Put(obj : in Nop_Statement_Ptr);
procedure Put_Name(obj : in Nop_Statement_Ptr);
procedure Build_Attributes_XML_String(obj : in Nop_Statement; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Nop_Statement; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Nop_Statement) return Unbounded_String;
function Get_Name (obj : in Nop_Statement_Ptr) return Unbounded_String;
function Copy(obj : in Nop_Statement_Ptr) return Generic_Statement_Ptr;
function Copy(obj : in Nop_Statement) return Generic_Statement_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Nop_Statement'Class, Nop_Statement_Ptr);


-- --------= Exit_Statement =--------

type Exit_Statement;
type Exit_Statement_Ptr is access all Exit_Statement'Class;
type Exit_Statement is new Generic_Statement with null record;

procedure Initialize(obj : in out Exit_Statement);
procedure Put(obj : in Exit_Statement);
procedure Put(obj : in Exit_Statement_Ptr);
procedure Put_Name(obj : in Exit_Statement_Ptr);
procedure Build_Attributes_XML_String(obj : in Exit_Statement; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Exit_Statement; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Exit_Statement) return Unbounded_String;
function Get_Name (obj : in Exit_Statement_Ptr) return Unbounded_String;
function Copy(obj : in Exit_Statement_Ptr) return Generic_Statement_Ptr;
function Copy(obj : in Exit_Statement) return Generic_Statement_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Exit_Statement'Class, Exit_Statement_Ptr);


-- --------= Put_Statement =--------

type Put_Statement;
type Put_Statement_Ptr is access all Put_Statement'Class;
type Put_Statement is new Generic_Statement with 
record
 Put_From : Generic_Expression_Ptr;
 Put_To : Generic_Expression_Ptr;
 Expression_To_Be_displayed : Generic_Expression_Ptr;
end record;

procedure Initialize(obj : in out Put_Statement);
procedure Put(obj : in Put_Statement);
procedure Put(obj : in Put_Statement_Ptr);
procedure Put_Name(obj : in Put_Statement_Ptr);
procedure Build_Attributes_XML_String(obj : in Put_Statement; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Put_Statement; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Put_Statement) return Unbounded_String;
function Get_Name (obj : in Put_Statement_Ptr) return Unbounded_String;
function Copy(obj : in Put_Statement_Ptr) return Generic_Statement_Ptr;
function Copy(obj : in Put_Statement) return Generic_Statement_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Put_Statement'Class, Put_Statement_Ptr);


-- --------= If_Statement =--------

type If_Statement;
type If_Statement_Ptr is access all If_Statement'Class;
type If_Statement is new Generic_Statement with 
record
 Bool_Expression : Generic_Expression_Ptr;
 Else_Statement : Generic_Statement_Ptr;
 Then_Statement : Generic_Statement_Ptr;
end record;

procedure Initialize(obj : in out If_Statement);
procedure Put(obj : in If_Statement);
procedure Put(obj : in If_Statement_Ptr);
procedure Put_Name(obj : in If_Statement_Ptr);
procedure Build_Attributes_XML_String(obj : in If_Statement; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in If_Statement; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in If_Statement) return Unbounded_String;
function Get_Name (obj : in If_Statement_Ptr) return Unbounded_String;
function Copy(obj : in If_Statement_Ptr) return Generic_Statement_Ptr;
function Copy(obj : in If_Statement) return Generic_Statement_Ptr;
procedure Free  is new Unchecked_Deallocation
	(If_Statement'Class, If_Statement_Ptr);


-- --------= Assign_Statement =--------

type Assign_Statement;
type Assign_Statement_Ptr is access all Assign_Statement'Class;
type Assign_Statement is new Generic_Statement with 
record
 Lvalue : Generic_Expression_Ptr;
 Rvalue : Generic_Expression_Ptr;
end record;

procedure Initialize(obj : in out Assign_Statement);
procedure Put(obj : in Assign_Statement);
procedure Put(obj : in Assign_Statement_Ptr);
procedure Put_Name(obj : in Assign_Statement_Ptr);
procedure Build_Attributes_XML_String(obj : in Assign_Statement; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Assign_Statement; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Assign_Statement) return Unbounded_String;
function Get_Name (obj : in Assign_Statement_Ptr) return Unbounded_String;
function Copy(obj : in Assign_Statement_Ptr) return Generic_Statement_Ptr;
function Copy(obj : in Assign_Statement) return Generic_Statement_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Assign_Statement'Class, Assign_Statement_Ptr);


-- --------= Clock_Statement =--------

type Clock_Statement;
type Clock_Statement_Ptr is access all Clock_Statement'Class;
type Clock_Statement is new Assign_Statement with null record;

procedure Initialize(obj : in out Clock_Statement);
procedure Put(obj : in Clock_Statement);
procedure Put(obj : in Clock_Statement_Ptr);
procedure Put_Name(obj : in Clock_Statement_Ptr);
procedure Build_Attributes_XML_String(obj : in Clock_Statement; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Clock_Statement; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Clock_Statement) return Unbounded_String;
function Get_Name (obj : in Clock_Statement_Ptr) return Unbounded_String;
function Copy(obj : in Clock_Statement_Ptr) return Generic_Statement_Ptr;
function Copy(obj : in Clock_Statement) return Generic_Statement_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Clock_Statement'Class, Clock_Statement_Ptr);


-- --------= For_Statement =--------

type For_Statement;
type For_Statement_Ptr is access all For_Statement'Class;
type For_Statement is new Generic_Statement with 
record
 For_Type : Table_Types;
 Included_Statement : Generic_Statement_Ptr;
 For_Index : Variable_Expression_Ptr;
end record;

procedure Initialize(obj : in out For_Statement);
procedure Put(obj : in For_Statement);
procedure Put(obj : in For_Statement_Ptr);
procedure Put_Name(obj : in For_Statement_Ptr);
procedure Build_Attributes_XML_String(obj : in For_Statement; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in For_Statement; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in For_Statement) return Unbounded_String;
function Get_Name (obj : in For_Statement_Ptr) return Unbounded_String;
function Copy(obj : in For_Statement_Ptr) return Generic_Statement_Ptr;
function Copy(obj : in For_Statement) return Generic_Statement_Ptr;
procedure Free  is new Unchecked_Deallocation
	(For_Statement'Class, For_Statement_Ptr);


-- --------= Return_Statement =--------

type Return_Statement;
type Return_Statement_Ptr is access all Return_Statement'Class;
type Return_Statement is new Generic_Statement with 
record
 Return_Value : Generic_Expression_Ptr;
end record;

procedure Initialize(obj : in out Return_Statement);
procedure Put(obj : in Return_Statement);
procedure Put(obj : in Return_Statement_Ptr);
procedure Put_Name(obj : in Return_Statement_Ptr);
procedure Build_Attributes_XML_String(obj : in Return_Statement; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Return_Statement; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Return_Statement) return Unbounded_String;
function Get_Name (obj : in Return_Statement_Ptr) return Unbounded_String;
function Copy(obj : in Return_Statement_Ptr) return Generic_Statement_Ptr;
function Copy(obj : in Return_Statement) return Generic_Statement_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Return_Statement'Class, Return_Statement_Ptr);


-- --------= While_Statement =--------

type While_Statement;
type While_Statement_Ptr is access all While_Statement'Class;
type While_Statement is new Generic_Statement with 
record
 Included_Statement : Generic_Statement_Ptr;
 Condition : Generic_Expression_Ptr;
end record;

procedure Initialize(obj : in out While_Statement);
procedure Put(obj : in While_Statement);
procedure Put(obj : in While_Statement_Ptr);
procedure Put_Name(obj : in While_Statement_Ptr);
procedure Build_Attributes_XML_String(obj : in While_Statement; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in While_Statement; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in While_Statement) return Unbounded_String;
function Get_Name (obj : in While_Statement_Ptr) return Unbounded_String;
function Copy(obj : in While_Statement_Ptr) return Generic_Statement_Ptr;
function Copy(obj : in While_Statement) return Generic_Statement_Ptr;
procedure Free  is new Unchecked_Deallocation
	(While_Statement'Class, While_Statement_Ptr);


-- --------= Random_Initialize_Statement =--------

type Random_Initialize_Statement;
type Random_Initialize_Statement_Ptr is access all Random_Initialize_Statement'Class;
type Random_Initialize_Statement is new Generic_Statement with 
record
 Lvalue : unbounded_string;
 Law : Laws_Type;
 Parameter1 : Generic_Expression_Ptr;
 Parameter2 : Generic_Expression_Ptr;
end record;

procedure Initialize(obj : in out Random_Initialize_Statement);
procedure Put(obj : in Random_Initialize_Statement);
procedure Put(obj : in Random_Initialize_Statement_Ptr);
procedure Put_Name(obj : in Random_Initialize_Statement_Ptr);
procedure Build_Attributes_XML_String(obj : in Random_Initialize_Statement; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Random_Initialize_Statement; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Random_Initialize_Statement) return Unbounded_String;
function Get_Name (obj : in Random_Initialize_Statement_Ptr) return Unbounded_String;
function Copy(obj : in Random_Initialize_Statement_Ptr) return Generic_Statement_Ptr;
function Copy(obj : in Random_Initialize_Statement) return Generic_Statement_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Random_Initialize_Statement'Class, Random_Initialize_Statement_Ptr);


-- --------= Set_Statement =--------

type Set_Statement;
type Set_Statement_Ptr is access all Set_Statement'Class;
type Set_Statement is new Generic_Statement with 
record
 Set_Id : unbounded_string;
 Set_Value : Generic_Expression_Ptr;
end record;

procedure Initialize(obj : in out Set_Statement);
procedure Put(obj : in Set_Statement);
procedure Put(obj : in Set_Statement_Ptr);
procedure Put_Name(obj : in Set_Statement_Ptr);
procedure Build_Attributes_XML_String(obj : in Set_Statement; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Set_Statement; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Set_Statement) return Unbounded_String;
function Get_Name (obj : in Set_Statement_Ptr) return Unbounded_String;
function Copy(obj : in Set_Statement_Ptr) return Generic_Statement_Ptr;
function Copy(obj : in Set_Statement) return Generic_Statement_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Set_Statement'Class, Set_Statement_Ptr);


-- --------= Subprogram_Statement =--------

type Subprogram_Statement;
type Subprogram_Statement_Ptr is access all Subprogram_Statement'Class;
type Subprogram_Statement is new Generic_Statement with 
record
 Included_Statement : Generic_Statement_Ptr;
 Is_A_Function : Boolean;
 Subprogram_Name : unbounded_string;
end record;

procedure Initialize(obj : in out Subprogram_Statement);
procedure Put(obj : in Subprogram_Statement);
procedure Put(obj : in Subprogram_Statement_Ptr);
procedure Put_Name(obj : in Subprogram_Statement_Ptr);
procedure Build_Attributes_XML_String(obj : in Subprogram_Statement; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Subprogram_Statement; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Subprogram_Statement) return Unbounded_String;
function Get_Name (obj : in Subprogram_Statement_Ptr) return Unbounded_String;
function Copy(obj : in Subprogram_Statement_Ptr) return Generic_Statement_Ptr;
function Copy(obj : in Subprogram_Statement) return Generic_Statement_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Subprogram_Statement'Class, Subprogram_Statement_Ptr);


-- --------= Subprogram_Call_Statement =--------

type Subprogram_Call_Statement;
type Subprogram_Call_Statement_Ptr is access all Subprogram_Call_Statement'Class;
type Subprogram_Call_Statement is new Generic_Statement with 
record
 Is_A_Function : Boolean;
 Called_Subprogram : Generic_Statement_Ptr;
 Return_Value : Generic_Expression_Ptr;
end record;

procedure Initialize(obj : in out Subprogram_Call_Statement);
procedure Put(obj : in Subprogram_Call_Statement);
procedure Put(obj : in Subprogram_Call_Statement_Ptr);
procedure Put_Name(obj : in Subprogram_Call_Statement_Ptr);
procedure Build_Attributes_XML_String(obj : in Subprogram_Call_Statement; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Subprogram_Call_Statement; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Subprogram_Call_Statement) return Unbounded_String;
function Get_Name (obj : in Subprogram_Call_Statement_Ptr) return Unbounded_String;
function Copy(obj : in Subprogram_Call_Statement_Ptr) return Generic_Statement_Ptr;
function Copy(obj : in Subprogram_Call_Statement) return Generic_Statement_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Subprogram_Call_Statement'Class, Subprogram_Call_Statement_Ptr);


End Statements;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with Objects;
use Objects;

with Unchecked_Deallocation;

with Statements;
use Statements;

with Automaton;
use Automaton;

use Automaton.State_Lists_Package;

use Automaton.Transition_Lists_Package;



Package Sections is 
 
type Sections_Type is (
	Automaton_Type,
	Start_Type,
	Priority_Type,
	Election_Type,
	Activation_Type,
	Check_Resource_Type,
	Allocate_Resource_Type,
	Release_Resource_Type,
	Gather_Event_Analyzer_Type,
	Display_Event_Analyzer_Type);

procedure To_Sections_Type is
new Convert_Strings(Sections_Type, Automaton_Type);
procedure To_Sections_Type is
new Convert_Unbounded_Strings(Sections_Type, Automaton_Type);
function XML_String (e : in Sections_Type; level : in natural := 0) return Unbounded_String;
package Sections_Type_io is new text_io.enumeration_io(Sections_Type);
use Sections_Type_io;


-- --------= Generic_Section =--------

type Generic_Section;
type Generic_Section_Ptr is access all Generic_Section'Class;
type Generic_Section is new Generic_Object with 
record
 Section_type : Sections_type;
 File_Name : unbounded_string;
end record;

procedure Initialize(obj : in out Generic_Section);
procedure Put(obj : in Generic_Section);
procedure Put(obj : in Generic_Section_Ptr);
procedure Put_Name(obj : in Generic_Section_Ptr);
procedure Build_Attributes_XML_String(obj : in Generic_Section; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Generic_Section; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Generic_Section) return Unbounded_String;
function Get_Name (obj : in Generic_Section_Ptr) return Unbounded_String;
function Copy(obj : in Generic_Section_Ptr) return Generic_Section_Ptr;
function Copy(obj : in Generic_Section) return Generic_Section_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Generic_Section'Class, Generic_Section_Ptr);


-- --------= Computation_Section =--------

type Computation_Section;
type Computation_Section_Ptr is access all Computation_Section'Class;
type Computation_Section is new Generic_Section with 
record
 First_Statement : Generic_Statement_Ptr;
end record;

procedure Initialize(obj : in out Computation_Section);
procedure Put(obj : in Computation_Section);
procedure Put(obj : in Computation_Section_Ptr);
procedure Put_Name(obj : in Computation_Section_Ptr);
procedure Build_Attributes_XML_String(obj : in Computation_Section; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Computation_Section; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Computation_Section) return Unbounded_String;
function Get_Name (obj : in Computation_Section_Ptr) return Unbounded_String;
function Copy(obj : in Computation_Section_Ptr) return Generic_Section_Ptr;
function Copy(obj : in Computation_Section) return Generic_Section_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Computation_Section'Class, Computation_Section_Ptr);


-- --------= Synchronization_Section =--------

type Synchronization_Section;
type Synchronization_Section_Ptr is access all Synchronization_Section'Class;
type Synchronization_Section is new Generic_Section with 
record
 State_List : State_Lists;
 Transition_List : Transition_Lists;
end record;

procedure Initialize(obj : in out Synchronization_Section);
procedure Put(obj : in Synchronization_Section);
procedure Put(obj : in Synchronization_Section_Ptr);
procedure Put_Name(obj : in Synchronization_Section_Ptr);
procedure Build_Attributes_XML_String(obj : in Synchronization_Section; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Synchronization_Section; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Synchronization_Section) return Unbounded_String;
function Get_Name (obj : in Synchronization_Section_Ptr) return Unbounded_String;
function Copy(obj : in Synchronization_Section_Ptr) return Generic_Section_Ptr;
function Copy(obj : in Synchronization_Section) return Generic_Section_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Synchronization_Section'Class, Synchronization_Section_Ptr);


End Sections;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with ada.strings.unbounded;
use ada.strings.unbounded;



Package Simulations is 
 
type Simulation_Type is (
	Simulation_Boolean,
	Simulation_Integer,
	Simulation_Double,
	Simulation_Random,
	Simulation_String,
	Simulation_clock,
	Simulation_Array_Boolean,
	Simulation_Array_Integer,
	Simulation_Array_Double,
	Simulation_Array_Random,
	Simulation_Array_String,
	Simulation_array_clock,
	Simulation_Time_Unit_Array_Boolean,
	Simulation_Time_Unit_Array_Integer,
	Simulation_Time_Unit_Array_Double,
	Simulation_Time_Unit_Array_String);

procedure To_Simulation_Type is
new Convert_Strings(Simulation_Type, Simulation_Boolean);
procedure To_Simulation_Type is
new Convert_Unbounded_Strings(Simulation_Type, Simulation_Boolean);
function XML_String (e : in Simulation_Type; level : in natural := 0) return Unbounded_String;
package Simulation_Type_io is new text_io.enumeration_io(Simulation_Type);
use Simulation_Type_io;


End Simulations;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with Objects;
use Objects;

with Unchecked_Deallocation;



Package Networks is 
 
type Networks_Type is (
	Bounded_Delay,
	Parametric_Delay);

procedure To_Networks_Type is
new Convert_Strings(Networks_Type, Bounded_Delay);
procedure To_Networks_Type is
new Convert_Unbounded_Strings(Networks_Type, Bounded_Delay);
function XML_String (e : in Networks_Type; level : in natural := 0) return Unbounded_String;
package Networks_Type_io is new text_io.enumeration_io(Networks_Type);
use Networks_Type_io;


-- --------= Network =--------

type Network;
type Network_Ptr is access all Network'Class;
type Network is new Generic_Object with 
record
 Network_Type : Networks_Type;
end record;

procedure Initialize(obj : in out Network);
procedure Put(obj : in Network);
procedure Put(obj : in Network_Ptr);
procedure Put_Name(obj : in Network_Ptr);
procedure Build_Attributes_XML_String(obj : in Network; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Network; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Network) return Unbounded_String;
function Get_Name (obj : in Network_Ptr) return Unbounded_String;
function Copy(obj : in Network_Ptr) return Network_Ptr;
function Copy(obj : in Network) return Network_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Network'Class, Network_Ptr);


End Networks;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with standards_io;
use standards_io;

use standards_io.natural_io;

with Indexed_Tables;

with framework_config;
use framework_config;

with Ada.Strings.Unbounded.Text_Io;
use Ada.Strings.Unbounded.Text_Io;

with Queueing_System;
use Queueing_System;

use Queueing_System.qs_io;

with Objects;
use Objects;

with Unchecked_Deallocation;



Package Buffers is 
 
type Role_type is (
	No_Role,
	Producer,
	Consumer);

procedure To_Role_type is
new Convert_Strings(Role_type, No_Role);
procedure To_Role_type is
new Convert_Unbounded_Strings(Role_type, No_Role);
function XML_String (e : in Role_type; level : in natural := 0) return Unbounded_String;
package Role_type_io is new text_io.enumeration_io(Role_type);
use Role_type_io;


-- --------= Buffer_Role =--------
 
type Buffer_Role is
record
 The_Role : Role_type;
 Size : Natural;
 Time : Natural;
end record;

type Buffer_Role_Ptr is access all Buffer_Role;

procedure Initialize(obj : out Buffer_Role);
procedure Put(obj : in Buffer_Role);
procedure Put(obj : in Buffer_Role_Ptr);
procedure Build_Attributes_XML_String(obj : in Buffer_Role; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Buffer_Role; level : in natural := 0) return Unbounded_String;

package Buffer_Roles is new Indexed_Tables(Buffer_Role, Unbounded_String, framework_config.max_tasks, 0, Put, Initialize, Put);
use Buffer_Roles;

subtype Buffer_Roles_Table is Buffer_roles.Indexed_Table;

subtype Buffer_Roles_Range is Buffer_roles.Indexed_Table_Range;


-- --------= Buffer =--------

type Buffer;
type Buffer_Ptr is access all Buffer'Class;
type Buffer is new Generic_Object with 
record
 Cpu_Name : unbounded_string;
 Address_Space_Name : unbounded_string;
 Queueing_System_Type : queueing_systems_type;
 Size : Natural;
 Roles : Buffer_Roles_Table;
 X : Natural;
 Y : Natural;
end record;

procedure Initialize(obj : in out Buffer);
procedure Put(obj : in Buffer);
procedure Put(obj : in Buffer_Ptr);
procedure Put_Name(obj : in Buffer_Ptr);
procedure Build_Attributes_XML_String(obj : in Buffer; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Buffer; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Buffer) return Unbounded_String;
function Get_Name (obj : in Buffer_Ptr) return Unbounded_String;
function Copy(obj : in Buffer_Ptr) return Buffer_Ptr;
function Copy(obj : in Buffer) return Buffer_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Buffer'Class, Buffer_Ptr);


End Buffers;

------------------------------------------------------------------------------
-- This Ada package was automatically generated by 
-- the meta CASE tool Platypus. [http://cassoulet.univ-brest.fr/mme]
-- It is strongly recommended not to update it manually since 
-- any modification of this file will be lost by subsequent code generation.
-- Please see the "platypus" directory instead,
-- it contains the Cheddar's model and its meta-model.
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff
--
-- The Cheddar project was started in 2002 by 
-- the LISyC Team, University of Western Britanny.
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of Cheddar 
-- and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
-----------------------------------------------------------------------------
-- Last update : 
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with ada.strings.unbounded;
use ada.strings.unbounded;

with unbounded_strings;
use unbounded_strings;

with standards_io;
use standards_io;

use standards_io.natural_io;

with Processors;
use Processors;

with scheduler;
use scheduler;

with Objects;
use Objects;

with Unchecked_Deallocation;



Package Address_Spaces is 
 

-- --------= Address_Space =--------

type Address_Space;
type Address_Space_Ptr is access all Address_Space'Class;
type Address_Space is new Generic_Object with 
record
 Cpu_Name : unbounded_string;
 Text_Memory_Size : Natural;
 Stack_Memory_Size : Natural;
 Data_Memory_Size : Natural;
 Heap_Memory_Size : Natural;
 Scheduler : Generic_Scheduler_Ptr;
end record;

procedure Initialize(obj : in out Address_Space);
procedure Put(obj : in Address_Space);
procedure Put(obj : in Address_Space_Ptr);
procedure Put_Name(obj : in Address_Space_Ptr);
procedure Build_Attributes_XML_String(obj : in Address_Space; level : in natural := 0; result : in out Unbounded_String);
function XML_String(obj : in Address_Space; level : in natural := 0) return Unbounded_String;
function Get_Name (obj : in Address_Space) return Unbounded_String;
function Get_Name (obj : in Address_Space_Ptr) return Unbounded_String;
function Copy(obj : in Address_Space_Ptr) return Address_Space_Ptr;
function Copy(obj : in Address_Space) return Address_Space_Ptr;
procedure Free  is new Unchecked_Deallocation
	(Address_Space'Class, Address_Space_Ptr);


End Address_Spaces;

