
--******************************************************************************
--                                                                            **
--  File:        UTILS_PI.ADS                                                 **
--  Description: Package specification of the package Utils_Pi                **
--  Revision:    1.23                                                         **
--  Date:        February 3, 2001                                             **
--  Author:      Jrme Delcourt                                              **
--  Mail:        sikander@club-internet.fr                                    **
--                                                                            **
--  Copyright (c) Jrme Delcourt, 1998, 1999, 2000, 2001                     **
--  62, rue Ngrier                                                           **
--  59800 Lille                                                               **
--  FRANCE                                                                    **
--                                                                            **
--  Permission granted to use for any purpose, provided this copyright        **
--  remains attached and unmodified.                                          **
--                                                                            **
--  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR            **
--  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED            **
--  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.       **
--                                                                            **
--******************************************************************************

WITH ModInt;              USE ModInt;
WITH File_Utils;          USE File_Utils;
WITH TEXT_IO;             USE TEXT_IO;
WITH ADA.STRINGS.UNBOUNDED;   USE ADA.STRINGS.UNBOUNDED;
WITH UStrings;            USE UStrings;
WITH Index_IO;            USE Index_IO;
WITH Index_Direct_IO;     USE Index_Direct_IO;
WITH My_Big;              USE My_Big;
                          USE My_Big.String_Conversion;
                          USE My_Big.Generic_Conversion;
                          USE My_Big.Unsigned_Number;
                          USE My_Big.Big_Unsigned_IO;
                          USE My_Big.Big_Fraction;
WITH Fraction_Direct_IO;  USE Fraction_Direct_IO;


PACKAGE Utils_Pi IS

Fract_One : CONSTANT Fraction := CreateFraction(Big_Unsigned_One, Big_Unsigned_One);

FUNCTION Convert IS NEW Mod_Number2Big_Unsigned(My_Index);

PROCEDURE Init(Inf, Sup : OUT My_Index;
               Old_ArcSin, Temp_Fract : OUT Fraction);

PROCEDURE Init(Inf : OUT My_Index; Old_ArcSin, Temp_Fract : OUT Fraction);

PROCEDURE Save(Sup : IN My_Index; Old_Result, Temp_Fract : IN Fraction);

FUNCTION Result2UString(Result : IN Fraction;
                        Nb_Digits : IN My_Index) RETURN UString;

PROCEDURE Resultat(Result : IN Fraction; BorneSup : IN My_Index);


END Utils_Pi;
