--******************************************************************************
--                                                                            **
--  File:        BNBISIIO.ADB                                                 **
--  Description: Big_Number.Big_Signed_IO package body                        **
--  Revision:    0.28 (beta version)                                          **
--  Date:        July 8, 2001                                                 **
--  Author:      Jrme Delcourt                                              **
--  Mail:        sikander@club-internet.fr                                    **
--                                                                            **
--  Copyright (c) Jrme Delcourt, 1998, 1999, 2000, 2001                     **
--  62, rue Ngrier                                                           **
--  59800 Lille                                                               **
--  FRANCE                                                                    **
--                                                                            **
--  Permission granted to use for any purpose, provided this copyright        **
--  remains attached and unmodified.                                          **
--                                                                            **
--  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR            **
--  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED            **
--  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.       **
--                                                                            **
--******************************************************************************

SEPARATE(Big_Number)

PACKAGE BODY Big_Signed_IO IS

--******************************************************************************
--******************************************************************************

PROCEDURE GET_LINE(x : OUT Big_Signed) IS
  Temp_String : UNBOUNDED_STRING;
BEGIN
  GET_LINE(Temp_String);
  x := UString2Signed(Temp_String);
END GET_LINE;

--******************************************************************************
--******************************************************************************

PROCEDURE GET_LINE(File : IN FILE_TYPE; x : OUT Big_Signed) IS
  Temp_String : UNBOUNDED_STRING;
BEGIN
  GET_LINE(File, Temp_String);
  x := UString2Signed(Temp_String);
END GET_LINE;

--******************************************************************************
--******************************************************************************

PROCEDURE PUT(x : IN Big_Signed;
              Base : IN My_Type := 10) IS
BEGIN
  PUT(Big_Signed2UString(x, Base));
END PUT;

--******************************************************************************
--******************************************************************************

PROCEDURE PUT(File : IN FILE_TYPE;
              x : IN Big_Signed;
              Base : IN My_Type := 10) IS
BEGIN
  PUT(File, Big_Signed2UString(x, Base));
END PUT;

--******************************************************************************
--******************************************************************************

PROCEDURE PUT_LINE(x : IN Big_Signed;
                   Base : IN My_Type := 10) IS
BEGIN
  PUT_LINE(Big_Signed2UString(x, Base));
END PUT_LINE;

--******************************************************************************
--******************************************************************************

PROCEDURE PUT_LINE(File : IN File_Type;
                   x : IN Big_Signed;
                   Base : IN My_Type := 10) IS
BEGIN
  PUT_LINE(File, Big_Signed2UString(x, Base));
END PUT_LINE;

--******************************************************************************
--******************************************************************************

END Big_Signed_IO;
