--******************************************************************************
--                                                                            **
--  File:        BINUMCON.ADB                                                 **
--  Description: Big_Number.Conversion package body                           **
--  Revision:    0.28 (beta version)                                          **
--  Date:        July 8, 2001                                                 **
--  Author:      Jrme Delcourt                                              **
--  Mail:        sikander@club-internet.fr                                    **
--                                                                            **
--  Copyright (c) Jrme Delcourt, 1998, 1999, 2000                           **
--  62, rue Ngrier                                                           **
--  59800 Lille                                                               **
--  FRANCE                                                                    **
--                                                                            **
--  Permission granted to use for any purpose, provided this copyright        **
--  remains attached and unmodified.                                          **
--                                                                            **
--  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR            **
--  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED            **
--  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.       **
--                                                                            **
--******************************************************************************

SEPARATE(Big_Number)

PACKAGE BODY Conversion IS

--******************************************************************************
--******************************************************************************

FUNCTION Unsigned2Signed(x : IN Big_Unsigned; Positive : IN BOOLEAN := TRUE) RETURN Big_Signed IS
  Temp : Big_Signed;
BEGIN
  Temp.Last_Significant_Digit := x.Last_Significant_Digit;
  Temp.Mantissa := x.Mantissa;
  Temp.Positive := Positive;
  RETURN Temp;
END Unsigned2Signed;

--******************************************************************************
--******************************************************************************

FUNCTION Signed2Unsigned(x : IN Big_Signed) RETURN Big_Unsigned IS
  Temp : Big_Unsigned;
BEGIN
  Temp.Last_Significant_Digit := x.Last_Significant_Digit;
  Temp.Mantissa := x.Mantissa;
  RETURN Temp;
END Signed2Unsigned;

--******************************************************************************
--******************************************************************************

FUNCTION Big_Unsigned2Long_Long_Float(x : IN Big_Unsigned)
                                      RETURN LONG_LONG_FLOAT IS
  Temp_Result : LONG_LONG_FLOAT := 0.0;
BEGIN
  FOR I IN REVERSE First_Indice..x.Last_Significant_Digit LOOP
    Temp_Result := Temp_Result * LLF_Base + LONG_LONG_FLOAT(x.Mantissa(I));
  END LOOP;
  RETURN Temp_Result;
END Big_Unsigned2Long_Long_Float;

--******************************************************************************
--******************************************************************************

FUNCTION Big_Signed2Long_Long_Float(x : IN Big_Signed) RETURN LONG_LONG_FLOAT IS
  Temp_Result : LONG_LONG_FLOAT := 0.0;
BEGIN
  FOR I IN REVERSE First_Indice..x.Last_Significant_Digit LOOP
    Temp_Result := Temp_Result * LLF_Base + LONG_LONG_FLOAT(x.Mantissa(I));
  END LOOP;
  IF (x.Positive = FALSE) THEN
    Temp_Result := -Temp_Result;
  END IF;
  RETURN Temp_Result;
END Big_Signed2Long_Long_Float;

--******************************************************************************
--******************************************************************************

END Conversion;
