--******************************************************************************
--                                                                            **
--  File:        BIGNUMBE.ADB                                                 **
--  Description: Big_Number package body                                      **
--  Revision:    0.28 (beta version)                                          **
--  Date:        July 8, 2001                                                 **
--  Author:      Jrme Delcourt                                              **
--  Mail:        sikander@club-internet.fr                                    **
--                                                                            **
--  Copyright (c) Jrme Delcourt, 1998, 1999, 2000, 2001                     **
--  62, rue Ngrier                                                           **
--  59800 Lille                                                               **
--  FRANCE                                                                    **
--                                                                            **
--  Permission granted to use for any purpose, provided this copyright        **
--  remains attached and unmodified.                                          **
--                                                                            **
--  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR            **
--  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED            **
--  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.       **
--                                                                            **
--******************************************************************************

PACKAGE BODY Big_Number IS

  --****************************************************************************
  --**               Declarations of local types and constants                **
  --****************************************************************************

  ---------------------
  -- Local constants --
  ---------------------

  First_Indice : CONSTANT Index_Type := 0;
  Last_Indice : CONSTANT Index_Type := Nb_Item - 1;

  Base : CONSTANT Largest_Unsigned := 2**My_Type'SIZE;
  Base_Minus_One : CONSTANT Largest_Unsigned := Base - 1;
  LLF_Base : CONSTANT LONG_LONG_FLOAT := LONG_LONG_FLOAT(Base);
  LLF_Base_Square : CONSTANT LONG_LONG_FLOAT := LLF_Base * LLF_Base;
  Greatest_Digit : CONSTANT My_Type := My_Type'LAST;

  --****************************************************************************
  --****************************************************************************

  FUNCTION Min(x,y : IN Index_Type) RETURN Index_Type IS
  BEGIN
    IF (x < y) THEN
      RETURN x;
    ELSE
      RETURN y;
    END IF;
  END Min;

  --****************************************************************************

  FUNCTION Max(x,y : IN Index_Type) RETURN Index_Type IS
  BEGIN
    IF (x < y) THEN
      RETURN y;
    ELSE
      RETURN x;
    END IF;
  END Max;

  --****************************************************************************

  PACKAGE BODY Conversion IS SEPARATE;
  PACKAGE BODY Generic_Conversion IS SEPARATE;
  PACKAGE BODY String_Conversion IS SEPARATE;
  PACKAGE BODY Unsigned_Number IS SEPARATE;
  PACKAGE BODY Signed_Number IS SEPARATE;
  PACKAGE BODY Big_Unsigned_IO IS SEPARATE;
  PACKAGE BODY Big_Signed_IO IS SEPARATE;
  PACKAGE BODY Big_Fraction IS SEPARATE;
  PACKAGE BODY Big_Unsigned_Random IS SEPARATE;

  --****************************************************************************
  --****************************************************************************

BEGIN
  IF (My_Type_Size < 8) THEN
    TEXT_IO.PUT_LINE("The package Big_Number has been modified in a wrong way.");
    TEXT_IO.PUT_LINE("The type My_Type must have a size greater or equal to 8 bits.");
    RAISE PROGRAM_ERROR;
  END IF;
END Big_Number;
